// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/**
 * LVITEM_T is useful only for setting list view item information via Windows
 * messages LVM_SETITEM and LVM_INSERTITEM.
 */

/** @dll.struct(pack=1, auto) */
public class LVITEM_T
{
	public int	    mask;
	public int	    iItem;
	public int	    iSubItem;
	public int	    state;
	public int	    stateMask;
	public String   pszText;
	public int	    cchTextMax;
	public int	    iImage;
	public int	    lParam;
	public int	    iIndent;
}


