// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public class PRINTER_INFO_2 extends PRINTER_INFO
{
    public String     pServerName;
    public String     pPrinterName;
    public String     pShareName;
    public String     pPortName;
    public String     pDriverName;
    public String     pComment;
    public String     pLocation;
    public int        pDevMode;
    public String     pSepFile;
    public String     pPrintProcessor;
    public String     pDatatype;
    public String     pParameters;
    public int        pSecurityDescriptor;
    public int        Attributes;
    public int        Priority;
    public int        DefaultPriority;
    public int        StartTime;
    public int        UntilTime;
    public int        Status;
    public int        cJobs;
    public int        AveragePPM;


    void copyFromNative(int[] pnative, int ofs)
    {
        pServerName     = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pPrinterName    = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pShareName      = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pPortName       = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pDriverName     = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pComment        = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pLocation       = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pDevMode        = pnative[ofs++];
        pSepFile        = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pPrintProcessor = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pDatatype       = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pParameters     = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pSecurityDescriptor = pnative[ofs++];
        Attributes      = pnative[ofs++];
        Priority        = pnative[ofs++];
        DefaultPriority = pnative[ofs++];
        StartTime       = pnative[ofs++];
        UntilTime       = pnative[ofs++];
        Status          = pnative[ofs++];
        cJobs           = pnative[ofs++];
        AveragePPM      = pnative[ofs++];
    }

    int numSlots()
    {
        return 84/4;
    }
}

