// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


public class PRINTER_INFO_5 extends PRINTER_INFO
{
    public String pPrinterName;
    public String pPortName;
    public int    Attributes;
    public int    DeviceNotSelectedTimeout;
    public int    TransmissionRetryTimeout;

    void copyFromNative(int[] pnative, int ofs)
    {
        pPrinterName             = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        pPortName                = com.ms.dll.DllLib.ptrToString(pnative[ofs++]);
        Attributes               = pnative[ofs++];
        DeviceNotSelectedTimeout = pnative[ofs++];
        TransmissionRetryTimeout = pnative[ofs++];
    }

    int numSlots()
    {
        return 20/4;
    }

}



