// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/**
 * REBARBANDINFO_IE4 extends REBARBANDINFO with fields defined by IE4.
 * This class cannot be used without IE4.
 */

/** @dll.struct(pack=1, auto) */
public class REBARBANDINFO_IE4 extends REBARBANDINFO
{
    public int  cyChild;
    public int  cyMaxChild;
    public int  cyIntegral;
    public int  cxIdeal;
    public int  lParam;
    public int  cxHeader;

    public REBARBANDINFO_IE4()
    {
        // override superclass default.
        cbSize = 80;    // com.ms.dll.DllLib.sizeOf(this);
    }
}