// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/**
 * TV_INSERTSTRUCT_T corresponds to a Win32 TVINSERTSTRUCT structure.
 * This class is useful only for adding a new item to a tree view control via
 * Windows message TVM_INSERTITEM.
 */

/** @dll.struct(pack=1, auto) */
public class TV_INSERTSTRUCT_T
{
	public int      hParent;
	public int      hInsertAfter;
	public int      item_mask;
	public int      item_hItem;
	public int      item_state;
	public int      item_stateMask;
	public String   item_pszText;
	public int      item_cchTextMax;
	public int      item_iImage;
	public int      item_iSelectedImage;
	public int      item_cChildren;
	public int      item_lParam;
}
