// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winb {
    int BOLD_FONTTYPE = 0x0100,
        BAUD_075 = (0x00000001),
        BAUD_110 = (0x00000002),
        BAUD_134_5 = (0x00000004),
        BAUD_150 = (0x00000008),
        BAUD_300 = (0x00000010),
        BAUD_600 = (0x00000020),
        BAUD_1200 = (0x00000040),
        BAUD_1800 = (0x00000080),
        BAUD_2400 = (0x00000100),
        BAUD_4800 = (0x00000200),
        BAUD_7200 = (0x00000400),
        BAUD_9600 = (0x00000800),
        BAUD_14400 = (0x00001000),
        BAUD_19200 = (0x00002000),
        BAUD_38400 = (0x00004000),
        BAUD_56K = (0x00008000),
        BAUD_128K = (0x00010000),
        BAUD_115200 = (0x00020000),
        BAUD_57600 = (0x00040000),
        BAUD_USER = (0x10000000),
        BACKUP_INVALID = 0x00000000,
        BACKUP_DATA = 0x00000001,
        BACKUP_EA_DATA = 0x00000002,
        BACKUP_SECURITY_DATA = 0x00000003,
        BACKUP_ALTERNATE_DATA = 0x00000004,
        BACKUP_LINK = 0x00000005,
        BACKUP_PROPERTY_DATA = 0x00000006,
        BATTERY_FLAG_HIGH = 0x01,
        BATTERY_FLAG_LOW = 0x02,
        BATTERY_FLAG_CRITICAL = 0x04,
        BATTERY_FLAG_CHARGING = 0x08,
        BATTERY_FLAG_NO_BATTERY = 0x80,
        BATTERY_FLAG_UNKNOWN = 0xFF,
        BATTERY_PERCENTAGE_UNKNOWN = 0xFF,
        BATTERY_LIFE_UNKNOWN = 0xFFFFFFFF,
        BACKGROUND_BLUE = 0x0010,
        BACKGROUND_GREEN = 0x0020,
        BACKGROUND_RED = 0x0040,
        BACKGROUND_INTENSITY = 0x0080,
        BLACKONWHITE = 1,
        BANDINFO = 24,
        BEGIN_PATH = 4096,
        BI_RGB = 0,
        BI_RLE8 = 1,
        BI_RLE4 = 2,
        BI_BITFIELDS = 3,
        BALTIC_CHARSET = 186,
        BKMODE_LAST = 2,
        BLACK_BRUSH = 4,
        BLACK_PEN = 7,
        BS_SOLID = 0,
        BS_NULL = 1,
        BS_HOLLOW = 1,
        BS_HATCHED = 2,
        BS_PATTERN = 3,
        BS_INDEXED = 4,
        BS_DIBPATTERN = 5,
        BS_DIBPATTERNPT = 6,
        BS_PATTERN8X8 = 7,
        BS_DIBPATTERN8X8 = 8,
        BS_MONOPATTERN = 9,
        BITSPIXEL = 12,
        BLTALIGNMENT = 119,
        BDR_RAISEDOUTER = 0x0001,
        BDR_SUNKENOUTER = 0x0002,
        BDR_RAISEDINNER = 0x0004,
        BDR_SUNKENINNER = 0x0008,
        BDR_OUTER = 0x0003,
        BDR_INNER = 0x000c,
        BDR_RAISED = 0x0005,
        BDR_SUNKEN = 0x000a,
        BF_LEFT = 0x0001,
        BF_TOP = 0x0002,
        BF_RIGHT = 0x0004,
        BF_BOTTOM = 0x0008,
        BF_TOPLEFT = (0x0002|0x0001),
        BF_TOPRIGHT = (0x0002|0x0004),
        BF_BOTTOMLEFT = (0x0008|0x0001),
        BF_BOTTOMRIGHT = (0x0008|0x0004),
        BF_RECT = (0x0001|0x0002|0x0004|0x0008),
        BF_DIAGONAL = 0x0010,
        BF_DIAGONAL_ENDTOPRIGHT = (0x0010|0x0002|0x0004),
        BF_DIAGONAL_ENDTOPLEFT = (0x0010|0x0002|0x0001),
        BF_DIAGONAL_ENDBOTTOMLEFT = (0x0010|0x0008|0x0001),
        BF_DIAGONAL_ENDBOTTOMRIGHT = (0x0010|0x0008|0x0004),
        BF_MIDDLE = 0x0800,
        BF_SOFT = 0x1000,
        BF_ADJUST = 0x2000,
        BF_FLAT = 0x4000,
        BF_MONO = 0x8000,
        BSM_ALLCOMPONENTS = 0x00000000,
        BSM_VXDS = 0x00000001,
        BSM_NETDRIVER = 0x00000002,
        BSM_INSTALLABLEDRIVERS = 0x00000004,
        BSM_APPLICATIONS = 0x00000008,
        BSM_ALLDESKTOPS = 0x00000010,
        BSF_QUERY = 0x00000001,
        BSF_IGNORECURRENTTASK = 0x00000002,
        BSF_FLUSHDISK = 0x00000004,
        BSF_NOHANG = 0x00000008,
        BSF_POSTMESSAGE = 0x00000010,
        BSF_FORCEIFHUNG = 0x00000020,
        BSF_NOTIMEOUTIFNOTHUNG = 0x00000040,
        BROADCAST_QUERY_DENY = 0x424D5144,
        BS_PUSHBUTTON = 0x00000000,
        BS_DEFPUSHBUTTON = 0x00000001,
        BS_CHECKBOX = 0x00000002,
        BS_AUTOCHECKBOX = 0x00000003,
        BS_RADIOBUTTON = 0x00000004,
        BS_3STATE = 0x00000005,
        BS_AUTO3STATE = 0x00000006,
        BS_GROUPBOX = 0x00000007,
        BS_USERBUTTON = 0x00000008,
        BS_AUTORADIOBUTTON = 0x00000009,
        BS_OWNERDRAW = 0x0000000B,
        BS_LEFTTEXT = 0x00000020,
        BS_TEXT = 0x00000000,
        BS_ICON = 0x00000040,
        BS_BITMAP = 0x00000080,
        BS_LEFT = 0x00000100,
        BS_RIGHT = 0x00000200,
        BS_CENTER = 0x00000300,
        BS_TOP = 0x00000400,
        BS_BOTTOM = 0x00000800,
        BS_VCENTER = 0x00000C00,
        BS_PUSHLIKE = 0x00001000,
        BS_MULTILINE = 0x00002000,
        BS_NOTIFY = 0x00004000,
        BS_FLAT = 0x00008000,
        BS_RIGHTBUTTON = 0x00000020,
        BN_CLICKED = 0,
        BN_PAINT = 1,
        BN_HILITE = 2,
        BN_UNHILITE = 3,
        BN_DISABLE = 4,
        BN_DOUBLECLICKED = 5,
        BN_PUSHED = 2,
        BN_UNPUSHED = 3,
        BN_DBLCLK = 5,
        BN_SETFOCUS = 6,
        BN_KILLFOCUS = 7,
        BM_GETCHECK = 0x00F0,
        BM_SETCHECK = 0x00F1,
        BM_GETSTATE = 0x00F2,
        BM_SETSTATE = 0x00F3,
        BM_SETSTYLE = 0x00F4,
        BM_CLICK = 0x00F5,
        BM_GETIMAGE = 0x00F6,
        BM_SETIMAGE = 0x00F7,
        BST_UNCHECKED = 0x0000,
        BST_CHECKED = 0x0001,
        BST_INDETERMINATE = 0x0002,
        BST_PUSHED = 0x0004,
        BST_FOCUS = 0x0008,
        BLACKNESS = 0x00000042;

    int BIND_MAYBOTHERUSER      = 1,
        BIND_JUSTTESTEXISTENCE  = 2;
}
