// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface wind {
	int DN_DEFAULTPRN = 0x0001,
		DDE_FACK = 0x8000,
		DDE_FBUSY = 0x4000,
		DDE_FDEFERUPD = 0x4000,
		DDE_FACKREQ = 0x8000,
		DDE_FRELEASE = 0x2000,
		DDE_FREQUESTED = 0x1000,
		DDE_FAPPSTATUS = 0x00ff,
		DDE_FNOTPROCESSED = 0x0000,
		DDE_FACKRESERVED = (~(0x8000|0x4000|0x00ff)),
		DDE_FADVRESERVED = (~(0x8000|0x4000)),
		DDE_FDATRESERVED = (~(0x8000|0x2000|0x1000)),
		DDE_FPOKRESERVED = (~(0x2000)),
		DNS_REGISTER = 0x0001,
		DNS_UNREGISTER = 0x0002,
		DNS_FILTERON = 0x0004,
		DNS_FILTEROFF = 0x0008,
		DMLERR_NO_ERROR = 0,
		DMLERR_FIRST = 0x4000,
		DMLERR_ADVACKTIMEOUT = 0x4000,
		DMLERR_BUSY = 0x4001,
		DMLERR_DATAACKTIMEOUT = 0x4002,
		DMLERR_DLL_NOT_INITIALIZED = 0x4003,
		DMLERR_DLL_USAGE = 0x4004,
		DMLERR_EXECACKTIMEOUT = 0x4005,
		DMLERR_INVALIDPARAMETER = 0x4006,
		DMLERR_LOW_MEMORY = 0x4007,
		DMLERR_MEMORY_ERROR = 0x4008,
		DMLERR_NOTPROCESSED = 0x4009,
		DMLERR_NO_CONV_ESTABLISHED = 0x400a,
		DMLERR_POKEACKTIMEOUT = 0x400b,
		DMLERR_POSTMSG_FAILED = 0x400c,
		DMLERR_REENTRANCY = 0x400d,
		DMLERR_SERVER_DIED = 0x400e,
		DMLERR_SYS_ERROR = 0x400f,
		DMLERR_UNADVACKTIMEOUT = 0x4010,
		DMLERR_UNFOUND_QUEUE_ID = 0x4011,
		DMLERR_LAST = 0x4011,
		DIALOPTION_BILLING = 0x00000040,
		DIALOPTION_QUIET = 0x00000080,
		DIALOPTION_DIALTONE = 0x00000100,
		DRV_LOAD = 0x0001,
		DRV_ENABLE = 0x0002,
		DRV_OPEN = 0x0003,
		DRV_CLOSE = 0x0004,
		DRV_DISABLE = 0x0005,
		DRV_FREE = 0x0006,
		DRV_CONFIGURE = 0x0007,
		DRV_QUERYCONFIGURE = 0x0008,
		DRV_INSTALL = 0x0009,
		DRV_REMOVE = 0x000A,
		DRV_EXITSESSION = 0x000B,
		DRV_POWER = 0x000F,
		DRV_RESERVED = 0x0800,
		DRV_USER = 0x4000,
		DRVCNF_CANCEL = 0x0000,
		DRVCNF_OK = 0x0001,
		DRVCNF_RESTART = 0x0002,
		DRV_CANCEL = 0x0000,
		DRV_OK = 0x0001,
		DRV_RESTART = 0x0002,
		DRV_MCI_FIRST = 0x0800,
		DRV_MCI_LAST = (0x0800+0xFFF),
		DEREGISTERED = 0x05,
		DUPLICATE = 0x06,
		DUPLICATE_DEREG = 0x07,
		DISPID_UNKNOWN = (-1),
		DISPID_VALUE = (0),
		DISPID_PROPERTYPUT = (-3),
		DISPID_NEWENUM = (-4),
		DISPID_EVALUATE = (-5),
		DISPID_DESTRUCTOR = (-7),
		DISPID_COLLECT = (-8),
		DISPATCH_METHOD = 0x1,
		DISPATCH_PROPERTYGET = 0x2,
		DISPATCH_PROPERTYPUT = 0x4,
		DISPATCH_PROPERTYPUTREF = 0x8,
		DROPEFFECT_NONE = (0),
		DROPEFFECT_COPY = (1),
		DROPEFFECT_MOVE = (2),
		DROPEFFECT_LINK = (4),
		DROPEFFECT_SCROLL = (0x80000000),
		DD_DEFSCROLLINSET = (11),
		DD_DEFSCROLLDELAY = (50),
		DD_DEFSCROLLINTERVAL = (50),
		DD_DEFDRAGDELAY = (200),
		DD_DEFDRAGMINDIST = (2),
		DCE_C_ERROR_STRING_LEN = 256,
		DATABITS_5 = (0x0001),
		DATABITS_6 = (0x0002),
		DATABITS_7 = (0x0004),
		DATABITS_8 = (0x0008),
		DATABITS_16 = (0x0010),
		DATABITS_16X = (0x0020),
		DTR_CONTROL_DISABLE = 0x00,
		DTR_CONTROL_ENABLE = 0x01,
		DTR_CONTROL_HANDSHAKE = 0x02,
		DEBUG_PROCESS = 0x00000001,
		DEBUG_ONLY_THIS_PROCESS = 0x00000002,
		DETACHED_PROCESS = 0x00000008,
		DRIVE_UNKNOWN = 0,
		DRIVE_NO_ROOT_DIR = 1,
		DRIVE_REMOVABLE = 2,
		DRIVE_FIXED = 3,
		DRIVE_REMOTE = 4,
		DRIVE_CDROM = 5,
		DRIVE_RAMDISK = 6,
		DONT_RESOLVE_DLL_REFERENCES = 0x00000001,
		DDD_RAW_TARGET_PATH = 0x00000001,
		DDD_REMOVE_DEFINITION = 0x00000002,
		DDD_EXACT_MATCH_ON_REMOVE = 0x00000004,
		DDD_NO_BROADCAST_SYSTEM = 0x00000008,
		DOCKINFO_UNDOCKED = (0x1),
		DOCKINFO_DOCKED = (0x2),
		DOCKINFO_USER_SUPPLIED = (0x4),
		DOCKINFO_USER_UNDOCKED = ((0x4)|(0x1)),
		DOCKINFO_USER_DOCKED = ((0x4)|(0x2)),
		DOUBLE_CLICK = 0x0002,
		DM_UPDATE = 1,
		DM_COPY = 2,
		DM_PROMPT = 4,
		DM_MODIFY = 8,
		DM_IN_BUFFER = 8,
		DM_IN_PROMPT = 4,
		DM_OUT_BUFFER = 2,
		DM_OUT_DEFAULT = 1,
		DC_FIELDS = 1,
		DC_PAPERS = 2,
		DC_PAPERSIZE = 3,
		DC_MINEXTENT = 4,
		DC_MAXEXTENT = 5,
		DC_BINS = 6,
		DC_DUPLEX = 7,
		DC_SIZE = 8,
		DC_EXTRA = 9,
		DC_VERSION = 10,
		DC_DRIVER = 11,
		DC_BINNAMES = 12,
		DC_ENUMRESOLUTIONS = 13,
		DC_FILEDEPENDENCIES = 14,
		DC_TRUETYPE = 15,
		DC_PAPERNAMES = 16,
		DC_ORIENTATION = 17,
		DC_COPIES = 18,
		DV_E_FORMATETC = 0x80040064,
		DV_E_DVTARGETDEVICE = 0x80040065,
		DV_E_STGMEDIUM = 0x80040066,
		DV_E_STATDATA = 0x80040067,
		DV_E_LINDEX = 0x80040068,
		DV_E_TYMED = 0x80040069,
		DV_E_CLIPFORMAT = 0x8004006A,
		DV_E_DVASPECT = 0x8004006B,
		DV_E_DVTARGETDEVICE_SIZE = 0x8004006C,
		DV_E_NOIVIEWOBJECT = 0x8004006D,
		DRAGDROP_E_FIRST = 0x80040100,
		DRAGDROP_E_LAST = 0x8004010F,
		DRAGDROP_S_FIRST = 0x00040100,
		DRAGDROP_S_LAST = 0x0004010F,
		DRAGDROP_E_NOTREGISTERED = 0x80040100,
		DRAGDROP_E_ALREADYREGISTERED = 0x80040101,
		DRAGDROP_E_INVALIDHWND = 0x80040102,
		DATA_E_FIRST = 0x80040130,
		DATA_E_LAST = 0x8004013F,
		DATA_S_FIRST = 0x00040130,
		DATA_S_LAST = 0x0004013F,
		DRAGDROP_S_DROP = 0x00040100,
		DRAGDROP_S_CANCEL = 0x00040101,
		DRAGDROP_S_USEDEFAULTCURSORS = 0x00040102,
		DATA_S_SAMEFORMATETC = 0x00040130,
		DISP_E_UNKNOWNINTERFACE = 0x80020001,
		DISP_E_MEMBERNOTFOUND = 0x80020003,
		DISP_E_PARAMNOTFOUND = 0x80020004,
		DISP_E_TYPEMISMATCH = 0x80020005,
		DISP_E_UNKNOWNNAME = 0x80020006,
		DISP_E_NONAMEDARGS = 0x80020007,
		DISP_E_BADVARTYPE = 0x80020008,
		DISP_E_EXCEPTION = 0x80020009,
		DISP_E_OVERFLOW = 0x8002000A,
		DISP_E_BADINDEX = 0x8002000B,
		DISP_E_UNKNOWNLCID = 0x8002000C,
		DISP_E_ARRAYISLOCKED = 0x8002000D,
		DISP_E_BADPARAMCOUNT = 0x8002000E,
		DISP_E_PARAMNOTOPTIONAL = 0x8002000F,
		DISP_E_BADCALLEE = 0x80020010,
		DISP_E_NOTACOLLECTION = 0x80020011,
		DIGSIG_E_ENCODE = 0x800B0005,
		DIGSIG_E_DECODE = 0x800B0006,
		DIGSIG_E_EXTENSIBILITY = 0x800B0007,
		DIGSIG_E_CRYPTO = 0x800B0008,
		DCB_RESET = 0x0001,
		DCB_ACCUMULATE = 0x0002,
		DCB_DIRTY = 0x0002,
		DCB_SET = (0x0001|0x0002),
		DCB_ENABLE = 0x0004,
		DCB_DISABLE = 0x0008,
		DRAFTMODE = 7,
		DEVICEDATA = 19,
		DRAWPATTERNRECT = 25,
		DOWNLOADFACE = 514,
		DOWNLOADHEADER = 4111,
		DEFAULT_QUALITY = 0,
		DRAFT_QUALITY = 1,
		DEFAULT_PITCH = 0,
		DEFAULT_CHARSET = 1,
		DEVICE_FONTTYPE = 0x002,
		DKGRAY_BRUSH = 3,
		DEVICE_DEFAULT_FONT = 14,
		DEFAULT_PALETTE = 15,
		DEFAULT_GUI_FONT = 17,
		DRIVERVERSION = 0,
		DESKTOPVERTRES = 117,
		DESKTOPHORZRES = 118,
		DT_PLOTTER = 0,
		DT_RASDISPLAY = 1,
		DT_RASPRINTER = 2,
		DT_RASCAMERA = 3,
		DT_CHARSTREAM = 4,
		DT_METAFILE = 5,
		DT_DISPFILE = 6,
		DIB_RGB_COLORS = 0,
		DIB_PAL_COLORS = 1,
		DM_SPECVERSION = 0x0401,
		DM_ORIENTATION = 0x00000001,
		DM_PAPERSIZE = 0x00000002,
		DM_PAPERLENGTH = 0x00000004,
		DM_PAPERWIDTH = 0x00000008,
		DM_SCALE = 0x00000010,
		DM_COPIES = 0x00000100,
		DM_DEFAULTSOURCE = 0x00000200,
		DM_PRINTQUALITY = 0x00000400,
		DM_COLOR = 0x00000800,
		DM_DUPLEX = 0x00001000,
		DM_YRESOLUTION = 0x00002000,
		DM_TTOPTION = 0x00004000,
		DM_COLLATE = 0x00008000,
		DM_FORMNAME = 0x00010000,
		DM_LOGPIXELS = 0x00020000,
		DM_BITSPERPEL = 0x00040000,
		DM_PELSWIDTH = 0x00080000,
		DM_PELSHEIGHT = 0x00100000,
		DM_DISPLAYFLAGS = 0x00200000,
		DM_DISPLAYFREQUENCY = 0x00400000,
		DM_PANNINGWIDTH = 0x00800000,
		DM_PANNINGHEIGHT = 0x01000000,
		DM_ICMMETHOD = 0x02000000,
		DM_ICMINTENT = 0x04000000,
		DM_MEDIATYPE = 0x08000000,
		DM_DITHERTYPE = 0x10000000,
		DM_ICCMANUFACTURER = 0x20000000,
		DM_ICCMODEL = 0x40000000,
		DMORIENT_PORTRAIT = 1,
		DMORIENT_LANDSCAPE = 2,
		DMPAPER_LETTER = 1,
		DMPAPER_LETTERSMALL = 2,
		DMPAPER_TABLOID = 3,
		DMPAPER_LEDGER = 4,
		DMPAPER_LEGAL = 5,
		DMPAPER_STATEMENT = 6,
		DMPAPER_EXECUTIVE = 7,
		DMPAPER_A3 = 8,
		DMPAPER_A4 = 9,
		DMPAPER_A4SMALL = 10,
		DMPAPER_A5 = 11,
		DMPAPER_B4 = 12,
		DMPAPER_B5 = 13,
		DMPAPER_FOLIO = 14,
		DMPAPER_QUARTO = 15,
		DMPAPER_10X14 = 16,
		DMPAPER_11X17 = 17,
		DMPAPER_NOTE = 18,
		DMPAPER_ENV_9 = 19,
		DMPAPER_ENV_10 = 20,
		DMPAPER_ENV_11 = 21,
		DMPAPER_ENV_12 = 22,
		DMPAPER_ENV_14 = 23,
		DMPAPER_CSHEET = 24,
		DMPAPER_DSHEET = 25,
		DMPAPER_ESHEET = 26,
		DMPAPER_ENV_DL = 27,
		DMPAPER_ENV_C5 = 28,
		DMPAPER_ENV_C3 = 29,
		DMPAPER_ENV_C4 = 30,
		DMPAPER_ENV_C6 = 31,
		DMPAPER_ENV_C65 = 32,
		DMPAPER_ENV_B4 = 33,
		DMPAPER_ENV_B5 = 34,
		DMPAPER_ENV_B6 = 35,
		DMPAPER_ENV_ITALY = 36,
		DMPAPER_ENV_MONARCH = 37,
		DMPAPER_ENV_PERSONAL = 38,
		DMPAPER_FANFOLD_US = 39,
		DMPAPER_FANFOLD_STD_GERMAN = 40,
		DMPAPER_FANFOLD_LGL_GERMAN = 41,
		DMPAPER_ISO_B4 = 42,
		DMPAPER_JAPANESE_POSTCARD = 43,
		DMPAPER_9X11 = 44,
		DMPAPER_10X11 = 45,
		DMPAPER_15X11 = 46,
		DMPAPER_ENV_INVITE = 47,
		DMPAPER_RESERVED_48 = 48,
		DMPAPER_RESERVED_49 = 49,
		DMPAPER_LETTER_EXTRA = 50,
		DMPAPER_LEGAL_EXTRA = 51,
		DMPAPER_TABLOID_EXTRA = 52,
		DMPAPER_A4_EXTRA = 53,
		DMPAPER_LETTER_TRANSVERSE = 54,
		DMPAPER_A4_TRANSVERSE = 55,
		DMPAPER_LETTER_EXTRA_TRANSVERSE = 56,
		DMPAPER_A_PLUS = 57,
		DMPAPER_B_PLUS = 58,
		DMPAPER_LETTER_PLUS = 59,
		DMPAPER_A4_PLUS = 60,
		DMPAPER_A5_TRANSVERSE = 61,
		DMPAPER_B5_TRANSVERSE = 62,
		DMPAPER_A3_EXTRA = 63,
		DMPAPER_A5_EXTRA = 64,
		DMPAPER_B5_EXTRA = 65,
		DMPAPER_A2 = 66,
		DMPAPER_A3_TRANSVERSE = 67,
		DMPAPER_A3_EXTRA_TRANSVERSE = 68,
		DMPAPER_LAST = 68;
	// DMPAPER_LAST = 41;
	int DMPAPER_USER = 256,
		DMBIN_UPPER = 1,
		DMBIN_ONLYONE = 1,
		DMBIN_LOWER = 2,
		DMBIN_MIDDLE = 3,
		DMBIN_MANUAL = 4,
		DMBIN_ENVELOPE = 5,
		DMBIN_ENVMANUAL = 6,
		DMBIN_AUTO = 7,
		DMBIN_TRACTOR = 8,
		DMBIN_SMALLFMT = 9,
		DMBIN_LARGEFMT = 10,
		DMBIN_LARGECAPACITY = 11,
		DMBIN_CASSETTE = 14,
		DMBIN_FORMSOURCE = 15,
		DMBIN_LAST = 15,
		DMBIN_USER = 256,
		DMRES_DRAFT = (-1),
		DMRES_LOW = (-2),
		DMRES_MEDIUM = (-3),
		DMRES_HIGH = (-4),
		DMCOLOR_MONOCHROME = 1,
		DMCOLOR_COLOR = 2,
		DMDUP_SIMPLEX = 1,
		DMDUP_VERTICAL = 2,
		DMDUP_HORIZONTAL = 3,
		DMTT_BITMAP = 1,
		DMTT_DOWNLOAD = 2,
		DMTT_SUBDEV = 3,
		DMTT_DOWNLOAD_OUTLINE = 4,
		DMCOLLATE_FALSE = 0,
		DMCOLLATE_TRUE = 1,
		DMDISPLAYFLAGS_TEXTMODE = 0x00000004,
		DMICMMETHOD_NONE = 1,
		DMICMMETHOD_SYSTEM = 2,
		DMICMMETHOD_DRIVER = 3,
		DMICMMETHOD_DEVICE = 4,
		DMICMMETHOD_USER = 256,
		DMICM_SATURATE = 1,
		DMICM_CONTRAST = 2,
		DMICM_COLORMETRIC = 3,
		DMICM_USER = 256,
		DMMEDIA_STANDARD = 1,
		DMMEDIA_TRANSPARENCY = 2,
		DMMEDIA_GLOSSY = 3,
		DMMEDIA_USER = 256,
		DMDITHER_NONE = 1,
		DMDITHER_COARSE = 2,
		DMDITHER_FINE = 3,
		DMDITHER_LINEART = 4,
		DMDITHER_GRAYSCALE = 5,
		DMDITHER_USER = 256,
		DC_BINADJUST = 19,
		DC_EMF_COMPLIANT = 20,
		DC_DATATYPE_PRODUCED = 21,
		DC_COLLATE = 22,
		DCTT_BITMAP = 0x0000001,
		DCTT_DOWNLOAD = 0x0000002,
		DCTT_SUBDEV = 0x0000004,
		DCTT_DOWNLOAD_OUTLINE = 0x0000008,
		DCBA_FACEUPNONE = 0x0000,
		DCBA_FACEUPCENTER = 0x0001,
		DCBA_FACEUPLEFT = 0x0002,
		DCBA_FACEUPRIGHT = 0x0003,
		DCBA_FACEDOWNNONE = 0x0100,
		DCBA_FACEDOWNCENTER = 0x0101,
		DCBA_FACEDOWNLEFT = 0x0102,
		DCBA_FACEDOWNRIGHT = 0x0103,
		DI_APPBANDING = 0x0001,
		DISC_UPDATE_PROFILE = 0x00000001,
		DISC_NO_FORCE = 0x00000040,
		DATE_SHORTDATE = 0x00000001,
		DATE_LONGDATE = 0x00000002,
		DATE_USE_ALT_CALENDAR = 0x00000004,
		DUPLICATE_CLOSE_SOURCE = 0x00000001,
		DUPLICATE_SAME_ACCESS = 0x00000002,
		DELETE = (0x00010000),
		DOMAIN_USER_RID_ADMIN = (0x000001F4),
		DOMAIN_USER_RID_GUEST = (0x000001F5),
		DOMAIN_GROUP_RID_ADMINS = (0x00000200),
		DOMAIN_GROUP_RID_USERS = (0x00000201),
		DOMAIN_GROUP_RID_GUESTS = (0x00000202),
		DOMAIN_ALIAS_RID_ADMINS = (0x00000220),
		DOMAIN_ALIAS_RID_USERS = (0x00000221),
		DOMAIN_ALIAS_RID_GUESTS = (0x00000222),
		DOMAIN_ALIAS_RID_POWER_USERS = (0x00000223),
		DOMAIN_ALIAS_RID_ACCOUNT_OPS = (0x00000224),
		DOMAIN_ALIAS_RID_SYSTEM_OPS = (0x00000225),
		DOMAIN_ALIAS_RID_PRINT_OPS = (0x00000226),
		DOMAIN_ALIAS_RID_BACKUP_OPS = (0x00000227),
		DOMAIN_ALIAS_RID_REPLICATOR = (0x00000228),
		DACL_SECURITY_INFORMATION = (0X00000004),
		DLL_PROCESS_ATTACH = 1,
		DLL_THREAD_ATTACH = 2,
		DLL_THREAD_DETACH = 3,
		DLL_PROCESS_DETACH = 0,
		DBG_CONTINUE = (0x00010002),
		DBG_TERMINATE_THREAD = (0x40010003),
		DBG_TERMINATE_PROCESS = (0x40010004),
		DBG_CONTROL_C = (0x40010005),
		DBG_CONTROL_BREAK = (0x40010008),
		DBG_EXCEPTION_NOT_HANDLED = (0x80010001),
		DEF_PRIORITY = 1,
		DI_CHANNEL = 1,
		DI_READ_SPOOL_JOB = 3,
		DIFFERENCE = 11,
		DESKTOP_READOBJECTS = 0x0001,
		DESKTOP_CREATEWINDOW = 0x0002,
		DESKTOP_CREATEMENU = 0x0004,
		DESKTOP_HOOKCONTROL = 0x0008,
		DESKTOP_JOURNALRECORD = 0x0010,
		DESKTOP_JOURNALPLAYBACK = 0x0020,
		DESKTOP_ENUMERATE = 0x0040,
		DESKTOP_WRITEOBJECTS = 0x0080,
		DESKTOP_SWITCHDESKTOP = 0x0100,
		DF_ALLOWOTHERACCOUNTHOOK = 0x0001,
		DFC_CAPTION = 1,
		DFC_MENU = 2,
		DFC_SCROLL = 3,
		DFC_BUTTON = 4,
		DFCS_CAPTIONCLOSE = 0x0000,
		DFCS_CAPTIONMIN = 0x0001,
		DFCS_CAPTIONMAX = 0x0002,
		DFCS_CAPTIONRESTORE = 0x0003,
		DFCS_CAPTIONHELP = 0x0004,
		DFCS_MENUARROW = 0x0000,
		DFCS_MENUCHECK = 0x0001,
		DFCS_MENUBULLET = 0x0002,
		DFCS_MENUARROWRIGHT = 0x0004,
		DFCS_SCROLLUP = 0x0000,
		DFCS_SCROLLDOWN = 0x0001,
		DFCS_SCROLLLEFT = 0x0002,
		DFCS_SCROLLRIGHT = 0x0003,
		DFCS_SCROLLCOMBOBOX = 0x0005,
		DFCS_SCROLLSIZEGRIP = 0x0008,
		DFCS_SCROLLSIZEGRIPRIGHT = 0x0010,
		DFCS_BUTTONCHECK = 0x0000,
		DFCS_BUTTONRADIOIMAGE = 0x0001,
		DFCS_BUTTONRADIOMASK = 0x0002,
		DFCS_BUTTONRADIO = 0x0004,
		DFCS_BUTTON3STATE = 0x0008,
		DFCS_BUTTONPUSH = 0x0010,
		DFCS_INACTIVE = 0x0100,
		DFCS_PUSHED = 0x0200,
		DFCS_CHECKED = 0x0400,
		DFCS_ADJUSTRECT = 0x2000,
		DFCS_FLAT = 0x4000,
		DFCS_MONO = 0x8000,
		DC_ACTIVE = 0x0001,
		DC_SMALLCAP = 0x0002,
		DC_ICON = 0x0004,
		DC_TEXT = 0x0008,
		DC_INBUTTON = 0x0010,
		DLGWINDOWEXTRA = 30,
		DOF_EXECUTABLE = 0x8001,
		DOF_DOCUMENT = 0x8002,
		DOF_DIRECTORY = 0x8003,
		DOF_MULTIPLE = 0x8004,
		DOF_PROGMAN = 0x0001,
		DOF_SHELLDATA = 0x0002,
		DO_DROPFILE = 0x454C4946,
		DO_PRINTFILE = 0x544E5250,
		DT_TOP = 0x00000000,
		DT_LEFT = 0x00000000,
		DT_CENTER = 0x00000001,
		DT_RIGHT = 0x00000002,
		DT_VCENTER = 0x00000004,
		DT_BOTTOM = 0x00000008,
		DT_WORDBREAK = 0x00000010,
		DT_SINGLELINE = 0x00000020,
		DT_EXPANDTABS = 0x00000040,
		DT_TABSTOP = 0x00000080,
		DT_NOCLIP = 0x00000100,
		DT_CALCRECT = 0x00000400,
		DT_NOPREFIX = 0x00000800,
		DT_INTERNAL = 0x00001000,
		DT_EDITCONTROL = 0x00002000,
		DT_PATH_ELLIPSIS = 0x00004000,
		DT_END_ELLIPSIS = 0x00008000,
		DT_MODIFYSTRING = 0x00010000,
		DT_RTLREADING = 0x00020000,
		DT_WORD_ELLIPSIS = 0x00040000,
		DST_COMPLEX = 0x0000,
		DST_TEXT = 0x0001,
		DST_PREFIXTEXT = 0x0002,
		DST_ICON = 0x0003,
		DST_BITMAP = 0x0004,
		DSS_NORMAL = 0x0000,
		DSS_UNION = 0x0010,
		DSS_DISABLED = 0x0020,
		DSS_MONO = 0x0080,
		DSS_RIGHT = 0x8000,
		DCX_WINDOW = 0x00000001,
		DCX_CACHE = 0x00000002,
		DCX_NORESETATTRS = 0x00000004,
		DCX_CLIPCHILDREN = 0x00000008,
		DCX_CLIPSIBLINGS = 0x00000010,
		DCX_PARENTCLIP = 0x00000020,
		DCX_EXCLUDERGN = 0x00000040,
		DCX_INTERSECTRGN = 0x00000080,
		DCX_EXCLUDEUPDATE = 0x00000100,
		DCX_INTERSECTUPDATE = 0x00000200,
		DCX_LOCKWINDOWUPDATE = 0x00000400,
		DCX_VALIDATE = 0x00200000,
		DI_MASK = 0x0001,
		DI_IMAGE = 0x0002,
		DI_NORMAL = 0x0003,
		DI_COMPAT = 0x0004,
		DI_DEFAULTSIZE = 0x0008,
		DWL_MSGRESULT = 0,
		DWL_DLGPROC = 4,
		DWL_USER = 8,
		DDL_READWRITE = 0x0000,
		DDL_READONLY = 0x0001,
		DDL_HIDDEN = 0x0002,
		DDL_SYSTEM = 0x0004,
		DDL_DIRECTORY = 0x0010,
		DDL_ARCHIVE = 0x0020,
		DDL_POSTMSGS = 0x2000,
		DDL_DRIVES = 0x4000,
		DDL_EXCLUSIVE = 0x8000,
		DS_ABSALIGN = 0x01,
		DS_SYSMODAL = 0x02,
		DS_LOCALEDIT = 0x20,
		DS_SETFONT = 0x40,
		DS_MODALFRAME = 0x80,
		DS_NOIDLEMSG = 0x100,
		DS_SETFOREGROUND = 0x200,
		DS_3DLOOK = 0x0004,
		DS_FIXEDSYS = 0x0008,
		DS_NOFAILCREATE = 0x0010,
		DS_CONTROL = 0x0400,
		DS_CENTER = 0x0800,
		DS_CENTERMOUSE = 0x1000,
		DS_CONTEXTHELP = 0x2000,
		DM_GETDEFID = (0x0400+0),
		DM_SETDEFID = (0x0400+1),
		DM_REPOSITION = (0x0400+2),
		DC_HASDEFID = 0x534B,
		DLGC_WANTARROWS = 0x0001,
		DLGC_WANTTAB = 0x0002,
		DLGC_WANTALLKEYS = 0x0004,
		DLGC_WANTMESSAGE = 0x0004,
		DLGC_HASSETSEL = 0x0008,
		DLGC_DEFPUSHBUTTON = 0x0010,
		DLGC_UNDEFPUSHBUTTON = 0x0020,
		DLGC_RADIOBUTTON = 0x0040,
		DLGC_WANTCHARS = 0x0080,
		DLGC_STATIC = 0x0100,
		DLGC_BUTTON = 0x2000,
		DISP_CHANGE_SUCCESSFUL = 0,
		DISP_CHANGE_RESTART = 1,
		DISP_CHANGE_FAILED = -1,
		DISP_CHANGE_BADMODE = -2,
		DISP_CHANGE_NOTUPDATED = -3,
		DISP_CHANGE_BADFLAGS = -4,
		DISP_CHANGE_BADPARAM = -5,
		DECIMAL_NEG = (0x80),
		DTN_FIRST = (0-760),
		DTN_LAST = (0-799),
		DL_BEGINDRAG = (0x0400+133),
		DL_DRAGGING = (0x0400+134),
		DL_DROPPED = (0x0400+135),
		DL_CANCELDRAG = (0x0400+136),
		DL_CURSORSET = 0,
		DL_STOPCURSOR = 1,
		DL_COPYCURSOR = 2,
		DL_MOVECURSOR = 3,
		DTM_FIRST = 0x1000,
		DTM_GETSYSTEMTIME = (0x1000+1),
		DTM_SETSYSTEMTIME = (0x1000+2),
		DTM_GETRANGE = (0x1000+3),
		DTM_SETRANGE = (0x1000+4),
		DTM_SETFORMATA = (0x1000+5),
		DTM_SETFORMATW = (0x1000+50),
		DTM_SETMCCOLOR = (0x1000+6),
		DTM_GETMCCOLOR = (0x1000+7),
		DTM_GETMONTHCAL = (0x1000+8),
		DTM_SETMCFONT = (0x1000+9),
		DTM_GETMCFONT = (0x1000+10),
		DTS_UPDOWN = 0x0001,
		DTS_SHOWNONE = 0x0002,
		DTS_SHORTDATEFORMAT = 0x0000,
		DTS_LONGDATEFORMAT = 0x0004,
		DTS_TIMEFORMAT = 0x0009,
		DTS_APPCANPARSE = 0x0010,
		DTS_RIGHTALIGN = 0x0020,
		DTN_DATETIMECHANGE = ((0-760)+1),
		DTN_USERSTRINGA = ((0-760)+2),
		DTN_USERSTRINGW = ((0-760)+15),
		DTN_WMKEYDOWNA = ((0-760)+3),
		DTN_WMKEYDOWNW = ((0-760)+16),
		DTN_FORMATA = ((0-760)+4),
		DTN_FORMATW = ((0-760)+17),
		DTN_FORMATQUERYA = ((0-760)+5),
		DTN_FORMATQUERYW = ((0-760)+18),
		DTN_DROPDOWN = ((0-760)+6),
		DTN_CLOSEUP = ((0-760)+7),
		DATA_E_FORMATETC = 0x80040064,
		DMPAPER_FIRST = 1,
		DMBIN_FIRST = 1,
        DSTINVERT = 0x00550009;
}
