// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winf {
	int FNERR_FILENAMECODES = 0x3000,
		FNERR_SUBCLASSFAILURE = 0x3001,
		FNERR_INVALIDFILENAME = 0x3002,
		FNERR_BUFFERTOOSMALL = 0x3003,
		FRERR_FINDREPLACECODES = 0x4000,
		FRERR_BUFFERLENGTHZERO = 0x4001,
		FR_DOWN = 0x00000001,
		FR_WHOLEWORD = 0x00000002,
		FR_MATCHCASE = 0x00000004,
		FR_FINDNEXT = 0x00000008,
		FR_REPLACE = 0x00000010,
		FR_REPLACEALL = 0x00000020,
		FR_DIALOGTERM = 0x00000040,
		FR_SHOWHELP = 0x00000080,
		FR_ENABLEHOOK = 0x00000100,
		FR_ENABLETEMPLATE = 0x00000200,
		FR_NOUPDOWN = 0x00000400,
		FR_NOMATCHCASE = 0x00000800,
		FR_NOWHOLEWORD = 0x00001000,
		FR_ENABLETEMPLATEHANDLE = 0x00002000,
		FR_HIDEUPDOWN = 0x00004000,
		FR_HIDEMATCHCASE = 0x00008000,
		FR_HIDEWHOLEWORD = 0x00010000;
	boolean FALSE = false;
	int frm1 = 0x0434,
		frm2 = 0x0435,
		frm3 = 0x0436,
		frm4 = 0x0437,
		FILEOPENORD = 1536,
		FINDDLGORD = 1540,
		FONTDLGORD = 1542,
		FORMATDLGORD31 = 1543,
		FORMATDLGORD30 = 1544,
		FADF_AUTO = (0x1),
		FADF_STATIC = (0x2),
		FADF_EMBEDDED = (0x4),
		FADF_FIXEDSIZE = (0x10),
		FADF_BSTR = (0x100),
		FADF_UNKNOWN = (0x200),
		FADF_DISPATCH = (0x400),
		FADF_VARIANT = (0x800),
		FADF_RESERVED = (0xf0e8),
		FO_MOVE = 0x0001,
		FO_COPY = 0x0002,
		FO_DELETE = 0x0003,
		FO_RENAME = 0x0004,
		FOF_MULTIDESTFILES = 0x0001,
		FOF_CONFIRMMOUSE = 0x0002,
		FOF_SILENT = 0x0004,
		FOF_RENAMEONCOLLISION = 0x0008,
		FOF_NOCONFIRMATION = 0x0010,
		FOF_WANTMAPPINGHANDLE = 0x0020,
		FOF_ALLOWUNDO = 0x0040,
		FOF_FILESONLY = 0x0080,
		FOF_SIMPLEPROGRESS = 0x0100,
		FOF_NOCONFIRMMKDIR = 0x0200,
		FOF_NOERRORUI = 0x0400,
		FILE_BEGIN = 0,
		FILE_CURRENT = 1,
		FILE_END = 2,
		FILE_FLAG_WRITE_THROUGH = 0x80000000,
		FILE_FLAG_OVERLAPPED = 0x40000000,
		FILE_FLAG_NO_BUFFERING = 0x20000000,
		FILE_FLAG_RANDOM_ACCESS = 0x10000000,
		FILE_FLAG_SEQUENTIAL_SCAN = 0x08000000,
		FILE_FLAG_DELETE_ON_CLOSE = 0x04000000,
		FILE_FLAG_BACKUP_SEMANTICS = 0x02000000,
		FILE_FLAG_POSIX_SEMANTICS = 0x01000000,
		FILE_TYPE_UNKNOWN = 0x0000,
		FILE_TYPE_DISK = 0x0001,
		FILE_TYPE_CHAR = 0x0002,
		FILE_TYPE_PIPE = 0x0003,
		FILE_TYPE_REMOTE = 0x8000,
		FORMAT_MESSAGE_ALLOCATE_BUFFER = 0x00000100,
		FORMAT_MESSAGE_IGNORE_INSERTS = 0x00000200,
		FORMAT_MESSAGE_FROM_STRING = 0x00000400,
		FORMAT_MESSAGE_FROM_HMODULE = 0x00000800,
		FORMAT_MESSAGE_FROM_SYSTEM = 0x00001000,
		FORMAT_MESSAGE_ARGUMENT_ARRAY = 0x00002000,
		FORMAT_MESSAGE_MAX_WIDTH_MASK = 0x000000FF,
		FIND_FIRST_EX_CASE_SENSITIVE = 0x00000001,
		FROM_LEFT_1ST_BUTTON_PRESSED = 0x0001,
		FROM_LEFT_2ND_BUTTON_PRESSED = 0x0004,
		FROM_LEFT_3RD_BUTTON_PRESSED = 0x0008,
		FROM_LEFT_4TH_BUTTON_PRESSED = 0x0010,
		FOCUS_EVENT = 0x0010,
		FOREGROUND_BLUE = 0x0001,
		FOREGROUND_GREEN = 0x0002,
		FOREGROUND_RED = 0x0004,
		FOREGROUND_INTENSITY = 0x0008;
	// FALSE = 0;
	int FACILITY_WINDOWS = 8,
		FACILITY_STORAGE = 3,
		FACILITY_RPC = 1,
		FACILITY_SSPI = 9,
		FACILITY_WIN32 = 7,
		FACILITY_CONTROL = 10,
		FACILITY_NULL = 0,
		FACILITY_INTERNET = 12,
		FACILITY_ITF = 4,
		FACILITY_DISPATCH = 2,
		FACILITY_CERT = 11,
		FACILITY_NT_BIT = 0x10000000,
		FLUSHOUTPUT = 6,
		FIXED_PITCH = 1,
		FS_LATIN1 = 0x00000001,
		FS_LATIN2 = 0x00000002,
		FS_CYRILLIC = 0x00000004,
		FS_GREEK = 0x00000008,
		FS_TURKISH = 0x00000010,
		FS_HEBREW = 0x00000020,
		FS_ARABIC = 0x00000040,
		FS_BALTIC = 0x00000080,
		FS_VIETNAMESE = 0x00000100,
		FS_THAI = 0x00010000,
		FS_JISJAPAN = 0x00020000,
		FS_CHINESESIMP = 0x00040000,
		FS_WANSUNG = 0x00080000,
		FS_CHINESETRAD = 0x00100000,
		FS_JOHAB = 0x00200000,
		FS_SYMBOL = 0x80000000,
		FF_DONTCARE = (0<<4),
		FF_ROMAN = (1<<4),
		FF_SWISS = (2<<4),
        FF_MODERN =(3<<4),
		FF_SCRIPT = (4<<4),
		FF_DECORATIVE = (5<<4),
		FW_DONTCARE = 0,
		FW_THIN = 100,
		FW_EXTRALIGHT = 200,
		FW_LIGHT = 300,
		FW_NORMAL = 400,
		FW_MEDIUM = 500,
		FW_SEMIBOLD = 600,
		FW_BOLD = 700,
		FW_EXTRABOLD = 800,
		FW_HEAVY = 900,
		FW_ULTRALIGHT = 200,
		FW_REGULAR = 400,
		FW_DEMIBOLD = 600,
		FW_ULTRABOLD = 800,
		FW_BLACK = 900,
		FLOODFILLBORDER = 0,
		FLOODFILLSURFACE = 1,
		FLI_MASK = 0x103B,
		FLI_GLYPHS = 0x00040000,
		FONTMAPPER_MAX = 10,
		FILE_READ_DATA = (0x0001),
		FILE_LIST_DIRECTORY = (0x0001),
		FILE_WRITE_DATA = (0x0002),
		FILE_ADD_FILE = (0x0002),
		FILE_APPEND_DATA = (0x0004),
		FILE_ADD_SUBDIRECTORY = (0x0004),
		FILE_CREATE_PIPE_INSTANCE = (0x0004),
		FILE_READ_EA = (0x0008),
		FILE_WRITE_EA = (0x0010),
		FILE_EXECUTE = (0x0020),
		FILE_TRAVERSE = (0x0020),
		FILE_DELETE_CHILD = (0x0040),
		FILE_READ_ATTRIBUTES = (0x0080),
		FILE_WRITE_ATTRIBUTES = (0x0100),
		FILE_SHARE_READ = 0x00000001,
		FILE_SHARE_WRITE = 0x00000002,
		FILE_SHARE_DELETE = 0x00000004,
		FILE_ATTRIBUTE_READONLY = 0x00000001,
		FILE_ATTRIBUTE_HIDDEN = 0x00000002,
		FILE_ATTRIBUTE_SYSTEM = 0x00000004,
		FILE_ATTRIBUTE_DIRECTORY = 0x00000010,
		FILE_ATTRIBUTE_ARCHIVE = 0x00000020,
		FILE_ATTRIBUTE_NORMAL = 0x00000080,
		FILE_ATTRIBUTE_TEMPORARY = 0x00000100,
		FILE_ATTRIBUTE_COMPRESSED = 0x00000800,
		FILE_ATTRIBUTE_OFFLINE = 0x00001000,
		FILE_NOTIFY_CHANGE_FILE_NAME = 0x00000001,
		FILE_NOTIFY_CHANGE_DIR_NAME = 0x00000002,
		FILE_NOTIFY_CHANGE_ATTRIBUTES = 0x00000004,
		FILE_NOTIFY_CHANGE_SIZE = 0x00000008,
		FILE_NOTIFY_CHANGE_LAST_WRITE = 0x00000010,
		FILE_NOTIFY_CHANGE_LAST_ACCESS = 0x00000020,
		FILE_NOTIFY_CHANGE_CREATION = 0x00000040,
		FILE_NOTIFY_CHANGE_SECURITY = 0x00000100,
		FILE_ACTION_ADDED = 0x00000001,
		FILE_ACTION_REMOVED = 0x00000002,
		FILE_ACTION_MODIFIED = 0x00000003,
		FILE_ACTION_RENAMED_OLD_NAME = 0x00000004,
		FILE_ACTION_RENAMED_NEW_NAME = 0x00000005,
		FILE_CASE_SENSITIVE_SEARCH = 0x00000001,
		FILE_CASE_PRESERVED_NAMES = 0x00000002,
		FILE_UNICODE_ON_DISK = 0x00000004,
		FILE_PERSISTENT_ACLS = 0x00000008,
		FILE_FILE_COMPRESSION = 0x00000010,
		FILE_VOLUME_IS_COMPRESSED = 0x00008000,
		FAILED_ACCESS_ACE_FLAG = (0x80),
		FRAME_FPO = 0,
		FRAME_TRAP = 1,
		FRAME_TSS = 2,
		FRAME_NONFPO = 3,
		FORM_USER = 0x00000000,
		FORM_BUILTIN = 0x00000001,
		FORM_PRINTER = 0x00000002;
	boolean FVIRTKEY = true;
	int FNOINVERT = 0x02,
		FSHIFT = 0x04,
		FCONTROL = 0x08,
		FALT = 0x10,
		FKF_FILTERKEYSON = 0x00000001,
		FKF_AVAILABLE = 0x00000002,
		FKF_HOTKEYACTIVE = 0x00000004,
		FKF_CONFIRMHOTKEY = 0x00000008,
		FKF_HOTKEYSOUND = 0x00000010,
		FKF_INDICATOR = 0x00000020,
		FKF_CLICKON = 0x00000040,
		FS_CASE_IS_PRESERVED = 0x00000002,
		FS_CASE_SENSITIVE = 0x00000001,
		FS_UNICODE_STORED_ON_DISK = 0x00000004,
		FS_PERSISTENT_ACLS = 0x00000008,
		FS_VOL_IS_COMPRESSED = 0x00008000,
		FS_FILE_COMPRESSION = 0x00000010,
		FILE_MAP_COPY = 0x0001,
		FILE_MAP_WRITE = 0x0002,
		FILE_MAP_READ = 0x0004,
		FILE_ALL_ACCESS = ((0x000F0000)|(0x00100000)|0x1FF);

}
