// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface wini {
    int ITALIC_FONTTYPE = 0x0200,
        ico1 = 0x043c,
        ico2 = 0x043d,
        ico3 = 0x043e,
        ico4 = 0x043f,
        IMC_GETCANDIDATEPOS = 0x0007,
        IMC_SETCANDIDATEPOS = 0x0008,
        IMC_GETCOMPOSITIONFONT = 0x0009,
        IMC_SETCOMPOSITIONFONT = 0x000A,
        IMC_GETCOMPOSITIONWINDOW = 0x000B,
        IMC_SETCOMPOSITIONWINDOW = 0x000C,
        IMC_GETSTATUSWINDOWPOS = 0x000F,
        IMC_SETSTATUSWINDOWPOS = 0x0010,
        IMC_CLOSESTATUSWINDOW = 0x0021,
        IMC_OPENSTATUSWINDOW = 0x0022,
        ISC_SHOWUICANDIDATEWINDOW = 0x00000001,
        ISC_SHOWUICOMPOSITIONWINDOW = 0x80000000,
        ISC_SHOWUIGUIDELINE = 0x40000000,
        ISC_SHOWUIALLCANDIDATEWINDOW = 0x0000000F,
        ISC_SHOWUIALL = 0xC000000F,
        IME_CHOTKEY_IME_NONIME_TOGGLE = 0x10,
        IME_CHOTKEY_SHAPE_TOGGLE = 0x11,
        IME_CHOTKEY_SYMBOL_TOGGLE = 0x12,
        IME_JHOTKEY_CLOSE_OPEN = 0x30,
        IME_KHOTKEY_SHAPE_TOGGLE = 0x50,
        IME_KHOTKEY_HANJACONVERT = 0x51,
        IME_KHOTKEY_ENGLISH = 0x52,
        IME_THOTKEY_IME_NONIME_TOGGLE = 0x70,
        IME_THOTKEY_SHAPE_TOGGLE = 0x71,
        IME_THOTKEY_SYMBOL_TOGGLE = 0x72,
        IME_HOTKEY_DSWITCH_FIRST = 0x100,
        IME_HOTKEY_DSWITCH_LAST = 0x11F,
        IME_HOTKEY_PRIVATE_FIRST = 0x200,
        IME_ITHOTKEY_RESEND_RESULTSTR = 0x200,
        IME_ITHOTKEY_PREVIOUS_COMPOSITION = 0x201,
        IME_ITHOTKEY_UISTYLE_TOGGLE = 0x202,
        IME_HOTKEY_PRIVATE_LAST = 0x21F,
        IMEVER_0310 = 0x0003000A,
        IMEVER_0400 = 0x00040000,
        IME_PROP_AT_CARET = 0x00010000,
        IME_PROP_SPECIAL_UI = 0x00020000,
        IME_PROP_CANDLIST_START_FROM_1 = 0x00040000,
        IME_PROP_UNICODE = 0x00080000,
        IGP_PROPERTY = 0x00000004,
        IGP_CONVERSION = 0x00000008,
        IGP_SENTENCE = 0x0000000c,
        IGP_UI = 0x00000010,
        IGP_SETCOMPSTR = 0x00000014,
        IGP_SELECT = 0x00000018,
        IME_CMODE_ALPHANUMERIC = 0x0000,
        IME_CMODE_NATIVE = 0x0001,
        IME_CMODE_CHINESE = 0x0001,
        IME_CMODE_HANGEUL = 0x0001,
        IME_CMODE_HANGUL = 0x0001,
        IME_CMODE_JAPANESE = 0x0001,
        IME_CMODE_KATAKANA = 0x0002,
        IME_CMODE_LANGUAGE = 0x0003,
        IME_CMODE_FULLSHAPE = 0x0008,
        IME_CMODE_ROMAN = 0x0010,
        IME_CMODE_CHARCODE = 0x0020,
        IME_CMODE_HANJACONVERT = 0x0040,
        IME_CMODE_SOFTKBD = 0x0080,
        IME_CMODE_NOCONVERSION = 0x0100,
        IME_CMODE_EUDC = 0x0200,
        IME_CMODE_SYMBOL = 0x0400,
        IME_SMODE_NONE = 0x0000,
        IME_SMODE_PLAURALCLAUSE = 0x0001,
        IME_SMODE_SINGLECONVERT = 0x0002,
        IME_SMODE_AUTOMATIC = 0x0004,
        IME_SMODE_PHRASEPREDICT = 0x0008,
        IME_CAND_UNKNOWN = 0x0000,
        IME_CAND_READ = 0x0001,
        IME_CAND_CODE = 0x0002,
        IME_CAND_MEANING = 0x0003,
        IME_CAND_RADICAL = 0x0004,
        IME_CAND_STROKE = 0x0005,
        IMN_CLOSESTATUSWINDOW = 0x0001,
        IMN_OPENSTATUSWINDOW = 0x0002,
        IMN_CHANGECANDIDATE = 0x0003,
        IMN_CLOSECANDIDATE = 0x0004,
        IMN_OPENCANDIDATE = 0x0005,
        IMN_SETCONVERSIONMODE = 0x0006,
        IMN_SETSENTENCEMODE = 0x0007,
        IMN_SETOPENSTATUS = 0x0008,
        IMN_SETCANDIDATEPOS = 0x0009,
        IMN_SETCOMPOSITIONFONT = 0x000A,
        IMN_SETCOMPOSITIONWINDOW = 0x000B,
        IMN_SETSTATUSWINDOWPOS = 0x000C,
        IMN_GUIDELINE = 0x000D,
        IMN_PRIVATE = 0x000E,
        IMM_ERROR_NODATA = (-1),
        IMM_ERROR_GENERAL = (-2),
        IME_CONFIG_GENERAL = 1,
        IME_CONFIG_REGISTERWORD = 2,
        IME_CONFIG_SELECTDICTIONARY = 3,
        IME_ESC_QUERY_SUPPORT = 0x0003,
        IME_ESC_RESERVED_FIRST = 0x0004,
        IME_ESC_RESERVED_LAST = 0x07FF,
        IME_ESC_PRIVATE_FIRST = 0x0800,
        IME_ESC_PRIVATE_LAST = 0x0FFF,
        IME_ESC_SEQUENCE_TO_INTERNAL = 0x1001,
        IME_ESC_GET_EUDC_DICTIONARY = 0x1003,
        IME_ESC_SET_EUDC_DICTIONARY = 0x1004,
        IME_ESC_MAX_KEY = 0x1005,
        IME_ESC_IME_NAME = 0x1006,
        IME_ESC_SYNC_HOTKEY = 0x1007,
        IME_ESC_HANJA_MODE = 0x1008,
        IME_ESC_AUTOMATA = 0x1009,
        IME_ESC_PRIVATE_HOTKEY = 0x100a,
        IME_REGWORD_STYLE_EUDC = 0x00000001,
        IME_REGWORD_STYLE_USER_FIRST = 0x80000000,
        IME_REGWORD_STYLE_USER_LAST = 0xFFFFFFFF,
        IDLFLAG_NONE = ((0)),
        IDLFLAG_FIN = ((0x1)),
        IDLFLAG_FOUT = ((0x2)),
        IDLFLAG_FLCID = ((0x4)),
        IDLFLAG_FRETVAL = ((0x8)),
        IMPLTYPEFLAG_FDEFAULT = (0x1),
        IMPLTYPEFLAG_FSOURCE = (0x2),
        IMPLTYPEFLAG_FRESTRICTED = (0x4),
        IMPLTYPEFLAG_FDEFAULTVTABLE = (0x8),
        ID_DEFAULTINST = -2,
        ID_PSRESTARTWINDOWS = 0x2,
        ID_PSREBOOTSYSTEM = (0x2|0x1),
        IDLE_PRIORITY_CLASS = 0x00000040,
        IGNORE = 0,
        INFINITE = 0xFFFFFFFF,
        IE_BADID = (-1),
        IE_OPEN = (-2),
        IE_NOPEN = (-3),
        IE_MEMORY = (-4),
        IE_DEFAULT = (-5),
        IE_HARDWARE = (-10),
        IE_BYTESIZE = (-11),
        IE_BAUDRATE = (-12),
        INPLACE_E_NOTUNDOABLE = 0x800401A0,
        INPLACE_E_NOTOOLSPACE = 0x800401A1,
        INPLACE_E_FIRST = 0x800401A0,
        INPLACE_E_LAST = 0x800401AF,
        INPLACE_S_FIRST = 0x000401A0,
        INPLACE_S_LAST = 0x000401AF,
        INPLACE_S_TRUNCATED = 0x000401A0,
        ILLUMINANT_DEVICE_DEFAULT = 0,
        ILLUMINANT_A = 1,
        ILLUMINANT_B = 2,
        ILLUMINANT_C = 3,
        ILLUMINANT_D50 = 4,
        ILLUMINANT_D55 = 5,
        ILLUMINANT_D65 = 6,
        ILLUMINANT_D75 = 7,
        ILLUMINANT_F2 = 8,
        ILLUMINANT_MAX_INDEX = 8,
        ILLUMINANT_TUNGSTEN = 1,
        ILLUMINANT_DAYLIGHT = 3,
        ILLUMINANT_FLUORESCENT = 8,
        ILLUMINANT_NTSC = 3,
        ICM_OFF = 1,
        ICM_ON = 2,
        ICM_QUERY = 3,
        IO_COMPLETION_MODIFY_STATE = 0x0002,
        INHERIT_ONLY_ACE = (0x8),
        IMAGE_DOS_SIGNATURE = 0x5A4D,
        IMAGE_OS2_SIGNATURE = 0x454E,
        IMAGE_OS2_SIGNATURE_LE = 0x454C,
        IMAGE_VXD_SIGNATURE = 0x454C,
        IMAGE_NT_SIGNATURE = 0x00004550,
        IMAGE_SIZEOF_FILE_HEADER = 20,
        IMAGE_FILE_RELOCS_STRIPPED = 0x0001,
        IMAGE_FILE_LINE_NUMS_STRIPPED = 0x0004,
        IMAGE_FILE_LOCAL_SYMS_STRIPPED = 0x0008,
        IMAGE_FILE_AGGRESIVE_WS_TRIM = 0x0010,
        IMAGE_FILE_BYTES_REVERSED_LO = 0x0080,
        IMAGE_FILE_32BIT_MACHINE = 0x0100,
        IMAGE_FILE_DEBUG_STRIPPED = 0x0200,
        IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = 0x0400,
        IMAGE_FILE_NET_RUN_FROM_SWAP = 0x0800,
        IMAGE_FILE_SYSTEM = 0x1000,
        IMAGE_FILE_DLL = 0x2000,
        IMAGE_FILE_UP_SYSTEM_ONLY = 0x4000,
        IMAGE_FILE_BYTES_REVERSED_HI = 0x8000,
        IMAGE_FILE_MACHINE_UNKNOWN = 0,
        IMAGE_FILE_MACHINE_I386 = 0x14c,
        IMAGE_FILE_MACHINE_R3000 = 0x162,
        IMAGE_FILE_MACHINE_R4000 = 0x166,
        IMAGE_FILE_MACHINE_R10000 = 0x168,
        IMAGE_FILE_MACHINE_ALPHA = 0x184,
        IMAGE_FILE_MACHINE_POWERPC = 0x1F0,
        IMAGE_NUMBEROF_DIRECTORY_ENTRIES = 16,
        IMAGE_SIZEOF_ROM_OPTIONAL_HEADER = 56,
        IMAGE_SIZEOF_STD_OPTIONAL_HEADER = 28,
        IMAGE_SIZEOF_NT_OPTIONAL_HEADER = 224,
        IMAGE_NT_OPTIONAL_HDR_MAGIC = 0x10b,
        IMAGE_ROM_OPTIONAL_HDR_MAGIC = 0x107,
        IMAGE_SUBSYSTEM_UNKNOWN = 0,
        IMAGE_SUBSYSTEM_NATIVE = 1,
        IMAGE_SUBSYSTEM_WINDOWS_GUI = 2,
        IMAGE_SUBSYSTEM_WINDOWS_CUI = 3,
        IMAGE_SUBSYSTEM_OS2_CUI = 5,
        IMAGE_SUBSYSTEM_POSIX_CUI = 7,
        IMAGE_SUBSYSTEM_RESERVED8 = 8,
        IMAGE_DIRECTORY_ENTRY_EXPORT = 0,
        IMAGE_DIRECTORY_ENTRY_IMPORT = 1,
        IMAGE_DIRECTORY_ENTRY_RESOURCE = 2,
        IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3,
        IMAGE_DIRECTORY_ENTRY_SECURITY = 4,
        IMAGE_DIRECTORY_ENTRY_BASERELOC = 5,
        IMAGE_DIRECTORY_ENTRY_DEBUG = 6,
        IMAGE_DIRECTORY_ENTRY_COPYRIGHT = 7,
        IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8,
        IMAGE_DIRECTORY_ENTRY_TLS = 9,
        IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10,
        IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11,
        IMAGE_DIRECTORY_ENTRY_IAT = 12,
        IMAGE_SIZEOF_SHORT_NAME = 8,
        IMAGE_SIZEOF_SECTION_HEADER = 40,
        IMAGE_SCN_TYPE_NO_PAD = 0x00000008,
        IMAGE_SCN_CNT_CODE = 0x00000020,
        IMAGE_SCN_CNT_INITIALIZED_DATA = 0x00000040,
        IMAGE_SCN_CNT_UNINITIALIZED_DATA = 0x00000080,
        IMAGE_SCN_LNK_OTHER = 0x00000100,
        IMAGE_SCN_LNK_INFO = 0x00000200,
        IMAGE_SCN_LNK_REMOVE = 0x00000800,
        IMAGE_SCN_LNK_COMDAT = 0x00001000,
        IMAGE_SCN_MEM_FARDATA = 0x00008000,
        IMAGE_SCN_MEM_PURGEABLE = 0x00020000,
        IMAGE_SCN_MEM_16BIT = 0x00020000,
        IMAGE_SCN_MEM_LOCKED = 0x00040000,
        IMAGE_SCN_MEM_PRELOAD = 0x00080000,
        IMAGE_SCN_ALIGN_1BYTES = 0x00100000,
        IMAGE_SCN_ALIGN_2BYTES = 0x00200000,
        IMAGE_SCN_ALIGN_4BYTES = 0x00300000,
        IMAGE_SCN_ALIGN_8BYTES = 0x00400000,
        IMAGE_SCN_ALIGN_16BYTES = 0x00500000,
        IMAGE_SCN_ALIGN_32BYTES = 0x00600000,
        IMAGE_SCN_ALIGN_64BYTES = 0x00700000,
        IMAGE_SCN_LNK_NRELOC_OVFL = 0x01000000,
        IMAGE_SCN_MEM_DISCARDABLE = 0x02000000,
        IMAGE_SCN_MEM_NOT_CACHED = 0x04000000,
        IMAGE_SCN_MEM_NOT_PAGED = 0x08000000,
        IMAGE_SCN_MEM_SHARED = 0x10000000,
        IMAGE_SCN_MEM_EXECUTE = 0x20000000,
        IMAGE_SCN_MEM_READ = 0x40000000,
        IMAGE_SCN_MEM_WRITE = 0x80000000,
        IMAGE_SCN_SCALE_INDEX = 0x00000001,
        IMAGE_SIZEOF_SYMBOL = 18,
        IMAGE_SYM_TYPE_NULL = 0x0000,
        IMAGE_SYM_TYPE_VOID = 0x0001,
        IMAGE_SYM_TYPE_CHAR = 0x0002,
        IMAGE_SYM_TYPE_SHORT = 0x0003,
        IMAGE_SYM_TYPE_INT = 0x0004,
        IMAGE_SYM_TYPE_LONG = 0x0005,
        IMAGE_SYM_TYPE_FLOAT = 0x0006,
        IMAGE_SYM_TYPE_DOUBLE = 0x0007,
        IMAGE_SYM_TYPE_STRUCT = 0x0008,
        IMAGE_SYM_TYPE_UNION = 0x0009,
        IMAGE_SYM_TYPE_ENUM = 0x000A,
        IMAGE_SYM_TYPE_MOE = 0x000B,
        IMAGE_SYM_TYPE_BYTE = 0x000C,
        IMAGE_SYM_TYPE_WORD = 0x000D,
        IMAGE_SYM_TYPE_UINT = 0x000E,
        IMAGE_SYM_TYPE_DWORD = 0x000F,
        IMAGE_SYM_TYPE_PCODE = 0x8000,
        IMAGE_SYM_DTYPE_NULL = 0,
        IMAGE_SYM_DTYPE_POINTER = 1,
        IMAGE_SYM_DTYPE_FUNCTION = 2,
        IMAGE_SYM_DTYPE_ARRAY = 3,
        IMAGE_SYM_CLASS_NULL = 0x0000,
        IMAGE_SYM_CLASS_AUTOMATIC = 0x0001,
        IMAGE_SYM_CLASS_STATIC = 0x0003,
        IMAGE_SYM_CLASS_REGISTER = 0x0004,
        IMAGE_SYM_CLASS_LABEL = 0x0006,
        IMAGE_SYM_CLASS_UNDEFINED_LABEL = 0x0007,
        IMAGE_SYM_CLASS_MEMBER_OF_STRUCT = 0x0008,
        IMAGE_SYM_CLASS_ARGUMENT = 0x0009,
        IMAGE_SYM_CLASS_STRUCT_TAG = 0x000A,
        IMAGE_SYM_CLASS_MEMBER_OF_UNION = 0x000B,
        IMAGE_SYM_CLASS_UNION_TAG = 0x000C,
        IMAGE_SYM_CLASS_TYPE_DEFINITION = 0x000D,
        IMAGE_SYM_CLASS_UNDEFINED_STATIC = 0x000E,
        IMAGE_SYM_CLASS_ENUM_TAG = 0x000F,
        IMAGE_SYM_CLASS_MEMBER_OF_ENUM = 0x0010,
        IMAGE_SYM_CLASS_REGISTER_PARAM = 0x0011,
        IMAGE_SYM_CLASS_BIT_FIELD = 0x0012,
        IMAGE_SYM_CLASS_BLOCK = 0x0064,
        IMAGE_SYM_CLASS_FUNCTION = 0x0065,
        IMAGE_SYM_CLASS_END_OF_STRUCT = 0x0066,
        IMAGE_SYM_CLASS_FILE = 0x0067,
        IMAGE_SYM_CLASS_SECTION = 0x0068,
        IMAGE_SIZEOF_AUX_SYMBOL = 18,
        IMAGE_COMDAT_SELECT_NODUPLICATES = 1,
        IMAGE_COMDAT_SELECT_ANY = 2,
        IMAGE_COMDAT_SELECT_SAME_SIZE = 3,
        IMAGE_COMDAT_SELECT_EXACT_MATCH = 4,
        IMAGE_COMDAT_SELECT_ASSOCIATIVE = 5,
        IMAGE_COMDAT_SELECT_LARGEST = 6,
        IMAGE_COMDAT_SELECT_NEWEST = 7,
        IMAGE_SIZEOF_RELOCATION = 10,
        IMAGE_REL_I386_ABSOLUTE = 0x0000,
        IMAGE_REL_I386_DIR16 = 0x0001,
        IMAGE_REL_I386_REL16 = 0x0002,
        IMAGE_REL_I386_DIR32 = 0x0006,
        IMAGE_REL_I386_DIR32NB = 0x0007,
        IMAGE_REL_I386_SEG12 = 0x0009,
        IMAGE_REL_I386_SECTION = 0x000A,
        IMAGE_REL_I386_SECREL = 0x000B,
        IMAGE_REL_I386_REL32 = 0x0014,
        IMAGE_REL_MIPS_ABSOLUTE = 0x0000,
        IMAGE_REL_MIPS_REFHALF = 0x0001,
        IMAGE_REL_MIPS_REFWORD = 0x0002,
        IMAGE_REL_MIPS_JMPADDR = 0x0003,
        IMAGE_REL_MIPS_REFHI = 0x0004,
        IMAGE_REL_MIPS_REFLO = 0x0005,
        IMAGE_REL_MIPS_GPREL = 0x0006,
        IMAGE_REL_MIPS_LITERAL = 0x0007,
        IMAGE_REL_MIPS_SECTION = 0x000A,
        IMAGE_REL_MIPS_SECREL = 0x000B,
        IMAGE_REL_MIPS_SECRELLO = 0x000C,
        IMAGE_REL_MIPS_SECRELHI = 0x000D,
        IMAGE_REL_MIPS_REFWORDNB = 0x0022,
        IMAGE_REL_MIPS_PAIR = 0x0025,
        IMAGE_REL_ALPHA_ABSOLUTE = 0x0000,
        IMAGE_REL_ALPHA_REFLONG = 0x0001,
        IMAGE_REL_ALPHA_REFQUAD = 0x0002,
        IMAGE_REL_ALPHA_GPREL32 = 0x0003,
        IMAGE_REL_ALPHA_LITERAL = 0x0004,
        IMAGE_REL_ALPHA_LITUSE = 0x0005,
        IMAGE_REL_ALPHA_GPDISP = 0x0006,
        IMAGE_REL_ALPHA_BRADDR = 0x0007,
        IMAGE_REL_ALPHA_HINT = 0x0008,
        IMAGE_REL_ALPHA_INLINE_REFLONG = 0x0009,
        IMAGE_REL_ALPHA_REFHI = 0x000A,
        IMAGE_REL_ALPHA_REFLO = 0x000B,
        IMAGE_REL_ALPHA_PAIR = 0x000C,
        IMAGE_REL_ALPHA_MATCH = 0x000D,
        IMAGE_REL_ALPHA_SECTION = 0x000E,
        IMAGE_REL_ALPHA_SECREL = 0x000F,
        IMAGE_REL_ALPHA_REFLONGNB = 0x0010,
        IMAGE_REL_ALPHA_SECRELLO = 0x0011,
        IMAGE_REL_ALPHA_SECRELHI = 0x0012,
        IMAGE_REL_PPC_ABSOLUTE = 0x0000,
        IMAGE_REL_PPC_ADDR64 = 0x0001,
        IMAGE_REL_PPC_ADDR32 = 0x0002,
        IMAGE_REL_PPC_ADDR24 = 0x0003,
        IMAGE_REL_PPC_ADDR16 = 0x0004,
        IMAGE_REL_PPC_ADDR14 = 0x0005,
        IMAGE_REL_PPC_REL24 = 0x0006,
        IMAGE_REL_PPC_REL14 = 0x0007,
        IMAGE_REL_PPC_TOCREL16 = 0x0008,
        IMAGE_REL_PPC_TOCREL14 = 0x0009,
        IMAGE_REL_PPC_ADDR32NB = 0x000A,
        IMAGE_REL_PPC_SECREL = 0x000B,
        IMAGE_REL_PPC_SECTION = 0x000C,
        IMAGE_REL_PPC_IFGLUE = 0x000D,
        IMAGE_REL_PPC_IMGLUE = 0x000E,
        IMAGE_REL_PPC_SECREL16 = 0x000F,
        IMAGE_REL_PPC_REFHI = 0x0010,
        IMAGE_REL_PPC_REFLO = 0x0011,
        IMAGE_REL_PPC_PAIR = 0x0012,
        IMAGE_REL_PPC_SECRELLO = 0x0013,
        IMAGE_REL_PPC_SECRELHI = 0x0014,
        IMAGE_REL_PPC_TYPEMASK = 0x00FF,
        IMAGE_REL_PPC_NEG = 0x0100,
        IMAGE_REL_PPC_BRTAKEN = 0x0200,
        IMAGE_REL_PPC_BRNTAKEN = 0x0400,
        IMAGE_REL_PPC_TOCDEFN = 0x0800,
        IMAGE_SIZEOF_LINENUMBER = 6,
        IMAGE_SIZEOF_BASE_RELOCATION = 8,
        IMAGE_REL_BASED_ABSOLUTE = 0,
        IMAGE_REL_BASED_HIGH = 1,
        IMAGE_REL_BASED_LOW = 2,
        IMAGE_REL_BASED_HIGHLOW = 3,
        IMAGE_REL_BASED_HIGHADJ = 4,
        IMAGE_REL_BASED_MIPS_JMPADDR = 5,
        IMAGE_REL_BASED_SECTION = 6,
        IMAGE_REL_BASED_REL32 = 7,
        IMAGE_ARCHIVE_START_SIZE = 8,
        IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR = 60,
        IMAGE_ORDINAL_FLAG = 0x80000000,
        IMAGE_RESOURCE_NAME_IS_STRING = 0x80000000,
        IMAGE_RESOURCE_DATA_IS_DIRECTORY = 0x80000000,
        IMAGE_DEBUG_TYPE_UNKNOWN = 0,
        IMAGE_DEBUG_TYPE_COFF = 1,
        IMAGE_DEBUG_TYPE_CODEVIEW = 2,
        IMAGE_DEBUG_TYPE_FPO = 3,
        IMAGE_DEBUG_TYPE_MISC = 4,
        IMAGE_DEBUG_TYPE_EXCEPTION = 5,
        IMAGE_DEBUG_TYPE_FIXUP = 6,
        IMAGE_DEBUG_TYPE_OMAP_TO_SRC = 7,
        IMAGE_DEBUG_TYPE_OMAP_FROM_SRC = 8,
        IMAGE_DEBUG_MISC_EXENAME = 1,
        IMAGE_SEPARATE_DEBUG_SIGNATURE = 0x4944,
        IMAGE_SEPARATE_DEBUG_FLAGS_MASK = 0x8000,
        IMAGE_SEPARATE_DEBUG_MISMATCH = 0x8000,
        IS_TEXT_UNICODE_ASCII16 = 0x0001,
        IS_TEXT_UNICODE_REVERSE_ASCII16 = 0x0010,
        IS_TEXT_UNICODE_STATISTICS = 0x0002,
        IS_TEXT_UNICODE_REVERSE_STATISTICS = 0x0020,
        IS_TEXT_UNICODE_CONTROLS = 0x0004,
        IS_TEXT_UNICODE_REVERSE_CONTROLS = 0x0040,
        IS_TEXT_UNICODE_SIGNATURE = 0x0008,
        IS_TEXT_UNICODE_REVERSE_SIGNATURE = 0x0080,
        IS_TEXT_UNICODE_ILLEGAL_CHARS = 0x0100,
        IS_TEXT_UNICODE_ODD_LENGTH = 0x0200,
        IS_TEXT_UNICODE_DBCS_LEADBYTE = 0x0400,
        IS_TEXT_UNICODE_NULL_BYTES = 0x1000,
        IS_TEXT_UNICODE_UNICODE_MASK = 0x000F,
        IS_TEXT_UNICODE_REVERSE_MASK = 0x00F0,
        IS_TEXT_UNICODE_NOT_UNICODE_MASK = 0x0F00,
        IS_TEXT_UNICODE_NOT_ASCII_MASK = 0xF000,
        ICON_SMALL = 0,
        ICON_BIG = 1,
        IDANI_OPEN = 1,
        IDANI_CLOSE = 2,
        IDANI_CAPTION = 3,
        IDHOT_SNAPWINDOW = (-1),
        IDHOT_SNAPDESKTOP = (-2),
        IDC_ARROW = 32512,
        IDC_IBEAM = 32513,
        IDC_WAIT = 32514,
        IDC_CROSS = 32515,
        IDC_UPARROW = 32516,
        IDC_SIZE = 32640,
        IDC_ICON = 32641,
        IDC_SIZENWSE = 32642,
        IDC_SIZENESW = 32643,
        IDC_SIZEWE = 32644,
        IDC_SIZENS = 32645,
        IDC_SIZEALL = 32646,
        IDC_NO = 32648,
        IDC_APPSTARTING = 32650,
        IDC_HELP = 32651,
        IMAGE_BITMAP = 0,
        IMAGE_ICON = 1,
        IMAGE_CURSOR = 2,
        IMAGE_ENHMETAFILE = 3,
        IDI_APPLICATION = 32512,
        IDI_HAND = 32513,
        IDI_QUESTION = 32514,
        IDI_EXCLAMATION = 32515,
        IDI_ASTERISK = 32516,
        IDI_WINLOGO = 32517,
        IDI_WARNING = 32515,
        IDI_ERROR = 32513,
        IDI_INFORMATION = 32516,
        IDOK = 1,
        IDCANCEL = 2,
        IDABORT = 3,
        IDRETRY = 4,
        IDIGNORE = 5,
        IDYES = 6,
        IDNO = 7,
        IDCLOSE = 8,
        IDHELP = 9,
        IDH_NO_HELP = 28440,
        IDH_MISSING_CONTEXT = 28441,
        IDH_GENERIC_HELP_BUTTON = 28442,
        IDH_OK = 28443,
        IDH_CANCEL = 28444,
        IDH_HELP = 28445,
        ICC_LISTVIEW_CLASSES = 0x00000001,
        ICC_TREEVIEW_CLASSES = 0x00000002,
        ICC_BAR_CLASSES = 0x00000004,
        ICC_TAB_CLASSES = 0x00000008,
        ICC_UPDOWN_CLASS = 0x00000010,
        ICC_PROGRESS_CLASS = 0x00000020,
        ICC_HOTKEY_CLASS = 0x00000040,
        ICC_ANIMATE_CLASS = 0x00000080,
        ICC_WIN95_CLASSES = 0x000000FF,
        ICC_DATE_CLASSES = 0x00000100,
        ICC_USEREX_CLASSES = 0x00000200,
        ICC_COOL_CLASSES = 0x00000400,
        ILC_MASK = 0x0001,
        ILC_COLOR = 0x0000,
        ILC_COLORDDB = 0x00FE,
        ILC_COLOR4 = 0x0004,
        ILC_COLOR8 = 0x0008,
        ILC_COLOR16 = 0x0010,
        ILC_COLOR24 = 0x0018,
        ILC_COLOR32 = 0x0020,
        ILC_PALETTE = 0x0800,
        ILD_NORMAL = 0x0000,
        ILD_TRANSPARENT = 0x0001,
        ILD_MASK = 0x0010,
        ILD_IMAGE = 0x0020,
        ILD_ROP = 0x0040,
        ILD_BLEND25 = 0x0002,
        ILD_BLEND50 = 0x0004,
        ILD_OVERLAYMASK = 0x0F00,
        ILD_SELECTED = 0x0004,
        ILD_FOCUS = 0x0002,
        ILD_BLEND = 0x0004,
        ILCF_MOVE = (0x00000000),
        ILCF_SWAP = (0x00000001),
        IDB_STD_SMALL_COLOR = 0,
        IDB_STD_LARGE_COLOR = 1,
        IDB_VIEW_SMALL_COLOR = 4,
        IDB_VIEW_LARGE_COLOR = 5,
        IDB_HIST_SMALL_COLOR = 8,
        IDB_HIST_LARGE_COLOR = 9,
        I_INDENTCALLBACK = (-1),
        I_IMAGECALLBACK = (-1),
        I_CHILDRENCALLBACK = (-1),
        IO_COMPLETION_ALL_ACCESS = ((0x000F0000)|(0x00100000)|0x3),
        INVALID_HANDLE_VALUE = (-1),
        IPN_FIRST = (0-860),
        IPN_LAST = (0-879);

    /* RichEdit: Options for EM_SETLANGOPTIONS and EM_GETLANGOPTIONS */
    int IMF_AUTOKEYBOARD        = 0x0001,
        IMF_AUTOFONT            = 0x0002,
        IMF_IMECANCELCOMPLETE   = 0x0004,   // high completes the comp string when aborting, low cancels.
        IMF_IMEALWAYSSENDNOTIFY = 0x0008;

    /* RichEdit: Values for EM_GETIMECOMPMODE */
    int ICM_NOTOPEN             = 0x0000,
        ICM_LEVEL3              = 0x0001,
        ICM_LEVEL2              = 0x0002,
        ICM_LEVEL2_5            = 0x0003,
        ICM_LEVEL2_SUI          = 0x0004;
        
    /* RichEdit: Far East specific flags */
    int IMF_FORCENONE           = 0x0001,
        IMF_FORCEENABLE         = 0x0002,
        IMF_FORCEDISABLE        = 0x0004,
        IMF_CLOSESTATUSWINDOW   = 0x0008,
        IMF_VERTICAL            = 0x0020,
        IMF_FORCEACTIVE         = 0x0040,
        IMF_FORCEINACTIVE       = 0x0080,
        IMF_FORCEREMEMBER       = 0x0100,
        IMF_MULTIPLEEDIT        = 0x0400;
}
