// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface wino {
	int OFN_READONLY = 0x00000001,
		OFN_OVERWRITEPROMPT = 0x00000002,
		OFN_HIDEREADONLY = 0x00000004,
		OFN_NOCHANGEDIR = 0x00000008,
		OFN_SHOWHELP = 0x00000010,
		OFN_ENABLEHOOK = 0x00000020,
		OFN_ENABLETEMPLATE = 0x00000040,
		OFN_ENABLETEMPLATEHANDLE = 0x00000080,
		OFN_NOVALIDATE = 0x00000100,
		OFN_ALLOWMULTISELECT = 0x00000200,
		OFN_EXTENSIONDIFFERENT = 0x00000400,
		OFN_PATHMUSTEXIST = 0x00000800,
		OFN_FILEMUSTEXIST = 0x00001000,
		OFN_CREATEPROMPT = 0x00002000,
		OFN_SHAREAWARE = 0x00004000,
		OFN_NOREADONLYRETURN = 0x00008000,
		OFN_NOTESTFILECREATE = 0x00010000,
		OFN_NONETWORKBUTTON = 0x00020000,
		OFN_NOLONGNAMES = 0x00040000,
		OFN_EXPLORER = 0x00080000,
		OFN_NODEREFERENCELINKS = 0x00100000,
		OFN_LONGNAMES = 0x00200000,
		OFN_SHAREFALLTHROUGH = 2,
		OFN_SHARENOWARN = 1,
		OFN_SHAREWARN = 0,
		OLEIVERB_PRIMARY = (0),
		OLEIVERB_SHOW = (-1),
		OLEIVERB_OPEN = (-2),
		OLEIVERB_HIDE = (-3),
		OLEIVERB_UIACTIVATE = (-4),
		OLEIVERB_INPLACEACTIVATE = (-5),
		OLEIVERB_DISCARDUNDOSTATE = (-6),
		OLECREATE_LEAVERUNNING = 0x00000001,
		OPEN_EXISTING = 3,
		OPEN_ALWAYS = 4,
		OUTPUT_DEBUG_STRING_EVENT = 8,
		ODDPARITY = 1,
		ONESTOPBIT = 0,
		ONE5STOPBITS = 1,
		OF_READ = 0x00000000,
		OF_WRITE = 0x00000001,
		OF_READWRITE = 0x00000002,
		OF_SHARE_COMPAT = 0x00000000,
		OF_SHARE_EXCLUSIVE = 0x00000010,
		OF_SHARE_DENY_WRITE = 0x00000020,
		OF_SHARE_DENY_READ = 0x00000030,
		OF_SHARE_DENY_NONE = 0x00000040,
		OF_PARSE = 0x00000100,
		OF_DELETE = 0x00000200,
		OF_VERIFY = 0x00000400,
		OF_CANCEL = 0x00000800,
		OF_CREATE = 0x00001000,
		OF_PROMPT = 0x00002000,
		OF_EXIST = 0x00004000,
		OF_REOPEN = 0x00008000,
		OFS_MAXPATHNAME = 128,
		OR_INVALID_OXID = 1910,
		OR_INVALID_OID = 1911,
		OR_INVALID_SET = 1912,
		OLE_E_OLEVERB = 0x80040000,
		OLE_E_ADVF = 0x80040001,
		OLE_E_ENUM_NOMORE = 0x80040002,
		OLE_E_ADVISENOTSUPPORTED = 0x80040003,
		OLE_E_NOCONNECTION = 0x80040004,
		OLE_E_NOTRUNNING = 0x80040005,
		OLE_E_NOCACHE = 0x80040006,
		OLE_E_BLANK = 0x80040007,
		OLE_E_CLASSDIFF = 0x80040008,
		OLE_E_CANT_GETMONIKER = 0x80040009,
		OLE_E_CANT_BINDTOSOURCE = 0x8004000A,
		OLE_E_STATIC = 0x8004000B,
		OLE_E_PROMPTSAVECANCELLED = 0x8004000C,
		OLE_E_INVALIDRECT = 0x8004000D,
		OLE_E_WRONGCOMPOBJ = 0x8004000E,
		OLE_E_INVALIDHWND = 0x8004000F,
		OLE_E_NOT_INPLACEACTIVE = 0x80040010,
		OLE_E_CANTCONVERT = 0x80040011,
		OLE_E_NOSTORAGE = 0x80040012,
		OLEOBJ_E_FIRST = 0x80040180,
		OLEOBJ_E_LAST = 0x8004018F,
		OLEOBJ_S_FIRST = 0x00040180,
		OLEOBJ_S_LAST = 0x0004018F,
		OLEOBJ_E_NOVERBS = 0x80040180,
		OLEOBJ_E_INVALIDVERB = 0x80040181,
		OLE_S_USEREG = 0x00040000,
		OLE_S_STATIC = 0x00040001,
		OLE_S_MAC_CLIPFORMAT = 0x00040002,
		OLEOBJ_S_INVALIDVERB = 0x00040180,
		OLEOBJ_S_CANNOT_DOVERB_NOW = 0x00040181,
		OLEOBJ_S_INVALIDHWND = 0x00040182,
		OPENCHANNEL = 4110,
		OBJ_PEN = 1,
		OBJ_BRUSH = 2,
		OBJ_DC = 3,
		OBJ_METADC = 4,
		OBJ_PAL = 5,
		OBJ_FONT = 6,
		OBJ_BITMAP = 7,
		OBJ_REGION = 8,
		OBJ_METAFILE = 9,
		OBJ_MEMDC = 10,
		OBJ_EXTPEN = 11,
		OBJ_ENHMETADC = 12,
		OBJ_ENHMETAFILE = 13,
		OUT_DEFAULT_PRECIS = 0,
		OUT_STRING_PRECIS = 1,
		OUT_CHARACTER_PRECIS = 2,
		OUT_STROKE_PRECIS = 3,
		OUT_TT_PRECIS = 4,
		OUT_DEVICE_PRECIS = 5,
		OUT_RASTER_PRECIS = 6,
		OUT_TT_ONLY_PRECIS = 7,
		OUT_OUTLINE_PRECIS = 8,
		OUT_SCREEN_OUTLINE_PRECIS = 9,
		OEM_CHARSET = 255,
		OPAQUE = 2,
		OEM_FIXED_FONT = 10,
		OBJECT_INHERIT_ACE = (0x1),
		OWNER_SECURITY_INFORMATION = (0X00000001),
		ODT_MENU = 1,
		ODT_LISTBOX = 2,
		ODT_COMBOBOX = 3,
		ODT_BUTTON = 4,
		ODT_STATIC = 5,
		ODA_DRAWENTIRE = 0x0001,
		ODA_SELECT = 0x0002,
		ODA_FOCUS = 0x0004,
		ODS_SELECTED = 0x0001,
		ODS_GRAYED = 0x0002,
		ODS_DISABLED = 0x0004,
		ODS_CHECKED = 0x0008,
		ODS_FOCUS = 0x0010,
		ODS_DEFAULT = 0x0020,
		ODS_COMBOBOXEDIT = 0x1000,
		OBM_CLOSE = 32754,
		OBM_UPARROW = 32753,
		OBM_DNARROW = 32752,
		OBM_RGARROW = 32751,
		OBM_LFARROW = 32750,
		OBM_REDUCE = 32749,
		OBM_ZOOM = 32748,
		OBM_RESTORE = 32747,
		OBM_REDUCED = 32746,
		OBM_ZOOMD = 32745,
		OBM_RESTORED = 32744,
		OBM_UPARROWD = 32743,
		OBM_DNARROWD = 32742,
		OBM_RGARROWD = 32741,
		OBM_LFARROWD = 32740,
		OBM_MNARROW = 32739,
		OBM_COMBO = 32738,
		OBM_UPARROWI = 32737,
		OBM_DNARROWI = 32736,
		OBM_RGARROWI = 32735,
		OBM_LFARROWI = 32734,
		OBM_OLD_CLOSE = 32767,
		OBM_SIZE = 32766,
		OBM_OLD_UPARROW = 32765,
		OBM_OLD_DNARROW = 32764,
		OBM_OLD_RGARROW = 32763,
		OBM_OLD_LFARROW = 32762,
		OBM_BTSIZE = 32761,
		OBM_CHECK = 32760,
		OBM_CHECKBOXES = 32759,
		OBM_BTNCORNERS = 32758,
		OBM_OLD_REDUCE = 32757,
		OBM_OLD_ZOOM = 32756,
		OBM_OLD_RESTORE = 32755,
		OCR_NORMAL = 32512,
		OCR_IBEAM = 32513,
		OCR_WAIT = 32514,
		OCR_CROSS = 32515,
		OCR_UP = 32516,
		OCR_SIZE = 32640,
		OCR_ICON = 32641,
		OCR_SIZENWSE = 32642,
		OCR_SIZENESW = 32643,
		OCR_SIZEWE = 32644,
		OCR_SIZENS = 32645,
		OCR_SIZEALL = 32646,
		OCR_ICOCUR = 32647,
		OCR_NO = 32648,
		OCR_APPSTARTING = 32650,
		OIC_SAMPLE = 32512,
		OIC_HAND = 32513,
		OIC_QUES = 32514,
		OIC_BANG = 32515,
		OIC_NOTE = 32516,
		OIC_WINLOGO = 32517,
		OIC_WARNING = 32515,
		OIC_ERROR = 32513,
		OIC_INFORMATION = 32516,
		ORD_LANGDRIVER = 1,
		ODT_HEADER = 100,
		ODT_TAB = 101,
		ODT_LISTVIEW = 102;

    /* RichEdit: constant value */
    int OLEOP_DOVERB = 1;
}
