// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winv {
    int VARIANT_NOVALUEPROP = 0x1,
        VARIANT_ALPHABOOL = 0x2,
        VARIANT_NOUSEROVERRIDE = 0x4,
        VAR_TIMEVALUEONLY = (0x00000001),
        VAR_DATEVALUEONLY = (0x00000002),
        VAR_VALIDDATE = 0x0004,
        VAR_CALENDAR_HIJRI = 0x0008,
        VARIANT_CALENDAR_HIJRI = 0x0008,
        VER_PLATFORM_WIN32s = 0,
        VER_PLATFORM_WIN32_WINDOWS = 1,
        VER_PLATFORM_WIN32_NT = 2,
        VIEW_E_FIRST = 0x80040140,
        VIEW_E_LAST = 0x8004014F,
        VIEW_S_FIRST = 0x00040140,
        VIEW_S_LAST = 0x0004014F,
        VIEW_E_DRAW = 0x80040140,
        VIEW_S_ALREADY_FROZEN = 0x00040140,
        VTA_BASELINE = 24,
        VTA_LEFT = 8,
        VTA_RIGHT = 0,
        VTA_CENTER = 6,
        VTA_BOTTOM = 2,
        VTA_TOP = 0,
        VARIABLE_PITCH = 2,
        VIETNAMESE_CHARSET = 163,
        VERTSIZE = 6,
        VERTRES = 10,
        VREFRESH = 116,
        VALID_INHERIT_FLAGS = (0xF),
        VK_LBUTTON = 0x01,
        VK_RBUTTON = 0x02,
        VK_CANCEL = 0x03,
        VK_MBUTTON = 0x04,
        VK_BACK = 0x08,
        VK_TAB = 0x09,
        VK_CLEAR = 0x0C,
        VK_RETURN = 0x0D,
        VK_SHIFT = 0x10,
        VK_CONTROL = 0x11,
        VK_MENU = 0x12,
        VK_PAUSE = 0x13,
        VK_CAPITAL = 0x14,
        VK_ESCAPE = 0x1B,
        VK_SPACE = 0x20,
        VK_PRIOR = 0x21,
        VK_NEXT = 0x22,
        VK_END = 0x23,
        VK_HOME = 0x24,
        VK_LEFT = 0x25,
        VK_UP = 0x26,
        VK_RIGHT = 0x27,
        VK_DOWN = 0x28,
        VK_SELECT = 0x29,
        VK_PRINT = 0x2A,
        VK_EXECUTE = 0x2B,
        VK_SNAPSHOT = 0x2C,
        VK_INSERT = 0x2D,
        VK_DELETE = 0x2E,
        VK_HELP = 0x2F,
        VK_LWIN = 0x5B,
        VK_RWIN = 0x5C,
        VK_APPS = 0x5D,
        VK_NUMPAD0 = 0x60,
        VK_NUMPAD1 = 0x61,
        VK_NUMPAD2 = 0x62,
        VK_NUMPAD3 = 0x63,
        VK_NUMPAD4 = 0x64,
        VK_NUMPAD5 = 0x65,
        VK_NUMPAD6 = 0x66,
        VK_NUMPAD7 = 0x67,
        VK_NUMPAD8 = 0x68,
        VK_NUMPAD9 = 0x69,
        VK_MULTIPLY = 0x6A,
        VK_ADD = 0x6B,
        VK_SEPARATOR = 0x6C,
        VK_SUBTRACT = 0x6D,
        VK_DECIMAL = 0x6E,
        VK_DIVIDE = 0x6F,
        VK_F1 = 0x70,
        VK_F2 = 0x71,
        VK_F3 = 0x72,
        VK_F4 = 0x73,
        VK_F5 = 0x74,
        VK_F6 = 0x75,
        VK_F7 = 0x76,
        VK_F8 = 0x77,
        VK_F9 = 0x78,
        VK_F10 = 0x79,
        VK_F11 = 0x7A,
        VK_F12 = 0x7B,
        VK_F13 = 0x7C,
        VK_F14 = 0x7D,
        VK_F15 = 0x7E,
        VK_F16 = 0x7F,
        VK_F17 = 0x80,
        VK_F18 = 0x81,
        VK_F19 = 0x82,
        VK_F20 = 0x83,
        VK_F21 = 0x84,
        VK_F22 = 0x85,
        VK_F23 = 0x86,
        VK_F24 = 0x87,
        VK_NUMLOCK = 0x90,
        VK_SCROLL = 0x91,
        VK_LSHIFT = 0xA0,
        VK_RSHIFT = 0xA1,
        VK_LCONTROL = 0xA2,
        VK_RCONTROL = 0xA3,
        VK_LMENU = 0xA4,
        VK_RMENU = 0xA5,
        VK_PROCESSKEY = 0xE5,
        VK_ATTN = 0xF6,
        VK_CRSEL = 0xF7,
        VK_EXSEL = 0xF8,
        VK_EREOF = 0xF9,
        VK_PLAY = 0xFA,
        VK_ZOOM = 0xFB,
        VK_NONAME = 0xFC,
        VK_PA1 = 0xFD,
        VK_OEM_CLEAR = 0xFE,
        VS_FILE_INFO = 16,
        VS_VERSION_INFO = 1,
        VS_USER_DEFINED = 100,
        VS_FFI_SIGNATURE = 0xFEEF04BD,
        VS_FFI_STRUCVERSION = 0x00010000,
        VS_FFI_FILEFLAGSMASK = 0x0000003F,
        VS_FF_DEBUG = 0x00000001,
        VS_FF_PRERELEASE = 0x00000002,
        VS_FF_PATCHED = 0x00000004,
        VS_FF_PRIVATEBUILD = 0x00000008,
        VS_FF_INFOINFERRED = 0x00000010,
        VS_FF_SPECIALBUILD = 0x00000020,
        VOS_UNKNOWN = 0x00000000,
        VOS_DOS = 0x00010000,
        VOS_OS216 = 0x00020000,
        VOS_OS232 = 0x00030000,
        VOS_NT = 0x00040000,
        VOS__BASE = 0x00000000,
        VOS__WINDOWS16 = 0x00000001,
        VOS__PM16 = 0x00000002,
        VOS__PM32 = 0x00000003,
        VOS__WINDOWS32 = 0x00000004,
        VOS_DOS_WINDOWS16 = 0x00010001,
        VOS_DOS_WINDOWS32 = 0x00010004,
        VOS_OS216_PM16 = 0x00020002,
        VOS_OS232_PM32 = 0x00030003,
        VOS_NT_WINDOWS32 = 0x00040004,
        VFT_UNKNOWN = 0x00000000,
        VFT_APP = 0x00000001,
        VFT_DLL = 0x00000002,
        VFT_DRV = 0x00000003,
        VFT_FONT = 0x00000004,
        VFT_VXD = 0x00000005,
        VFT_STATIC_LIB = 0x00000007,
        VFT2_UNKNOWN = 0x00000000,
        VFT2_DRV_PRINTER = 0x00000001,
        VFT2_DRV_KEYBOARD = 0x00000002,
        VFT2_DRV_LANGUAGE = 0x00000003,
        VFT2_DRV_DISPLAY = 0x00000004,
        VFT2_DRV_MOUSE = 0x00000005,
        VFT2_DRV_NETWORK = 0x00000006,
        VFT2_DRV_SYSTEM = 0x00000007,
        VFT2_DRV_INSTALLABLE = 0x00000008,
        VFT2_DRV_SOUND = 0x00000009,
        VFT2_DRV_COMM = 0x0000000A,
        VFT2_DRV_INPUTMETHOD = 0x0000000B,
        VFT2_FONT_RASTER = 0x00000001,
        VFT2_FONT_VECTOR = 0x00000002,
        VFT2_FONT_TRUETYPE = 0x00000003,
        VFFF_ISSHAREDFILE = 0x0001,
        VFF_CURNEDEST = 0x0001,
        VFF_FILEINUSE = 0x0002,
        VFF_BUFFTOOSMALL = 0x0004,
        VIFF_FORCEINSTALL = 0x0001,
        VIFF_DONTDELETEOLD = 0x0002,
        VIF_TEMPFILE = 0x00000001,
        VIF_MISMATCH = 0x00000002,
        VIF_SRCOLD = 0x00000004,
        VIF_DIFFLANG = 0x00000008,
        VIF_DIFFCODEPG = 0x00000010,
        VIF_DIFFTYPE = 0x00000020,
        VIF_WRITEPROT = 0x00000040,
        VIF_FILEINUSE = 0x00000080,
        VIF_OUTOFSPACE = 0x00000100,
        VIF_ACCESSVIOLATION = 0x00000200,
        VIF_SHARINGVIOLATION = 0x00000400,
        VIF_CANNOTCREATE = 0x00000800,
        VIF_CANNOTDELETE = 0x00001000,
        VIF_CANNOTRENAME = 0x00002000,
        VIF_CANNOTDELETECUR = 0x00004000,
        VIF_OUTOFMEMORY = 0x00008000,
        VIF_CANNOTREADSRC = 0x00010000,
        VIF_CANNOTREADDST = 0x00020000,
        VIF_BUFFTOOSMALL = 0x00040000,
        VIEW_LARGEICONS = 0,
        VIEW_SMALLICONS = 1,
        VIEW_LIST = 2,
        VIEW_DETAILS = 3,
        VIEW_SORTNAME = 4,
        VIEW_SORTSIZE = 5,
        VIEW_SORTDATE = 6,
        VIEW_SORTTYPE = 7,
        VIEW_PARENTFOLDER = 8,
        VIEW_NETCONNECT = 9,
        VIEW_NETDISCONNECT = 10,
        VIEW_NEWFOLDER = 11,
        VIEW_VIEWMENU = 12;
}
