// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/** @dll.struct() */
public class BITMAPINFO {
    // bmiHeader was a by-value BITMAPINFOHEADER structure
    public int      bmiHeader_biSize = 40;  // com.ms.dll.DllLib.sizeOf( BITMAPINFOHEADER.class );
    public int      bmiHeader_biWidth;
    public int      bmiHeader_biHeight;
    public short    bmiHeader_biPlanes;
    public short    bmiHeader_biBitCount;
    public int      bmiHeader_biCompression;
    public int      bmiHeader_biSizeImage;
    public int      bmiHeader_biXPelsPerMeter;
    public int      bmiHeader_biYPelsPerMeter;
    public int      bmiHeader_biClrUsed;
    public int      bmiHeader_biClrImportant;

    // bmiColors was an embedded array of RGBQUAD structures
    public byte     bmiColors_rgbBlue;
    public byte     bmiColors_rgbGreen;
    public byte     bmiColors_rgbRed;
    public byte     bmiColors_rgbReserved;
}
