// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

/** @dll.struct() */
public class DRAWITEMSTRUCT_X {
        public int CtlType;
        public int CtlID;
        public int itemID;
        public int itemAction;
        public int itemState;
        public int hwndItem;
        public int hDC;

	    // rcItem was a by-value RECT structure
        public int rcItem_left;
        public int rcItem_top;
        public int rcItem_right;
        public int rcItem_bottom;

        public int itemData;
}