// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/** @dll.struct() */
public class ENUMLOGFONTEX_X {
    // elfLogFont was a by-value LOGFONT structure
    public int      elfLogFont_lfHeight;
    public int      elfLogFont_lfWidth;
    public int      elfLogFont_lfEscapement;
    public int      elfLogFont_lfOrientation;
    public int      elfLogFont_lfWeight;
    public byte     elfLogFont_lfItalic;
    public byte     elfLogFont_lfUnderline;
    public byte     elfLogFont_lfStrikeOut;
    public byte     elfLogFont_lfCharSet;
    public byte     elfLogFont_lfOutPrecision;
    public byte     elfLogFont_lfClipPrecision;
    public byte     elfLogFont_lfQuality;
    public byte     elfLogFont_lfPitchAndFamily;
    /** @dll.structmap([type=TCHAR[32]]) */
    public String   elfLogFont_lfFaceName;

    /** @dll.structmap([type=TCHAR[64]]) */
    public String   elfFullName;
    /** @dll.structmap([type=TCHAR[32]]) */
    public String   elfStyle;
    /** @dll.structmap([type=TCHAR[32]]) */
    public String   elfScript;
}
