// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/**
 * LVCOLUMN_T is useful only for setting column information via Windows
 * messages LVM_SETCOLUMN and LVM_INSERTCOLUMN.
 */

/** @dll.struct(pack=1, auto) */
public class LVCOLUMN_T
{
    public int      mask;
    public int      fmt;
    public int      cx;
    public String   pszText;
    public int      cchTextMax;
    public int      iSubItem;
    public int	    iImage;
    public int      iOrder;
}