// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

/** @dll.struct() */
public class RGBQUAD {
        public byte rgbBlue;
        public byte rgbGreen;
        public byte rgbRed;
        public byte rgbReserved;

        public static int   getBlue( int rgbQuad ) {
            return( rgbQuad & 0xff );
        }

        public static int   getGreen( int rgbQuad ) {
            return( (rgbQuad >> 8) & 0xff );
        }

        public static int   getRed( int rgbQuad ) {
            return( (rgbQuad >> 16) & 0xff );
        }
}

