// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

/** @dll.struct() */
public class SCROLLINFO {
    public int cbSize = 28; //com.ms.dll.DllLib.sizeOf(this);
    public int fMask;
    public int nMin;
    public int nMax;
    public int nPage;
    public int nPos;
    public int nTrackPos;

    public SCROLLINFO() {
    }

    public SCROLLINFO(int mask, int min, int max, int page, int pos) {
        fMask = mask;
        nMin = min;
        nMax = max;
        nPage = page;
        nPos = pos;
    }
}

