// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winh {
    int HDATA_APPOWNED = 0x0001,
        HANGUP_PENDING = 0x04,
        HANGUP_COMPLETE = 0x05,
        HIGH_PRIORITY_CLASS = 0x00000080,
        HANDLE_FLAG_INHERIT = 0x00000001,
        HANDLE_FLAG_PROTECT_FROM_CLOSE = 0x00000002,
        HINSTANCE_ERROR = 32,
        HW_PROFILE_GUIDLEN = 39,
        HP_ALGID = 0x0001,
        HP_HASHVAL = 0x0002,
        HP_HASHSIZE = 0x0004,
        HALFTONE = 4,
        HANGEUL_CHARSET = 129,
        HEBREW_CHARSET = 177,
        HOLLOW_BRUSH = 5,
        HS_HORIZONTAL = 0,
        HS_VERTICAL = 1,
        HS_FDIAGONAL = 2,
        HS_BDIAGONAL = 3,
        HS_CROSS = 4,
        HS_DIAGCROSS = 5,
        HORZSIZE = 4,
        HORZRES = 8,
        HEAP_NO_SERIALIZE = 0x00000001,
        HEAP_GROWABLE = 0x00000002,
        HEAP_GENERATE_EXCEPTIONS = 0x00000004,
        HEAP_ZERO_MEMORY = 0x00000008,
        HEAP_REALLOC_IN_PLACE_ONLY = 0x00000010,
        HEAP_TAIL_CHECKING_ENABLED = 0x00000020,
        HEAP_FREE_CHECKING_ENABLED = 0x00000040,
        HEAP_DISABLE_COALESCE_ON_FREE = 0x00000080,
        HEAP_CREATE_ALIGN_16 = 0x00010000,
        HEAP_CREATE_ENABLE_TRACING = 0x00020000,
        HEAP_MAXIMUM_TAG = 0x0FFF,
        HEAP_PSEUDO_TAG_FLAG = 0x8000,
        HEAP_TAG_SHIFT = 16,
        HIDE_WINDOW = 0,
        HC_ACTION = 0,
        HC_GETNEXT = 1,
        HC_SKIP = 2,
        HC_NOREMOVE = 3,
        HC_NOREM = 3,
        HC_SYSMODALON = 4,
        HC_SYSMODALOFF = 5,
        HCBT_MOVESIZE = 0,
        HCBT_MINMAX = 1,
        HCBT_QS = 2,
        HCBT_CREATEWND = 3,
        HCBT_DESTROYWND = 4,
        HCBT_ACTIVATE = 5,
        HCBT_CLICKSKIPPED = 6,
        HCBT_KEYSKIPPED = 7,
        HCBT_SYSCOMMAND = 8,
        HCBT_SETFOCUS = 9,
        HSHELL_WINDOWCREATED = 1,
        HSHELL_WINDOWDESTROYED = 2,
        HSHELL_ACTIVATESHELLWINDOW = 3,
        HSHELL_WINDOWACTIVATED = 4,
        HSHELL_GETMINRECT = 5,
        HSHELL_REDRAW = 6,
        HSHELL_TASKMAN = 7,
        HSHELL_LANGUAGE = 8,
        HKL_PREV = 0,
        HKL_NEXT = 1,
        HTERROR = (-2),
        HTTRANSPARENT = (-1),
        HTNOWHERE = 0,
        HTCLIENT = 1,
        HTCAPTION = 2,
        HTSYSMENU = 3,
        HTGROWBOX = 4,
        HTSIZE = 4,
        HTMENU = 5,
        HTHSCROLL = 6,
        HTVSCROLL = 7,
        HTMINBUTTON = 8,
        HTMAXBUTTON = 9,
        HTLEFT = 10,
        HTRIGHT = 11,
        HTTOP = 12,
        HTTOPLEFT = 13,
        HTTOPRIGHT = 14,
        HTBOTTOM = 15,
        HTBOTTOMLEFT = 16,
        HTBOTTOMRIGHT = 17,
        HTBORDER = 18,
        HTREDUCE = 8,
        HTZOOM = 9,
        HTSIZEFIRST = 10,
        HTSIZELAST = 17,
        HTOBJECT = 19,
        HTCLOSE = 20,
        HTHELP = 21,
        HOVER_DEFAULT = 0xFFFFFFFF,
        HELPINFO_WINDOW = 0x0001,
        HELPINFO_MENUITEM = 0x0002,
        HELP_CONTEXT = 0x0001,
        HELP_QUIT = 0x0002,
        HELP_INDEX = 0x0003,
        HELP_CONTENTS = 0x0003,
        HELP_HELPONHELP = 0x0004,
        HELP_SETINDEX = 0x0005,
        HELP_SETCONTENTS = 0x0005,
        HELP_CONTEXTPOPUP = 0x0008,
        HELP_FORCEFILE = 0x0009,
        HELP_KEY = 0x0101,
        HELP_COMMAND = 0x0102,
        HELP_PARTIALKEY = 0x0105,
        HELP_MULTIKEY = 0x0201,
        HELP_SETWINPOS = 0x0203,
        HELP_CONTEXTMENU = 0x000a,
        HELP_FINDER = 0x000b,
        HELP_WM_HELP = 0x000c,
        HELP_SETPOPUP_POS = 0x000d,
        HELP_TCARD = 0x8000,
        HELP_TCARD_DATA = 0x0010,
        HELP_TCARD_OTHER_CALLER = 0x0011,
        HCF_HIGHCONTRASTON = 0x00000001,
        HCF_AVAILABLE = 0x00000002,
        HCF_HOTKEYACTIVE = 0x00000004,
        HCF_CONFIRMHOTKEY = 0x00000008,
        HCF_HOTKEYSOUND = 0x00000010,
        HCF_INDICATOR = 0x00000020,
        HCF_HOTKEYAVAILABLE = 0x00000040,
        HDM_FIRST = 0x1200,
        HDN_FIRST = (0-300),
        HDN_LAST = (0-399),
        HDS_HORZ = 0x0000,
        HDS_BUTTONS = 0x0002,
        HDS_HOTTRACK = 0x0004,
        HDS_HIDDEN = 0x0008,
        HDS_DRAGDROP = 0x0040,
        HDS_FULLDRAG = 0x0080,
        HDI_WIDTH = 0x0001,
        HDI_HEIGHT = 0x0001,
        HDI_TEXT = 0x0002,
        HDI_FORMAT = 0x0004,
        HDI_LPARAM = 0x0008,
        HDI_BITMAP = 0x0010,
        HDI_IMAGE = 0x0020,
        HDI_DI_SETITEM = 0x0040,
        HDI_ORDER = 0x0080,
        HDF_LEFT = 0,
        HDF_RIGHT = 1,
        HDF_CENTER = 2,
        HDF_JUSTIFYMASK = 0x0003,
        HDF_RTLREADING = 4,
        HDF_OWNERDRAW = 0x8000,
        HDF_STRING = 0x4000,
        HDF_BITMAP = 0x2000,
        HDF_BITMAP_ON_RIGHT = 0x1000,
        HDF_IMAGE = 0x0800,
        HDM_GETITEMCOUNT = (0x1200+0),
        HDM_INSERTITEMA = (0x1200+1),
        HDM_INSERTITEMW = (0x1200+10),
        HDM_DELETEITEM = (0x1200+2),
        HDM_GETITEMA = (0x1200+3),
        HDM_GETITEMW = (0x1200+11),
        HDM_SETITEMA = (0x1200+4),
        HDM_SETITEMW = (0x1200+12),
        HDM_LAYOUT = (0x1200+5),
        HHT_NOWHERE = 0x0001,
        HHT_ONHEADER = 0x0002,
        HHT_ONDIVIDER = 0x0004,
        HHT_ONDIVOPEN = 0x0008,
        HHT_ABOVE = 0x0100,
        HHT_BELOW = 0x0200,
        HHT_TORIGHT = 0x0400,
        HHT_TOLEFT = 0x0800,
        HDM_HITTEST = (0x1200+6),
        HDM_GETITEMRECT = (0x1200+7),
        HDM_SETIMAGELIST = (0x1200+8),
        HDM_GETIMAGELIST = (0x1200+9),
        HDM_ORDERTOINDEX = (0x1200+15),
        HDM_CREATEDRAGIMAGE = (0x1200+16),
        HDM_GETORDERARRAY = (0x1200+17),
        HDM_SETORDERARRAY = (0x1200+18),
        HDM_SETHOTDIVIDER = (0x1200+19),
        HDN_ITEMCHANGINGA = ((0-300)-0),
        HDN_ITEMCHANGINGW = ((0-300)-20),
        HDN_ITEMCHANGEDA = ((0-300)-1),
        HDN_ITEMCHANGEDW = ((0-300)-21),
        HDN_ITEMCLICKA = ((0-300)-2),
        HDN_ITEMCLICKW = ((0-300)-22),
        HDN_ITEMDBLCLICKA = ((0-300)-3),
        HDN_ITEMDBLCLICKW = ((0-300)-23),
        HDN_DIVIDERDBLCLICKA = ((0-300)-5),
        HDN_DIVIDERDBLCLICKW = ((0-300)-25),
        HDN_BEGINTRACKA = ((0-300)-6),
        HDN_BEGINTRACKW = ((0-300)-26),
        HDN_ENDTRACKA = ((0-300)-7),
        HDN_ENDTRACKW = ((0-300)-27),
        HDN_TRACKA = ((0-300)-8),
        HDN_TRACKW = ((0-300)-28),
        HDN_GETDISPINFOA = ((0-300)-9),
        HDN_GETDISPINFOW = ((0-300)-29),
        HDN_BEGINDRAG = ((0-300)-10),
        HDN_ENDDRAG = ((0-300)-11),
        HIST_BACK = 0,
        HIST_FORWARD = 1,
        HIST_FAVORITES = 2,
        HIST_ADDTOFAVORITES = 3,
        HIST_VIEWTREE = 4,
        HOTKEYF_SHIFT = 0x01,
        HOTKEYF_CONTROL = 0x02,
        HOTKEYF_ALT = 0x04,
        HOTKEYF_EXT = 0x08,
        HKCOMB_NONE = 0x0001,
        HKCOMB_S = 0x0002,
        HKCOMB_C = 0x0004,
        HKCOMB_A = 0x0008,
        HKCOMB_SC = 0x0010,
        HKCOMB_SA = 0x0020,
        HKCOMB_CA = 0x0040,
        HKCOMB_SCA = 0x0080,
        HKM_SETHOTKEY = (0x0400+1),
        HKM_GETHOTKEY = (0x0400+2),
        HKM_SETRULES = (0x0400+3),
        HWND_TOP = 0,
        HWND_BOTTOM = 1,
        HWND_TOPMOST = -1,
        HWND_NOTOPMOST = -2,
        HICF_OTHER = 0x00000000,
        HICF_MOUSE = 0x00000001,
        HICF_ARROWKEYS = 0x00000002,
        HICF_ACCELERATOR = 0x00000004,
        HICF_DUPACCEL = 0x00000008,
        HICF_ENTERING = 0x00000010,
        HICF_LEAVING = 0x00000020,
        HICF_RESELECT = 0x00000040,
        HICF_TOGGLEDROPDOWN = 0x00000100,
        HINST_COMMCTRL = -1;
}
