// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winj {
	int JOYERR_BASE = 160,
		JOYERR_NOERROR = (0),
		JOYERR_PARMS = (160+5),
		JOYERR_NOCANDO = (160+6),
		JOYERR_UNPLUGGED = (160+7),
		JOY_BUTTON1 = 0x0001,
		JOY_BUTTON2 = 0x0002,
		JOY_BUTTON3 = 0x0004,
		JOY_BUTTON4 = 0x0008,
		JOY_BUTTON1CHG = 0x0100,
		JOY_BUTTON2CHG = 0x0200,
		JOY_BUTTON3CHG = 0x0400,
		JOY_BUTTON4CHG = 0x0800,
		JOY_BUTTON5 = 0x00000010,
		JOY_BUTTON6 = 0x00000020,
		JOY_BUTTON7 = 0x00000040,
		JOY_BUTTON8 = 0x00000080,
		JOY_BUTTON9 = 0x00000100,
		JOY_BUTTON10 = 0x00000200,
		JOY_BUTTON11 = 0x00000400,
		JOY_BUTTON12 = 0x00000800,
		JOY_BUTTON13 = 0x00001000,
		JOY_BUTTON14 = 0x00002000,
		JOY_BUTTON15 = 0x00004000,
		JOY_BUTTON16 = 0x00008000,
		JOY_BUTTON17 = 0x00010000,
		JOY_BUTTON18 = 0x00020000,
		JOY_BUTTON19 = 0x00040000,
		JOY_BUTTON20 = 0x00080000,
		JOY_BUTTON21 = 0x00100000,
		JOY_BUTTON22 = 0x00200000,
		JOY_BUTTON23 = 0x00400000,
		JOY_BUTTON24 = 0x00800000,
		JOY_BUTTON25 = 0x01000000,
		JOY_BUTTON26 = 0x02000000,
		JOY_BUTTON27 = 0x04000000,
		JOY_BUTTON28 = 0x08000000,
		JOY_BUTTON29 = 0x10000000,
		JOY_BUTTON30 = 0x20000000,
		JOY_BUTTON31 = 0x40000000,
		JOY_BUTTON32 = 0x80000000,
		JOY_POVFORWARD = 0,
		JOY_POVRIGHT = 9000,
		JOY_POVBACKWARD = 18000,
		JOY_POVLEFT = 27000,
		JOY_RETURNX = 0x00000001,
		JOY_RETURNY = 0x00000002,
		JOY_RETURNZ = 0x00000004,
		JOY_RETURNR = 0x00000008,
		JOY_RETURNU = 0x00000010,
		JOY_RETURNV = 0x00000020,
		JOY_RETURNPOV = 0x00000040,
		JOY_RETURNBUTTONS = 0x00000080,
		JOY_RETURNRAWDATA = 0x00000100,
		JOY_RETURNPOVCTS = 0x00000200,
		JOY_RETURNCENTERED = 0x00000400,
		JOY_USEDEADZONE = 0x00000800,
		JOY_CAL_READALWAYS = 0x00010000,
		JOY_CAL_READXYONLY = 0x00020000,
		JOY_CAL_READ3 = 0x00040000,
		JOY_CAL_READ4 = 0x00080000,
		JOY_CAL_READXONLY = 0x00100000,
		JOY_CAL_READYONLY = 0x00200000,
		JOY_CAL_READ5 = 0x00400000,
		JOY_CAL_READ6 = 0x00800000,
		JOY_CAL_READZONLY = 0x01000000,
		JOY_CAL_READRONLY = 0x02000000,
		JOY_CAL_READUONLY = 0x04000000,
		JOY_CAL_READVONLY = 0x08000000,
		JOYSTICKID1 = 0,
		JOYSTICKID2 = 1,
		JOYCAPS_HASZ = 0x0001,
		JOYCAPS_HASR = 0x0002,
		JOYCAPS_HASU = 0x0004,
		JOYCAPS_HASV = 0x0008,
		JOYCAPS_HASPOV = 0x0010,
		JOYCAPS_POV4DIR = 0x0020,
		JOYCAPS_POVCTS = 0x0040,
		JOHAB_CHARSET = 130,
		JOB_CONTROL_PAUSE = 1,
		JOB_CONTROL_RESUME = 2,
		JOB_CONTROL_CANCEL = 3,
		JOB_CONTROL_RESTART = 4,
		JOB_CONTROL_DELETE = 5,
		JOB_CONTROL_SENT_TO_PRINTER = 6,
		JOB_CONTROL_LAST_PAGE_EJECTED = 7,
		JOB_STATUS_PAUSED = 0x00000001,
		JOB_STATUS_ERROR = 0x00000002,
		JOB_STATUS_DELETING = 0x00000004,
		JOB_STATUS_SPOOLING = 0x00000008,
		JOB_STATUS_PRINTING = 0x00000010,
		JOB_STATUS_OFFLINE = 0x00000020,
		JOB_STATUS_PAPEROUT = 0x00000040,
		JOB_STATUS_PRINTED = 0x00000080,
		JOB_STATUS_DELETED = 0x00000100,
		JOB_STATUS_BLOCKED_DEVQ = 0x00000200,
		JOB_STATUS_USER_INTERVENTION = 0x00000400,
		JOB_STATUS_RESTART = 0x00000800,
		JOB_POSITION_UNSPECIFIED = 0,
		JOB_NOTIFY_TYPE = 0x01,
		JOB_NOTIFY_FIELD_PRINTER_NAME = 0x00,
		JOB_NOTIFY_FIELD_MACHINE_NAME = 0x01,
		JOB_NOTIFY_FIELD_PORT_NAME = 0x02,
		JOB_NOTIFY_FIELD_USER_NAME = 0x03,
		JOB_NOTIFY_FIELD_NOTIFY_NAME = 0x04,
		JOB_NOTIFY_FIELD_DATATYPE = 0x05,
		JOB_NOTIFY_FIELD_PRINT_PROCESSOR = 0x06,
		JOB_NOTIFY_FIELD_PARAMETERS = 0x07,
		JOB_NOTIFY_FIELD_DRIVER_NAME = 0x08,
		JOB_NOTIFY_FIELD_DEVMODE = 0x09,
		JOB_NOTIFY_FIELD_STATUS = 0x0A,
		JOB_NOTIFY_FIELD_STATUS_STRING = 0x0B,
		JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 0x0C,
		JOB_NOTIFY_FIELD_DOCUMENT = 0x0D,
		JOB_NOTIFY_FIELD_PRIORITY = 0x0E,
		JOB_NOTIFY_FIELD_POSITION = 0x0F,
		JOB_NOTIFY_FIELD_SUBMITTED = 0x10,
		JOB_NOTIFY_FIELD_START_TIME = 0x11,
		JOB_NOTIFY_FIELD_UNTIL_TIME = 0x12,
		JOB_NOTIFY_FIELD_TIME = 0x13,
		JOB_NOTIFY_FIELD_TOTAL_PAGES = 0x14,
		JOB_NOTIFY_FIELD_PAGES_PRINTED = 0x15,
		JOB_NOTIFY_FIELD_TOTAL_BYTES = 0x16,
		JOB_NOTIFY_FIELD_BYTES_PRINTED = 0x17,
		JOB_ACCESS_ADMINISTER = 0x00000010;

}
