// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winm {
    int MSGF_DDEMGR = 0x8001,
        MH_CREATE = 1,
        MH_KEEP = 2,
        MH_DELETE = 3,
        MH_CLEANUP = 4,
        MAX_MONITORS = 4,
        MF_HSZ_INFO = 0x01000000,
        MF_SENDMSGS = 0x02000000,
        MF_POSTMSGS = 0x04000000,
        MF_CALLBACKS = 0x08000000,
        MF_ERRORS = 0x10000000,
        MF_LINKS = 0x20000000,
        MF_CONV = 0x40000000,
        MF_MASK = 0xFF000000,
        MULTIFILEOPENORD = 1537,
        MOD_ALT = 0x0001,
        MOD_CONTROL = 0x0002,
        MOD_SHIFT = 0x0004,
        MOD_LEFT = 0x8000,
        MOD_RIGHT = 0x4000,
        MOD_ON_KEYUP = 0x0800,
        MOD_IGNORE_ALL_MODIFIER = 0x0400,
        MDMVOLFLAG_LOW = 0x00000001,
        MDMVOLFLAG_MEDIUM = 0x00000002,
        MDMVOLFLAG_HIGH = 0x00000004,
        MDMVOL_LOW = 0x00000000,
        MDMVOL_MEDIUM = 0x00000001,
        MDMVOL_HIGH = 0x00000002,
        MDMSPKRFLAG_OFF = 0x00000001,
        MDMSPKRFLAG_DIAL = 0x00000002,
        MDMSPKRFLAG_ON = 0x00000004,
        MDMSPKRFLAG_CALLSETUP = 0x00000008,
        MDMSPKR_OFF = 0x00000000,
        MDMSPKR_DIAL = 0x00000001,
        MDMSPKR_ON = 0x00000002,
        MDMSPKR_CALLSETUP = 0x00000003,
        MDM_COMPRESSION = 0x00000001,
        MDM_ERROR_CONTROL = 0x00000002,
        MDM_FORCED_EC = 0x00000004,
        MDM_CELLULAR = 0x00000008,
        MDM_FLOWCONTROL_HARD = 0x00000010,
        MDM_FLOWCONTROL_SOFT = 0x00000020,
        MDM_CCITT_OVERRIDE = 0x00000040,
        MDM_SPEED_ADJUST = 0x00000080,
        MDM_TONE_DIAL = 0x00000100,
        MDM_BLIND_DIAL = 0x00000200,
        MDM_V23_OVERRIDE = 0x00000400,
        MAXPNAMELEN = 32,
        MAXERRORLENGTH = 256,
        MAX_JOYSTICKOEMVXDNAME = 260,
        MM_MICROSOFT = 1,
        MM_MIDI_MAPPER = 1,
        MM_WAVE_MAPPER = 2,
        MM_SNDBLST_MIDIOUT = 3,
        MM_SNDBLST_MIDIIN = 4,
        MM_SNDBLST_SYNTH = 5,
        MM_SNDBLST_WAVEOUT = 6,
        MM_SNDBLST_WAVEIN = 7,
        MM_ADLIB = 9,
        MM_MPU401_MIDIOUT = 10,
        MM_MPU401_MIDIIN = 11,
        MM_PC_JOYSTICK = 12,
        MM_JOY1MOVE = 0x3A0,
        MM_JOY2MOVE = 0x3A1,
        MM_JOY1ZMOVE = 0x3A2,
        MM_JOY2ZMOVE = 0x3A3,
        MM_JOY1BUTTONDOWN = 0x3B5,
        MM_JOY2BUTTONDOWN = 0x3B6,
        MM_JOY1BUTTONUP = 0x3B7,
        MM_JOY2BUTTONUP = 0x3B8,
        MM_MCINOTIFY = 0x3B9,
        MM_WOM_OPEN = 0x3BB,
        MM_WOM_CLOSE = 0x3BC,
        MM_WOM_DONE = 0x3BD,
        MM_WIM_OPEN = 0x3BE,
        MM_WIM_CLOSE = 0x3BF,
        MM_WIM_DATA = 0x3C0,
        MM_MIM_OPEN = 0x3C1,
        MM_MIM_CLOSE = 0x3C2,
        MM_MIM_DATA = 0x3C3,
        MM_MIM_LONGDATA = 0x3C4,
        MM_MIM_ERROR = 0x3C5,
        MM_MIM_LONGERROR = 0x3C6,
        MM_MOM_OPEN = 0x3C7,
        MM_MOM_CLOSE = 0x3C8,
        MM_MOM_DONE = 0x3C9,
        MM_DRVM_OPEN = 0x3D0,
        MM_DRVM_CLOSE = 0x3D1,
        MM_DRVM_DATA = 0x3D2,
        MM_DRVM_ERROR = 0x3D3,
        MM_STREAM_OPEN = 0x3D4,
        MM_STREAM_CLOSE = 0x3D5,
        MM_STREAM_DONE = 0x3D6,
        MM_STREAM_ERROR = 0x3D7,
        MM_MOM_POSITIONCB = 0x3CA,
        MM_MCISIGNAL = 0x3CB,
        MM_MIM_MOREDATA = 0x3CC,
        MM_MIXM_LINE_CHANGE = 0x3D0,
        MM_MIXM_CONTROL_CHANGE = 0x3D1,
        MMSYSERR_BASE = 0,
        MIDIERR_BASE = 64,
        MCIERR_BASE = 256,
        MIXERR_BASE = 1024,
        MCI_STRING_OFFSET = 512,
        MCI_VD_OFFSET = 1024,
        MCI_CD_OFFSET = 1088,
        MCI_WAVE_OFFSET = 1152,
        MCI_SEQ_OFFSET = 1216,
        MMSYSERR_NOERROR = 0,
        MMSYSERR_ERROR = (0+1),
        MMSYSERR_BADDEVICEID = (0+2),
        MMSYSERR_NOTENABLED = (0+3),
        MMSYSERR_ALLOCATED = (0+4),
        MMSYSERR_INVALHANDLE = (0+5),
        MMSYSERR_NODRIVER = (0+6),
        MMSYSERR_NOMEM = (0+7),
        MMSYSERR_NOTSUPPORTED = (0+8),
        MMSYSERR_BADERRNUM = (0+9),
        MMSYSERR_INVALFLAG = (0+10),
        MMSYSERR_INVALPARAM = (0+11),
        MMSYSERR_HANDLEBUSY = (0+12),
        MMSYSERR_INVALIDALIAS = (0+13),
        MMSYSERR_BADDB = (0+14),
        MMSYSERR_KEYNOTFOUND = (0+15),
        MMSYSERR_READERROR = (0+16),
        MMSYSERR_WRITEERROR = (0+17),
        MMSYSERR_DELETEERROR = (0+18),
        MMSYSERR_VALNOTFOUND = (0+19),
        MMSYSERR_NODRIVERCB = (0+20),
        MMSYSERR_LASTERROR = (0+20),
        MIDIERR_UNPREPARED = (64+0),
        MIDIERR_STILLPLAYING = (64+1),
        MIDIERR_NOMAP = (64+2),
        MIDIERR_NOTREADY = (64+3),
        MIDIERR_NODEVICE = (64+4),
        MIDIERR_INVALIDSETUP = (64+5),
        MIDIERR_BADOPENMODE = (64+6),
        MIDIERR_DONT_CONTINUE = (64+7),
        MIDIERR_LASTERROR = (64+7),
        MIDIPATCHSIZE = 128,
        MIM_OPEN = 0x3C1,
        MIM_CLOSE = 0x3C2,
        MIM_DATA = 0x3C3,
        MIM_LONGDATA = 0x3C4,
        MIM_ERROR = 0x3C5,
        MIM_LONGERROR = 0x3C6,
        MOM_OPEN = 0x3C7,
        MOM_CLOSE = 0x3C8,
        MOM_DONE = 0x3C9,
        MIM_MOREDATA = 0x3CC,
        MOM_POSITIONCB = 0x3CA,
        MIDI_IO_STATUS = 0x00000020,
        MIDI_CACHE_ALL = 1,
        MIDI_CACHE_BESTFIT = 2,
        MIDI_CACHE_QUERY = 3,
        MIDI_UNCACHE = 4,
        MOD_MIDIPORT = 1,
        MOD_SYNTH = 2,
        MOD_SQSYNTH = 3,
        MOD_FMSYNTH = 4,
        MOD_MAPPER = 5,
        MIDICAPS_VOLUME = 0x0001,
        MIDICAPS_LRVOLUME = 0x0002,
        MIDICAPS_CACHE = 0x0004,
        MIDICAPS_STREAM = 0x0008,
        MHDR_DONE = 0x00000001,
        MHDR_PREPARED = 0x00000002,
        MHDR_INQUEUE = 0x00000004,
        MHDR_ISSTRM = 0x00000008,
        MEVT_F_SHORT = 0x00000000,
        MEVT_F_LONG = 0x80000000,
        MEVT_F_CALLBACK = 0x40000000,
        MEVT_SHORTMSG = (0x00),
        MEVT_TEMPO = (0x01),
        MEVT_NOP = (0x02),
        MEVT_LONGMSG = (0x80),
        MEVT_COMMENT = (0x82),
        MEVT_VERSION = (0x84),
        MIDISTRM_ERROR = (-2),
        MIDIPROP_SET = 0x80000000,
        MIDIPROP_GET = 0x40000000,
        MIDIPROP_TIMEDIV = 0x00000001,
        MIDIPROP_TEMPO = 0x00000002,
        MIXER_SHORT_NAME_CHARS = 16,
        MIXER_LONG_NAME_CHARS = 64,
        MIXERR_INVALLINE = (1024+0),
        MIXERR_INVALCONTROL = (1024+1),
        MIXERR_INVALVALUE = (1024+2),
        MIXERR_LASTERROR = (1024+2),
        MIXER_OBJECTF_HANDLE = 0x80000000,
        MIXER_OBJECTF_MIXER = 0x00000000,
        MIXER_OBJECTF_HMIXER = (0x80000000|0x00000000),
        MIXER_OBJECTF_WAVEOUT = 0x10000000,
        MIXER_OBJECTF_HWAVEOUT = (0x80000000|0x10000000),
        MIXER_OBJECTF_WAVEIN = 0x20000000,
        MIXER_OBJECTF_HWAVEIN = (0x80000000|0x20000000),
        MIXER_OBJECTF_MIDIOUT = 0x30000000,
        MIXER_OBJECTF_HMIDIOUT = (0x80000000|0x30000000),
        MIXER_OBJECTF_MIDIIN = 0x40000000,
        MIXER_OBJECTF_HMIDIIN = (0x80000000|0x40000000),
        MIXER_OBJECTF_AUX = 0x50000000,
        MIXERLINE_LINEF_ACTIVE = 0x00000001,
        MIXERLINE_LINEF_DISCONNECTED = 0x00008000,
        MIXERLINE_LINEF_SOURCE = 0x80000000,
        MIXERLINE_COMPONENTTYPE_DST_FIRST = 0x00000000,
        MIXERLINE_COMPONENTTYPE_DST_UNDEFINED = (0x00000000+0),
        MIXERLINE_COMPONENTTYPE_DST_DIGITAL = (0x00000000+1),
        MIXERLINE_COMPONENTTYPE_DST_LINE = (0x00000000+2),
        MIXERLINE_COMPONENTTYPE_DST_MONITOR = (0x00000000+3),
        MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = (0x00000000+4),
        MIXERLINE_COMPONENTTYPE_DST_HEADPHONES = (0x00000000+5),
        MIXERLINE_COMPONENTTYPE_DST_TELEPHONE = (0x00000000+6),
        MIXERLINE_COMPONENTTYPE_DST_WAVEIN = (0x00000000+7),
        MIXERLINE_COMPONENTTYPE_DST_VOICEIN = (0x00000000+8),
        MIXERLINE_COMPONENTTYPE_DST_LAST = (0x00000000+8),
        MIXERLINE_COMPONENTTYPE_SRC_FIRST = 0x00001000,
        MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED = (0x00001000+0),
        MIXERLINE_COMPONENTTYPE_SRC_DIGITAL = (0x00001000+1),
        MIXERLINE_COMPONENTTYPE_SRC_LINE = (0x00001000+2),
        MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE = (0x00001000+3),
        MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER = (0x00001000+4),
        MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC = (0x00001000+5),
        MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE = (0x00001000+6),
        MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER = (0x00001000+7),
        MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT = (0x00001000+8),
        MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY = (0x00001000+9),
        MIXERLINE_COMPONENTTYPE_SRC_ANALOG = (0x00001000+10),
        MIXERLINE_COMPONENTTYPE_SRC_LAST = (0x00001000+10),
        MIXERLINE_TARGETTYPE_UNDEFINED = 0,
        MIXERLINE_TARGETTYPE_WAVEOUT = 1,
        MIXERLINE_TARGETTYPE_WAVEIN = 2,
        MIXERLINE_TARGETTYPE_MIDIOUT = 3,
        MIXERLINE_TARGETTYPE_MIDIIN = 4,
        MIXERLINE_TARGETTYPE_AUX = 5,
        MIXER_GETLINEINFOF_DESTINATION = 0x00000000,
        MIXER_GETLINEINFOF_SOURCE = 0x00000001,
        MIXER_GETLINEINFOF_LINEID = 0x00000002,
        MIXER_GETLINEINFOF_COMPONENTTYPE = 0x00000003,
        MIXER_GETLINEINFOF_TARGETTYPE = 0x00000004,
        MIXER_GETLINEINFOF_QUERYMASK = 0x0000000F,
        MIXERCONTROL_CONTROLF_UNIFORM = 0x00000001,
        MIXERCONTROL_CONTROLF_MULTIPLE = 0x00000002,
        MIXERCONTROL_CONTROLF_DISABLED = 0x80000000,
        MIXERCONTROL_CT_CLASS_MASK = 0xF0000000,
        MIXERCONTROL_CT_CLASS_CUSTOM = 0x00000000,
        MIXERCONTROL_CT_CLASS_METER = 0x10000000,
        MIXERCONTROL_CT_CLASS_SWITCH = 0x20000000,
        MIXERCONTROL_CT_CLASS_NUMBER = 0x30000000,
        MIXERCONTROL_CT_CLASS_SLIDER = 0x40000000,
        MIXERCONTROL_CT_CLASS_FADER = 0x50000000,
        MIXERCONTROL_CT_CLASS_TIME = 0x60000000,
        MIXERCONTROL_CT_CLASS_LIST = 0x70000000,
        MIXERCONTROL_CT_SUBCLASS_MASK = 0x0F000000,
        MIXERCONTROL_CT_SC_SWITCH_BOOLEAN = 0x00000000,
        MIXERCONTROL_CT_SC_SWITCH_BUTTON = 0x01000000,
        MIXERCONTROL_CT_SC_METER_POLLED = 0x00000000,
        MIXERCONTROL_CT_SC_TIME_MICROSECS = 0x00000000,
        MIXERCONTROL_CT_SC_TIME_MILLISECS = 0x01000000,
        MIXERCONTROL_CT_SC_LIST_SINGLE = 0x00000000,
        MIXERCONTROL_CT_SC_LIST_MULTIPLE = 0x01000000,
        MIXERCONTROL_CT_UNITS_MASK = 0x00FF0000,
        MIXERCONTROL_CT_UNITS_CUSTOM = 0x00000000,
        MIXERCONTROL_CT_UNITS_BOOLEAN = 0x00010000,
        MIXERCONTROL_CT_UNITS_SIGNED = 0x00020000,
        MIXERCONTROL_CT_UNITS_UNSIGNED = 0x00030000,
        MIXERCONTROL_CT_UNITS_DECIBELS = 0x00040000,
        MIXERCONTROL_CT_UNITS_PERCENT = 0x00050000,
        MIXERCONTROL_CONTROLTYPE_CUSTOM = (0x00000000|0x00000000),
        MIXERCONTROL_CONTROLTYPE_BOOLEANMETER = (0x10000000|0x00000000|0x00010000),
        MIXERCONTROL_CONTROLTYPE_SIGNEDMETER = (0x10000000|0x00000000|0x00020000),
        MIXERCONTROL_CONTROLTYPE_PEAKMETER = ((0x10000000|0x00000000|0x00020000)+1),
        MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER = (0x10000000|0x00000000|0x00030000),
        MIXERCONTROL_CONTROLTYPE_BOOLEAN = (0x20000000|0x00000000|0x00010000),
        MIXERCONTROL_CONTROLTYPE_ONOFF = ((0x20000000|0x00000000|0x00010000)+1),
        MIXERCONTROL_CONTROLTYPE_MUTE = ((0x20000000|0x00000000|0x00010000)+2),
        MIXERCONTROL_CONTROLTYPE_MONO = ((0x20000000|0x00000000|0x00010000)+3),
        MIXERCONTROL_CONTROLTYPE_LOUDNESS = ((0x20000000|0x00000000|0x00010000)+4),
        MIXERCONTROL_CONTROLTYPE_STEREOENH = ((0x20000000|0x00000000|0x00010000)+5),
        MIXERCONTROL_CONTROLTYPE_BUTTON = (0x20000000|0x01000000|0x00010000),
        MIXERCONTROL_CONTROLTYPE_DECIBELS = (0x30000000|0x00040000),
        MIXERCONTROL_CONTROLTYPE_SIGNED = (0x30000000|0x00020000),
        MIXERCONTROL_CONTROLTYPE_UNSIGNED = (0x30000000|0x00030000),
        MIXERCONTROL_CONTROLTYPE_PERCENT = (0x30000000|0x00050000),
        MIXERCONTROL_CONTROLTYPE_SLIDER = (0x40000000|0x00020000),
        MIXERCONTROL_CONTROLTYPE_PAN = ((0x40000000|0x00020000)+1),
        MIXERCONTROL_CONTROLTYPE_QSOUNDPAN = ((0x40000000|0x00020000)+2),
        MIXERCONTROL_CONTROLTYPE_FADER = (0x50000000|0x00030000),
        MIXERCONTROL_CONTROLTYPE_VOLUME = ((0x50000000|0x00030000)+1),
        MIXERCONTROL_CONTROLTYPE_BASS = ((0x50000000|0x00030000)+2),
        MIXERCONTROL_CONTROLTYPE_TREBLE = ((0x50000000|0x00030000)+3),
        MIXERCONTROL_CONTROLTYPE_EQUALIZER = ((0x50000000|0x00030000)+4),
        MIXERCONTROL_CONTROLTYPE_SINGLESELECT = (0x70000000|0x00000000|0x00010000),
        MIXERCONTROL_CONTROLTYPE_MUX = ((0x70000000|0x00000000|0x00010000)+1),
        MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT = (0x70000000|0x01000000|0x00010000),
        MIXERCONTROL_CONTROLTYPE_MIXER = ((0x70000000|0x01000000|0x00010000)+1),
        MIXERCONTROL_CONTROLTYPE_MICROTIME = (0x60000000|0x00000000|0x00030000),
        MIXERCONTROL_CONTROLTYPE_MILLITIME = (0x60000000|0x01000000|0x00030000),
        MIXER_GETLINECONTROLSF_ALL = 0x00000000,
        MIXER_GETLINECONTROLSF_ONEBYID = 0x00000001,
        MIXER_GETLINECONTROLSF_ONEBYTYPE = 0x00000002,
        MIXER_GETLINECONTROLSF_QUERYMASK = 0x0000000F,
        MIXER_GETCONTROLDETAILSF_VALUE = 0x00000000,
        MIXER_GETCONTROLDETAILSF_LISTTEXT = 0x00000001,
        MIXER_GETCONTROLDETAILSF_QUERYMASK = 0x0000000F,
        MIXER_SETCONTROLDETAILSF_VALUE = 0x00000000,
        MIXER_SETCONTROLDETAILSF_CUSTOM = 0x00000001,
        MIXER_SETCONTROLDETAILSF_QUERYMASK = 0x0000000F,
        MMIOERR_BASE = 256,
        MMIOERR_FILENOTFOUND = (256+1),
        MMIOERR_OUTOFMEMORY = (256+2),
        MMIOERR_CANNOTOPEN = (256+3),
        MMIOERR_CANNOTCLOSE = (256+4),
        MMIOERR_CANNOTREAD = (256+5),
        MMIOERR_CANNOTWRITE = (256+6),
        MMIOERR_CANNOTSEEK = (256+7),
        MMIOERR_CANNOTEXPAND = (256+8),
        MMIOERR_CHUNKNOTFOUND = (256+9),
        MMIOERR_UNBUFFERED = (256+10),
        MMIOERR_PATHNOTFOUND = (256+11),
        MMIOERR_ACCESSDENIED = (256+12),
        MMIOERR_SHARINGVIOLATION = (256+13),
        MMIOERR_NETWORKERROR = (256+14),
        MMIOERR_TOOMANYOPENFILES = (256+15),
        MMIOERR_INVALIDFILE = (256+16),
        MMIO_RWMODE = 0x00000003,
        MMIO_SHAREMODE = 0x00000070,
        MMIO_CREATE = 0x00001000,
        MMIO_PARSE = 0x00000100,
        MMIO_DELETE = 0x00000200,
        MMIO_EXIST = 0x00004000,
        MMIO_ALLOCBUF = 0x00010000,
        MMIO_GETTEMP = 0x00020000,
        MMIO_DIRTY = 0x10000000,
        MMIO_READ = 0x00000000,
        MMIO_WRITE = 0x00000001,
        MMIO_READWRITE = 0x00000002,
        MMIO_COMPAT = 0x00000000,
        MMIO_EXCLUSIVE = 0x00000010,
        MMIO_DENYWRITE = 0x00000020,
        MMIO_DENYREAD = 0x00000030,
        MMIO_DENYNONE = 0x00000040,
        MMIO_FHOPEN = 0x0010,
        MMIO_EMPTYBUF = 0x0010,
        MMIO_TOUPPER = 0x0010,
        MMIO_INSTALLPROC = 0x00010000,
        MMIO_GLOBALPROC = 0x10000000,
        MMIO_REMOVEPROC = 0x00020000,
        MMIO_UNICODEPROC = 0x01000000,
        MMIO_FINDPROC = 0x00040000,
        MMIO_FINDCHUNK = 0x0010,
        MMIO_FINDRIFF = 0x0020,
        MMIO_FINDLIST = 0x0040,
        MMIO_CREATERIFF = 0x0020,
        MMIO_CREATELIST = 0x0040,
        MMIOM_READ = 0x00000000,
        MMIOM_WRITE = 0x00000001,
        MMIOM_SEEK = 2,
        MMIOM_OPEN = 3,
        MMIOM_CLOSE = 4,
        MMIOM_WRITEFLUSH = 5,
        MMIOM_RENAME = 6,
        MMIOM_USER = 0x8000,
        MMIO_DEFAULTBUFFER = 8192,
        MCIERR_INVALID_DEVICE_ID = (256+1),
        MCIERR_UNRECOGNIZED_KEYWORD = (256+3),
        MCIERR_UNRECOGNIZED_COMMAND = (256+5),
        MCIERR_HARDWARE = (256+6),
        MCIERR_INVALID_DEVICE_NAME = (256+7),
        MCIERR_OUT_OF_MEMORY = (256+8),
        MCIERR_DEVICE_OPEN = (256+9),
        MCIERR_CANNOT_LOAD_DRIVER = (256+10),
        MCIERR_MISSING_COMMAND_STRING = (256+11),
        MCIERR_PARAM_OVERFLOW = (256+12),
        MCIERR_MISSING_STRING_ARGUMENT = (256+13),
        MCIERR_BAD_INTEGER = (256+14),
        MCIERR_PARSER_INTERNAL = (256+15),
        MCIERR_DRIVER_INTERNAL = (256+16),
        MCIERR_MISSING_PARAMETER = (256+17),
        MCIERR_UNSUPPORTED_FUNCTION = (256+18),
        MCIERR_FILE_NOT_FOUND = (256+19),
        MCIERR_DEVICE_NOT_READY = (256+20),
        MCIERR_INTERNAL = (256+21),
        MCIERR_DRIVER = (256+22),
        MCIERR_CANNOT_USE_ALL = (256+23),
        MCIERR_MULTIPLE = (256+24),
        MCIERR_EXTENSION_NOT_FOUND = (256+25),
        MCIERR_OUTOFRANGE = (256+26),
        MCIERR_FLAGS_NOT_COMPATIBLE = (256+28),
        MCIERR_FILE_NOT_SAVED = (256+30),
        MCIERR_DEVICE_TYPE_REQUIRED = (256+31),
        MCIERR_DEVICE_LOCKED = (256+32),
        MCIERR_DUPLICATE_ALIAS = (256+33),
        MCIERR_MUST_USE_SHAREABLE = (256+35),
        MCIERR_MISSING_DEVICE_NAME = (256+36),
        MCIERR_BAD_TIME_FORMAT = (256+37),
        MCIERR_NO_CLOSING_QUOTE = (256+38),
        MCIERR_DUPLICATE_FLAGS = (256+39),
        MCIERR_INVALID_FILE = (256+40),
        MCIERR_NULL_PARAMETER_BLOCK = (256+41),
        MCIERR_UNNAMED_RESOURCE = (256+42),
        MCIERR_NEW_REQUIRES_ALIAS = (256+43),
        MCIERR_NOTIFY_ON_AUTO_OPEN = (256+44),
        MCIERR_NO_ELEMENT_ALLOWED = (256+45),
        MCIERR_NONAPPLICABLE_FUNCTION = (256+46),
        MCIERR_ILLEGAL_FOR_AUTO_OPEN = (256+47),
        MCIERR_FILENAME_REQUIRED = (256+48),
        MCIERR_EXTRA_CHARACTERS = (256+49),
        MCIERR_DEVICE_NOT_INSTALLED = (256+50),
        MCIERR_GET_CD = (256+51),
        MCIERR_SET_CD = (256+52),
        MCIERR_SET_DRIVE = (256+53),
        MCIERR_DEVICE_LENGTH = (256+54),
        MCIERR_DEVICE_ORD_LENGTH = (256+55),
        MCIERR_NO_INTEGER = (256+56),
        MCIERR_WAVE_OUTPUTSINUSE = (256+64),
        MCIERR_WAVE_SETOUTPUTINUSE = (256+65),
        MCIERR_WAVE_INPUTSINUSE = (256+66),
        MCIERR_WAVE_SETINPUTINUSE = (256+67),
        MCIERR_WAVE_OUTPUTUNSPECIFIED = (256+68),
        MCIERR_WAVE_INPUTUNSPECIFIED = (256+69),
        MCIERR_WAVE_OUTPUTSUNSUITABLE = (256+70),
        MCIERR_WAVE_SETOUTPUTUNSUITABLE = (256+71),
        MCIERR_WAVE_INPUTSUNSUITABLE = (256+72),
        MCIERR_WAVE_SETINPUTUNSUITABLE = (256+73),
        MCIERR_SEQ_DIV_INCOMPATIBLE = (256+80),
        MCIERR_SEQ_PORT_INUSE = (256+81),
        MCIERR_SEQ_PORT_NONEXISTENT = (256+82),
        MCIERR_SEQ_PORT_MAPNODEVICE = (256+83),
        MCIERR_SEQ_PORT_MISCERROR = (256+84),
        MCIERR_SEQ_TIMER = (256+85),
        MCIERR_SEQ_PORTUNSPECIFIED = (256+86),
        MCIERR_SEQ_NOMIDIPRESENT = (256+87),
        MCIERR_NO_WINDOW = (256+90),
        MCIERR_CREATEWINDOW = (256+91),
        MCIERR_FILE_READ = (256+92),
        MCIERR_FILE_WRITE = (256+93),
        MCIERR_NO_IDENTITY = (256+94),
        MCIERR_CUSTOM_DRIVER_BASE = (256+256),
        MCI_FIRST = 0x0800,
        MCI_OPEN = 0x0803,
        MCI_CLOSE = 0x0804,
        MCI_ESCAPE = 0x0805,
        MCI_PLAY = 0x0806,
        MCI_SEEK = 0x0807,
        MCI_STOP = 0x0808,
        MCI_PAUSE = 0x0809,
        MCI_INFO = 0x080A,
        MCI_GETDEVCAPS = 0x080B,
        MCI_SPIN = 0x080C,
        MCI_SET = 0x080D,
        MCI_STEP = 0x080E,
        MCI_RECORD = 0x080F,
        MCI_SYSINFO = 0x0810,
        MCI_BREAK = 0x0811,
        MCI_SAVE = 0x0813,
        MCI_STATUS = 0x0814,
        MCI_CUE = 0x0830,
        MCI_REALIZE = 0x0840,
        MCI_WINDOW = 0x0841,
        MCI_PUT = 0x0842,
        MCI_WHERE = 0x0843,
        MCI_FREEZE = 0x0844,
        MCI_UNFREEZE = 0x0845,
        MCI_LOAD = 0x0850,
        MCI_CUT = 0x0851,
        MCI_COPY = 0x0852,
        MCI_PASTE = 0x0853,
        MCI_UPDATE = 0x0854,
        MCI_RESUME = 0x0855,
        MCI_DELETE = 0x0856,
        MCI_USER_MESSAGES = (0x0800+0x400),
        MCI_LAST = 0x0FFF,
        MCI_DEVTYPE_VCR = 513,
        MCI_DEVTYPE_VIDEODISC = 514,
        MCI_DEVTYPE_OVERLAY = 515,
        MCI_DEVTYPE_CD_AUDIO = 516,
        MCI_DEVTYPE_DAT = 517,
        MCI_DEVTYPE_SCANNER = 518,
        MCI_DEVTYPE_ANIMATION = 519,
        MCI_DEVTYPE_DIGITAL_VIDEO = 520,
        MCI_DEVTYPE_OTHER = 521,
        MCI_DEVTYPE_WAVEFORM_AUDIO = 522,
        MCI_DEVTYPE_SEQUENCER = 523,
        MCI_DEVTYPE_FIRST = 513,
        MCI_DEVTYPE_LAST = 523,
        MCI_DEVTYPE_FIRST_USER = 0x1000,
        MCI_MODE_NOT_READY = (512+12),
        MCI_MODE_STOP = (512+13),
        MCI_MODE_PLAY = (512+14),
        MCI_MODE_RECORD = (512+15),
        MCI_MODE_SEEK = (512+16),
        MCI_MODE_PAUSE = (512+17),
        MCI_MODE_OPEN = (512+18),
        MCI_FORMAT_MILLISECONDS = 0,
        MCI_FORMAT_HMS = 1,
        MCI_FORMAT_MSF = 2,
        MCI_FORMAT_FRAMES = 3,
        MCI_FORMAT_SMPTE_24 = 4,
        MCI_FORMAT_SMPTE_25 = 5,
        MCI_FORMAT_SMPTE_30 = 6,
        MCI_FORMAT_SMPTE_30DROP = 7,
        MCI_FORMAT_BYTES = 8,
        MCI_FORMAT_SAMPLES = 9,
        MCI_FORMAT_TMSF = 10,
        MCI_NOTIFY_SUCCESSFUL = 0x0001,
        MCI_NOTIFY_SUPERSEDED = 0x0002,
        MCI_NOTIFY_ABORTED = 0x0004,
        MCI_NOTIFY_FAILURE = 0x0008,
        MCI_NOTIFY = 0x00000001,
        MCI_WAIT = 0x00000002,
        MCI_FROM = 0x00000004,
        MCI_TO = 0x00000008,
        MCI_TRACK = 0x00000010,
        MCI_OPEN_SHAREABLE = 0x00000100,
        MCI_OPEN_ELEMENT = 0x00000200,
        MCI_OPEN_ALIAS = 0x00000400,
        MCI_OPEN_ELEMENT_ID = 0x00000800,
        MCI_OPEN_TYPE_ID = 0x00001000,
        MCI_OPEN_TYPE = 0x00002000,
        MCI_SEEK_TO_START = 0x00000100,
        MCI_SEEK_TO_END = 0x00000200,
        MCI_STATUS_ITEM = 0x00000100,
        MCI_STATUS_START = 0x00000200,
        MCI_STATUS_LENGTH = 0x00000001,
        MCI_STATUS_POSITION = 0x00000002,
        MCI_STATUS_NUMBER_OF_TRACKS = 0x00000003,
        MCI_STATUS_MODE = 0x00000004,
        MCI_STATUS_MEDIA_PRESENT = 0x00000005,
        MCI_STATUS_TIME_FORMAT = 0x00000006,
        MCI_STATUS_READY = 0x00000007,
        MCI_STATUS_CURRENT_TRACK = 0x00000008,
        MCI_INFO_PRODUCT = 0x00000100,
        MCI_INFO_FILE = 0x00000200,
        MCI_INFO_MEDIA_UPC = 0x00000400,
        MCI_INFO_MEDIA_IDENTITY = 0x00000800,
        MCI_INFO_NAME = 0x00001000,
        MCI_INFO_COPYRIGHT = 0x00002000,
        MCI_GETDEVCAPS_ITEM = 0x00000100,
        MCI_GETDEVCAPS_CAN_RECORD = 0x00000001,
        MCI_GETDEVCAPS_HAS_AUDIO = 0x00000002,
        MCI_GETDEVCAPS_HAS_VIDEO = 0x00000003,
        MCI_GETDEVCAPS_DEVICE_TYPE = 0x00000004,
        MCI_GETDEVCAPS_USES_FILES = 0x00000005,
        MCI_GETDEVCAPS_COMPOUND_DEVICE = 0x00000006,
        MCI_GETDEVCAPS_CAN_EJECT = 0x00000007,
        MCI_GETDEVCAPS_CAN_PLAY = 0x00000008,
        MCI_GETDEVCAPS_CAN_SAVE = 0x00000009,
        MCI_SYSINFO_QUANTITY = 0x00000100,
        MCI_SYSINFO_OPEN = 0x00000200,
        MCI_SYSINFO_NAME = 0x00000400,
        MCI_SYSINFO_INSTALLNAME = 0x00000800,
        MCI_SET_DOOR_OPEN = 0x00000100,
        MCI_SET_DOOR_CLOSED = 0x00000200,
        MCI_SET_TIME_FORMAT = 0x00000400,
        MCI_SET_AUDIO = 0x00000800,
        MCI_SET_VIDEO = 0x00001000,
        MCI_SET_ON = 0x00002000,
        MCI_SET_OFF = 0x00004000,
        MCI_SET_AUDIO_ALL = 0x00000000,
        MCI_SET_AUDIO_LEFT = 0x00000001,
        MCI_SET_AUDIO_RIGHT = 0x00000002,
        MCI_BREAK_KEY = 0x00000100,
        MCI_BREAK_HWND = 0x00000200,
        MCI_BREAK_OFF = 0x00000400,
        MCI_RECORD_INSERT = 0x00000100,
        MCI_RECORD_OVERWRITE = 0x00000200,
        MCI_SAVE_FILE = 0x00000100,
        MCI_LOAD_FILE = 0x00000100,
        MCI_VD_MODE_PARK = (1024+1),
        MCI_VD_MEDIA_CLV = (1024+2),
        MCI_VD_MEDIA_CAV = (1024+3),
        MCI_VD_MEDIA_OTHER = (1024+4),
        MCI_VD_FORMAT_TRACK = 0x4001,
        MCI_VD_PLAY_REVERSE = 0x00010000,
        MCI_VD_PLAY_FAST = 0x00020000,
        MCI_VD_PLAY_SPEED = 0x00040000,
        MCI_VD_PLAY_SCAN = 0x00080000,
        MCI_VD_PLAY_SLOW = 0x00100000,
        MCI_VD_SEEK_REVERSE = 0x00010000,
        MCI_VD_STATUS_SPEED = 0x00004002,
        MCI_VD_STATUS_FORWARD = 0x00004003,
        MCI_VD_STATUS_MEDIA_TYPE = 0x00004004,
        MCI_VD_STATUS_SIDE = 0x00004005,
        MCI_VD_STATUS_DISC_SIZE = 0x00004006,
        MCI_VD_GETDEVCAPS_CLV = 0x00010000,
        MCI_VD_GETDEVCAPS_CAV = 0x00020000,
        MCI_VD_SPIN_UP = 0x00010000,
        MCI_VD_SPIN_DOWN = 0x00020000,
        MCI_VD_GETDEVCAPS_CAN_REVERSE = 0x00004002,
        MCI_VD_GETDEVCAPS_FAST_RATE = 0x00004003,
        MCI_VD_GETDEVCAPS_SLOW_RATE = 0x00004004,
        MCI_VD_GETDEVCAPS_NORMAL_RATE = 0x00004005,
        MCI_VD_STEP_FRAMES = 0x00010000,
        MCI_VD_STEP_REVERSE = 0x00020000,
        MCI_VD_ESCAPE_STRING = 0x00000100,
        MCI_CDA_STATUS_TYPE_TRACK = 0x00004001,
        MCI_CDA_TRACK_AUDIO = (1088+0),
        MCI_CDA_TRACK_OTHER = (1088+1),
        MCI_WAVE_PCM = (1152+0),
        MCI_WAVE_MAPPER = (1152+1),
        MCI_WAVE_OPEN_BUFFER = 0x00010000,
        MCI_WAVE_SET_FORMATTAG = 0x00010000,
        MCI_WAVE_SET_CHANNELS = 0x00020000,
        MCI_WAVE_SET_SAMPLESPERSEC = 0x00040000,
        MCI_WAVE_SET_AVGBYTESPERSEC = 0x00080000,
        MCI_WAVE_SET_BLOCKALIGN = 0x00100000,
        MCI_WAVE_SET_BITSPERSAMPLE = 0x00200000,
        MCI_WAVE_INPUT = 0x00400000,
        MCI_WAVE_OUTPUT = 0x00800000,
        MCI_WAVE_STATUS_FORMATTAG = 0x00004001,
        MCI_WAVE_STATUS_CHANNELS = 0x00004002,
        MCI_WAVE_STATUS_SAMPLESPERSEC = 0x00004003,
        MCI_WAVE_STATUS_AVGBYTESPERSEC = 0x00004004,
        MCI_WAVE_STATUS_BLOCKALIGN = 0x00004005,
        MCI_WAVE_STATUS_BITSPERSAMPLE = 0x00004006,
        MCI_WAVE_STATUS_LEVEL = 0x00004007,
        MCI_WAVE_SET_ANYINPUT = 0x04000000,
        MCI_WAVE_SET_ANYOUTPUT = 0x08000000,
        MCI_WAVE_GETDEVCAPS_INPUTS = 0x00004001,
        MCI_WAVE_GETDEVCAPS_OUTPUTS = 0x00004002,
        MCI_SEQ_DIV_PPQN = (0+1216),
        MCI_SEQ_DIV_SMPTE_24 = (1+1216),
        MCI_SEQ_DIV_SMPTE_25 = (2+1216),
        MCI_SEQ_DIV_SMPTE_30DROP = (3+1216),
        MCI_SEQ_DIV_SMPTE_30 = (4+1216),
        MCI_SEQ_FORMAT_SONGPTR = 0x4001,
        MCI_SEQ_FILE = 0x4002,
        MCI_SEQ_MIDI = 0x4003,
        MCI_SEQ_SMPTE = 0x4004,
        MCI_SEQ_NONE = 65533,
        MCI_SEQ_MAPPER = 65535,
        MCI_SEQ_STATUS_TEMPO = 0x00004002,
        MCI_SEQ_STATUS_PORT = 0x00004003,
        MCI_SEQ_STATUS_SLAVE = 0x00004007,
        MCI_SEQ_STATUS_MASTER = 0x00004008,
        MCI_SEQ_STATUS_OFFSET = 0x00004009,
        MCI_SEQ_STATUS_DIVTYPE = 0x0000400A,
        MCI_SEQ_STATUS_NAME = 0x0000400B,
        MCI_SEQ_STATUS_COPYRIGHT = 0x0000400C,
        MCI_SEQ_SET_TEMPO = 0x00010000,
        MCI_SEQ_SET_PORT = 0x00020000,
        MCI_SEQ_SET_SLAVE = 0x00040000,
        MCI_SEQ_SET_MASTER = 0x00080000,
        MCI_SEQ_SET_OFFSET = 0x01000000,
        MCI_ANIM_OPEN_WS = 0x00010000,
        MCI_ANIM_OPEN_PARENT = 0x00020000,
        MCI_ANIM_OPEN_NOSTATIC = 0x00040000,
        MCI_ANIM_PLAY_SPEED = 0x00010000,
        MCI_ANIM_PLAY_REVERSE = 0x00020000,
        MCI_ANIM_PLAY_FAST = 0x00040000,
        MCI_ANIM_PLAY_SLOW = 0x00080000,
        MCI_ANIM_PLAY_SCAN = 0x00100000,
        MCI_ANIM_STEP_REVERSE = 0x00010000,
        MCI_ANIM_STEP_FRAMES = 0x00020000,
        MCI_ANIM_STATUS_SPEED = 0x00004001,
        MCI_ANIM_STATUS_FORWARD = 0x00004002,
        MCI_ANIM_STATUS_HWND = 0x00004003,
        MCI_ANIM_STATUS_HPAL = 0x00004004,
        MCI_ANIM_STATUS_STRETCH = 0x00004005,
        MCI_ANIM_INFO_TEXT = 0x00010000,
        MCI_ANIM_GETDEVCAPS_CAN_REVERSE = 0x00004001,
        MCI_ANIM_GETDEVCAPS_FAST_RATE = 0x00004002,
        MCI_ANIM_GETDEVCAPS_SLOW_RATE = 0x00004003,
        MCI_ANIM_GETDEVCAPS_NORMAL_RATE = 0x00004004,
        MCI_ANIM_GETDEVCAPS_PALETTES = 0x00004006,
        MCI_ANIM_GETDEVCAPS_CAN_STRETCH = 0x00004007,
        MCI_ANIM_GETDEVCAPS_MAX_WINDOWS = 0x00004008,
        MCI_ANIM_REALIZE_NORM = 0x00010000,
        MCI_ANIM_REALIZE_BKGD = 0x00020000,
        MCI_ANIM_WINDOW_HWND = 0x00010000,
        MCI_ANIM_WINDOW_STATE = 0x00040000,
        MCI_ANIM_WINDOW_TEXT = 0x00080000,
        MCI_ANIM_WINDOW_ENABLE_STRETCH = 0x00100000,
        MCI_ANIM_WINDOW_DISABLE_STRETCH = 0x00200000,
        MCI_ANIM_WINDOW_DEFAULT = 0x00000000,
        MCI_ANIM_RECT = 0x00010000,
        MCI_ANIM_PUT_SOURCE = 0x00020000,
        MCI_ANIM_PUT_DESTINATION = 0x00040000,
        MCI_ANIM_WHERE_SOURCE = 0x00020000,
        MCI_ANIM_WHERE_DESTINATION = 0x00040000,
        MCI_ANIM_UPDATE_HDC = 0x00020000,
        MCI_OVLY_OPEN_WS = 0x00010000,
        MCI_OVLY_OPEN_PARENT = 0x00020000,
        MCI_OVLY_STATUS_HWND = 0x00004001,
        MCI_OVLY_STATUS_STRETCH = 0x00004002,
        MCI_OVLY_INFO_TEXT = 0x00010000,
        MCI_OVLY_GETDEVCAPS_CAN_STRETCH = 0x00004001,
        MCI_OVLY_GETDEVCAPS_CAN_FREEZE = 0x00004002,
        MCI_OVLY_GETDEVCAPS_MAX_WINDOWS = 0x00004003,
        MCI_OVLY_WINDOW_HWND = 0x00010000,
        MCI_OVLY_WINDOW_STATE = 0x00040000,
        MCI_OVLY_WINDOW_TEXT = 0x00080000,
        MCI_OVLY_WINDOW_ENABLE_STRETCH = 0x00100000,
        MCI_OVLY_WINDOW_DISABLE_STRETCH = 0x00200000,
        MCI_OVLY_WINDOW_DEFAULT = 0x00000000,
        MCI_OVLY_RECT = 0x00010000,
        MCI_OVLY_PUT_SOURCE = 0x00020000,
        MCI_OVLY_PUT_DESTINATION = 0x00040000,
        MCI_OVLY_PUT_FRAME = 0x00080000,
        MCI_OVLY_PUT_VIDEO = 0x00100000,
        MCI_OVLY_WHERE_SOURCE = 0x00020000,
        MCI_OVLY_WHERE_DESTINATION = 0x00040000,
        MCI_OVLY_WHERE_FRAME = 0x00080000,
        MCI_OVLY_WHERE_VIDEO = 0x00100000,
        MAX_LANA = 254,
        MARSHALINTERFACE_MIN = 500,
        MEMBERID_NIL = (-1),
        MK_ALT = (0x20),
        MAXPROPPAGES = 100,
        MARKPARITY = 3,
        MS_CTS_ON = (0x0010),
        MS_DSR_ON = (0x0020),
        MS_RING_ON = (0x0040),
        MS_RLSD_ON = (0x0080),
        MAXINTATOM = 0xC000,
        MOVEFILE_REPLACE_EXISTING = 0x00000001,
        MOVEFILE_COPY_ALLOWED = 0x00000002,
        MOVEFILE_DELAY_UNTIL_REBOOT = 0x00000004,
        MOVEFILE_WRITE_THROUGH = 0x00000008,
        MAX_COMPUTERNAME_LENGTH = 15,
        MAX_PROFILE_LEN = 80,
        MOUSE_MOVED = 0x0001,
        MOUSE_EVENT = 0x0002,
        MENU_EVENT = 0x0008,
        MAXUIDLEN = 64,
        MAX_PATH = 260,
        MARSHAL_E_FIRST = 0x80040120,
        MARSHAL_E_LAST = 0x8004012F,
        MARSHAL_S_FIRST = 0x00040120,
        MARSHAL_S_LAST = 0x0004012F,
        MK_E_FIRST = 0x800401E0,
        MK_E_LAST = 0x800401EF,
        MK_S_FIRST = 0x000401E0,
        MK_S_LAST = 0x000401EF,
        MK_E_CONNECTMANUALLY = 0x800401E0,
        MK_E_EXCEEDEDDEADLINE = 0x800401E1,
        MK_E_NEEDGENERIC = 0x800401E2,
        MK_E_UNAVAILABLE = 0x800401E3,
        MK_E_SYNTAX = 0x800401E4,
        MK_E_NOOBJECT = 0x800401E5,
        MK_E_INVALIDEXTENSION = 0x800401E6,
        MK_E_INTERMEDIATEINTERFACENOTSUPPORTED = 0x800401E7,
        MK_E_NOTBINDABLE = 0x800401E8,
        MK_E_NOTBOUND = 0x800401E9,
        MK_E_CANTOPENFILE = 0x800401EA,
        MK_E_MUSTBOTHERUSER = 0x800401EB,
        MK_E_NOINVERSE = 0x800401EC,
        MK_E_NOSTORAGE = 0x800401ED,
        MK_E_NOPREFIX = 0x800401EE,
        MK_E_ENUMERATION_FAILED = 0x800401EF,
        MK_S_REDUCED_TO_SELF = 0x000401E2,
        MK_S_ME = 0x000401E4,
        MK_S_HIM = 0x000401E5,
        MK_S_US = 0x000401E6,
        MK_S_MONIKERALREADYREGISTERED = 0x000401E7,
        MK_E_NO_NORMALIZED = 0x80080007,
        MEM_E_INVALID_ROOT = 0x80080009,
        MEM_E_INVALID_LINK = 0x80080010,
        MEM_E_INVALID_SIZE = 0x80080011,
        MAXSTRETCHBLTMODE = 4,
        META_SETBKCOLOR = 0x0201,
        META_SETBKMODE = 0x0102,
        META_SETMAPMODE = 0x0103,
        META_SETROP2 = 0x0104,
        META_SETRELABS = 0x0105,
        META_SETPOLYFILLMODE = 0x0106,
        META_SETSTRETCHBLTMODE = 0x0107,
        META_SETTEXTCHAREXTRA = 0x0108,
        META_SETTEXTCOLOR = 0x0209,
        META_SETTEXTJUSTIFICATION = 0x020A,
        META_SETWINDOWORG = 0x020B,
        META_SETWINDOWEXT = 0x020C,
        META_SETVIEWPORTORG = 0x020D,
        META_SETVIEWPORTEXT = 0x020E,
        META_OFFSETWINDOWORG = 0x020F,
        META_SCALEWINDOWEXT = 0x0410,
        META_OFFSETVIEWPORTORG = 0x0211,
        META_SCALEVIEWPORTEXT = 0x0412,
        META_LINETO = 0x0213,
        META_MOVETO = 0x0214,
        META_EXCLUDECLIPRECT = 0x0415,
        META_INTERSECTCLIPRECT = 0x0416,
        META_ARC = 0x0817,
        META_ELLIPSE = 0x0418,
        META_FLOODFILL = 0x0419,
        META_PIE = 0x081A,
        META_RECTANGLE = 0x041B,
        META_ROUNDRECT = 0x061C,
        META_PATBLT = 0x061D,
        META_SAVEDC = 0x001E,
        META_SETPIXEL = 0x041F,
        META_OFFSETCLIPRGN = 0x0220,
        META_TEXTOUT = 0x0521,
        META_BITBLT = 0x0922,
        META_STRETCHBLT = 0x0B23,
        META_POLYGON = 0x0324,
        META_POLYLINE = 0x0325,
        META_ESCAPE = 0x0626,
        META_RESTOREDC = 0x0127,
        META_FILLREGION = 0x0228,
        META_FRAMEREGION = 0x0429,
        META_INVERTREGION = 0x012A,
        META_PAINTREGION = 0x012B,
        META_SELECTCLIPREGION = 0x012C,
        META_SELECTOBJECT = 0x012D,
        META_SETTEXTALIGN = 0x012E,
        META_CHORD = 0x0830,
        META_SETMAPPERFLAGS = 0x0231,
        META_EXTTEXTOUT = 0x0a32,
        META_SETDIBTODEV = 0x0d33,
        META_SELECTPALETTE = 0x0234,
        META_REALIZEPALETTE = 0x0035,
        META_ANIMATEPALETTE = 0x0436,
        META_SETPALENTRIES = 0x0037,
        META_POLYPOLYGON = 0x0538,
        META_RESIZEPALETTE = 0x0139,
        META_DIBBITBLT = 0x0940,
        META_DIBSTRETCHBLT = 0x0b41,
        META_DIBCREATEPATTERNBRUSH = 0x0142,
        META_STRETCHDIB = 0x0f43,
        META_EXTFLOODFILL = 0x0548,
        META_DELETEOBJECT = 0x01f0,
        META_CREATEPALETTE = 0x00f7,
        META_CREATEPATTERNBRUSH = 0x01F9,
        META_CREATEPENINDIRECT = 0x02FA,
        META_CREATEFONTINDIRECT = 0x02FB,
        META_CREATEBRUSHINDIRECT = 0x02FC,
        META_CREATEREGION = 0x06FF,
        MFCOMMENT = 15,
        MOUSETRAILS = 39,
        MWT_IDENTITY = 1,
        MWT_LEFTMULTIPLY = 2,
        MWT_RIGHTMULTIPLY = 3,
        MWT_MIN = 1,
        MWT_MAX = 3,
        MONO_FONT = 8,
        MAC_CHARSET = 77,
        MM_TEXT = 1,
        MM_LOMETRIC = 2,
        MM_HIMETRIC = 3,
        MM_LOENGLISH = 4,
        MM_HIENGLISH = 5,
        MM_TWIPS = 6,
        MM_ISOTROPIC = 7,
        MM_ANISOTROPIC = 8,
        MM_MIN = 1,
        MM_MAX = 8,
        MM_MAX_FIXEDSCALE = 6,
        MAX_LEADBYTES = 12,
        MAX_DEFAULTCHAR = 2,
        MB_PRECOMPOSED = 0x00000001,
        MB_COMPOSITE = 0x00000002,
        MB_USEGLYPHCHARS = 0x00000004,
        MB_ERR_INVALID_CHARS = 0x00000008,
        MAP_FOLDCZONE = 0x00000010,
        MAP_PRECOMPOSED = 0x00000020,
        MAP_COMPOSITE = 0x00000040,
        MAP_FOLDDIGITS = 0x00000080;
    long MAXLONGLONG = (0x7fffffffffffffffL);
    int MINCHAR = 0x80,
        MAXCHAR = 0x7f,
        MINSHORT = 0x8000,
        MAXSHORT = 0x7fff,
        MINLONG = 0x80000000,
        MAXLONG = 0x7fffffff,
        MAXBYTE = 0xff,
        MAXWORD = 0xffff,
        MAXDWORD = 0xffffffff,
        MAXIMUM_WAIT_OBJECTS = 64,
        MAXIMUM_SUSPEND_COUNT = 0x7f,
        MAXIMUM_PROCESSORS = 32,
        MUTANT_QUERY_STATE = 0x0001,
        MEM_COMMIT = 0x1000,
        MEM_RESERVE = 0x2000,
        MEM_DECOMMIT = 0x4000,
        MEM_RELEASE = 0x8000,
        MEM_FREE = 0x10000,
        MEM_PRIVATE = 0x20000,
        MEM_MAPPED = 0x40000,
        MEM_RESET = 0x80000,
        MEM_TOP_DOWN = 0x100000,
        MEM_IMAGE = 0x1000000,
        MAILSLOT_NO_MESSAGE = (-1),
        MAILSLOT_WAIT_FOREVER = (-1),
        MAXIMUM_ALLOWED = (0x02000000),
        MESSAGE_RESOURCE_UNICODE = 0x0001,
        MAX_PRIORITY = 99,
        MIN_PRIORITY = 1,
        MSGF_DIALOGBOX = 0,
        MSGF_MESSAGEBOX = 1,
        MSGF_MENU = 2,
        MSGF_MOVE = 3,
        MSGF_SIZE = 4,
        MSGF_SCROLLBAR = 5,
        MSGF_NEXTWINDOW = 6,
        MSGF_MAINLOOP = 8,
        MSGF_MAX = 8,
        MSGF_USER = 4096,
        MENULOOP_WINDOW = 0,
        MENULOOP_POPUP = 1,
        MA_ACTIVATE = 1,
        MA_ACTIVATEANDEAT = 2,
        MA_NOACTIVATE = 3,
        MA_NOACTIVATEANDEAT = 4,
        MK_LBUTTON = 0x0001,
        MK_RBUTTON = 0x0002,
        MK_SHIFT = 0x0004,
        MK_CONTROL = 0x0008,
        MK_MBUTTON = 0x0010,
        MOD_WIN = 0x0008,
        MOUSEEVENTF_MOVE = 0x0001,
        MOUSEEVENTF_LEFTDOWN = 0x0002,
        MOUSEEVENTF_LEFTUP = 0x0004,
        MOUSEEVENTF_RIGHTDOWN = 0x0008,
        MOUSEEVENTF_RIGHTUP = 0x0010,
        MOUSEEVENTF_MIDDLEDOWN = 0x0020,
        MOUSEEVENTF_MIDDLEUP = 0x0040,
        MOUSEEVENTF_WHEEL = 0x0800,
        MOUSEEVENTF_ABSOLUTE = 0x8000,
        MWMO_WAITALL = 0x0001,
        MWMO_ALERTABLE = 0x0002,
        MNC_IGNORE = 0,
        MNC_CLOSE = 1,
        MNC_EXECUTE = 2,
        MNC_SELECT = 3,
        MIIM_STATE = 0x00000001,
        MIIM_ID = 0x00000002,
        MIIM_SUBMENU = 0x00000004,
        MIIM_CHECKMARKS = 0x00000008,
        MIIM_TYPE = 0x00000010,
        MIIM_DATA = 0x00000020,
        MB_OK = 0x00000000,
        MB_OKCANCEL = 0x00000001,
        MB_ABORTRETRYIGNORE = 0x00000002,
        MB_YESNOCANCEL = 0x00000003,
        MB_YESNO = 0x00000004,
        MB_RETRYCANCEL = 0x00000005,
        MB_ICONHAND = 0x00000010,
        MB_ICONQUESTION = 0x00000020,
        MB_ICONEXCLAMATION = 0x00000030,
        MB_ICONASTERISK = 0x00000040,
        MB_USERICON = 0x00000080,
        MB_ICONWARNING = 0x00000030,
        MB_ICONERROR = 0x00000010,
        MB_ICONINFORMATION = 0x00000040,
        MB_DEFBUTTON1 = 0x00000000,
        MB_DEFBUTTON2 = 0x00000100,
        MB_DEFBUTTON3 = 0x00000200,
        MB_DEFBUTTON4 = 0x00000300,
        MB_APPLMODAL = 0x00000000,
        MB_SYSTEMMODAL = 0x00001000,
        MB_TASKMODAL = 0x00002000,
        MB_HELP = 0x00004000,
        MB_NOFOCUS = 0x00008000,
        MB_SETFOREGROUND = 0x00010000,
        MB_DEFAULT_DESKTOP_ONLY = 0x00020000,
        MB_TOPMOST = 0x00040000,
        MB_RIGHT = 0x00080000,
        MB_RTLREADING = 0x00100000,
        MB_SERVICE_NOTIFICATION = 0x00200000;
    // MB_SERVICE_NOTIFICATION = 0x00040000;
    int MB_SERVICE_NOTIFICATION_NT3X = 0x00040000,
        MB_TYPEMASK = 0x0000000F,
        MB_ICONMASK = 0x000000F0,
        MB_DEFMASK = 0x00000F00,
        MB_MODEMASK = 0x00003000,
        MB_MISCMASK = 0x0000C000,
        MF_INSERT = 0x00000000,
        MF_CHANGE = 0x00000080,
        MF_APPEND = 0x00000100,
        MF_DELETE = 0x00000200,
        MF_REMOVE = 0x00001000,
        MF_BYCOMMAND = 0x00000000,
        MF_BYPOSITION = 0x00000400,
        MF_SEPARATOR = 0x00000800,
        MF_ENABLED = 0x00000000,
        MF_GRAYED = 0x00000001,
        MF_DISABLED = 0x00000002,
        MF_UNCHECKED = 0x00000000,
        MF_CHECKED = 0x00000008,
        MF_USECHECKBITMAPS = 0x00000200,
        MF_STRING = 0x00000000,
        MF_BITMAP = 0x00000004,
        MF_OWNERDRAW = 0x00000100,
        MF_POPUP = 0x00000010,
        MF_MENUBARBREAK = 0x00000020,
        MF_MENUBREAK = 0x00000040,
        MF_UNHILITE = 0x00000000,
        MF_HILITE = 0x00000080,
        MF_DEFAULT = 0x00001000,
        MF_SYSMENU = 0x00002000,
        MF_HELP = 0x00004000,
        MF_RIGHTJUSTIFY = 0x00004000,
        MF_MOUSESELECT = 0x00008000,
        MF_END = 0x00000080,
        MFT_STRING = 0x00000000,
        MFT_BITMAP = 0x00000004,
        MFT_MENUBARBREAK = 0x00000020,
        MFT_MENUBREAK = 0x00000040,
        MFT_OWNERDRAW = 0x00000100,
        MFT_RADIOCHECK = 0x00000200,
        MFT_SEPARATOR = 0x00000800,
        MFT_RIGHTORDER = 0x00002000,
        MFT_RIGHTJUSTIFY = 0x00004000,
        MFS_GRAYED = 0x00000003,
        MFS_DISABLED = 0x00000003,
        MFS_CHECKED = 0x00000008,
        MFS_HILITE = 0x00000080,
        MFS_ENABLED = 0x00000000,
        MFS_UNCHECKED = 0x00000000,
        MFS_UNHILITE = 0x00000000,
        MFS_DEFAULT = 0x00001000,
        MDIS_ALLCHILDSTYLES = 0x0001,
        MDITILE_VERTICAL = 0x0000,
        MDITILE_HORIZONTAL = 0x0001,
        MDITILE_SKIPDISABLED = 0x0002,
        METRICS_USEDEFAULT = -1,
        MKF_MOUSEKEYSON = 0x00000001,
        MKF_AVAILABLE = 0x00000002,
        MKF_HOTKEYACTIVE = 0x00000004,
        MKF_CONFIRMHOTKEY = 0x00000008,
        MKF_HOTKEYSOUND = 0x00000010,
        MKF_INDICATOR = 0x00000020,
        MKF_MODIFIERS = 0x00000040,
        MKF_REPLACENUMBERS = 0x00000080,
        MCN_FIRST = (0-750),
        MCN_LAST = (0-759),
        MSGF_COMMCTRL_BEGINDRAG = 0x4200,
        MSGF_COMMCTRL_SIZEHEADER = 0x4201,
        MSGF_COMMCTRL_DRAGSELECT = 0x4202,
        MSGF_COMMCTRL_TOOLBARCUST = 0x4203,
        MINSYSCOMMAND = 0xF000,
        MCM_FIRST = 0x1000,
        MCM_GETCURSEL = (0x1000+1),
        MCM_SETCURSEL = (0x1000+2),
        MCM_GETMAXSELCOUNT = (0x1000+3),
        MCM_SETMAXSELCOUNT = (0x1000+4),
        MCM_GETSELRANGE = (0x1000+5),
        MCM_SETSELRANGE = (0x1000+6),
        MCM_GETMONTHRANGE = (0x1000+7),
        MCM_SETDAYSTATE = (0x1000+8),
        MCM_GETMINREQRECT = (0x1000+9),
        MCM_SETCOLOR = (0x1000+10),
        MCM_GETCOLOR = (0x1000+11),
        MCM_SETTODAY = (0x1000+12),
        MCM_GETTODAY = (0x1000+13),
        MCM_HITTEST = (0x1000+14),
        MCM_SETFIRSTDAYOFWEEK = (0x1000+15),
        MCM_GETFIRSTDAYOFWEEK = (0x1000+16),
        MCM_GETRANGE = (0x1000+17),
        MCM_SETRANGE = (0x1000+18),
        MCM_GETMONTHDELTA = (0x1000+19),
        MCM_SETMONTHDELTA = (0x1000+20),
        MCM_GETMAXTODAYWIDTH = (0x1000+21),
        MCHT_TITLE = 0x00010000,
        MCHT_CALENDAR = 0x00020000,
        MCHT_TODAYLINK = 0x00030000,
        MCHT_NEXT = 0x01000000,
        MCHT_PREV = 0x02000000,
        MCHT_NOWHERE = 0x00000000,
        MCHT_TITLEBK = (0x00010000),
        MCHT_TITLEMONTH = (0x00010000|0x0001),
        MCHT_TITLEYEAR = (0x00010000|0x0002),
        MCHT_TITLEBTNNEXT = (0x00010000|0x01000000|0x0003),
        MCHT_TITLEBTNPREV = (0x00010000|0x02000000|0x0003),
        MCHT_CALENDARBK = (0x00020000),
        MCHT_CALENDARDATE = (0x00020000|0x0001),
        MCHT_CALENDARDATENEXT = ((0x00020000|0x0001)|0x01000000),
        MCHT_CALENDARDATEPREV = ((0x00020000|0x0001)|0x02000000),
        MCHT_CALENDARDAY = (0x00020000|0x0002),
        MCHT_CALENDARWEEKNUM = (0x00020000|0x0003),
        MCSC_BACKGROUND = 0,
        MCSC_TEXT = 1,
        MCSC_TITLEBK = 2,
        MCSC_TITLETEXT = 3,
        MCSC_MONTHBK = 4,
        MCSC_TRAILINGTEXT = 5,
        MCN_SELCHANGE = ((0-750)+1),
        MCN_GETDAYSTATE = ((0-750)+3),
        MCN_SELECT = ((0-750)+4),
        MCS_DAYSTATE = 0x0001,
        MCS_MULTISELECT = 0x0002,
        MCS_WEEKNUMBERS = 0x0004,
        MCS_NOTODAYCIRCLE = 0x0008,
        MUTEX_MODIFY_STATE = 0x0001,
        MERGECOPY = 0x00C000CA,
        MERGEPAINT = 0x00BB0226;

    /* RichEdit: constant value */
    int MAX_TAB_STOPS = 32;
    
    /* MKRREDUCE enum */
    int MKRREDUCE_ONE           = (3<<16),
        MKRREDUCE_TOUSER        = (2<<16),
        MKRREDUCE_THROUGHUSER   = (1<<16),
        MKRREDUCE_ALL           = 0;

    /* MKSYS enum */
    int MKSYS_NONE              = 0,
        MKSYS_GENERICCOMPOSITE  = 1,
        MKSYS_FILEMONIKER       = 2,
        MKSYS_ANTIMONIKER       = 3,
        MKSYS_ITEMMONIKER       = 4,
        MKSYS_POINTERMONIKER    = 5,
        MKSYS_CLASSMONIKER      = 7,
        MKSYS_OBJREFMONIKER     = 8;

    /* MSHCTX enum */
    int MSHCTX_LOCAL            = 0,
        MSHCTX_NOSHAREDMEM      = 1,
        MSHCTX_DIFFERENTMACHINE = 2,
        MSHCTX_INPROC           = 3;
        
    /* MSHLFLAGS enum */
    int MSHLFLAGS_NORMAL        = 0,
        MSHLFLAGS_TABLESTRONG   = 1,
        MSHLFLAGS_TABLEWEAK     = 2,
        MSHLFLAGS_NOPING        = 4;
}
