// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winn {
	int NEWFILEOPENORD = 1547,
		NI_OPENCANDIDATE = 0x0010,
		NI_CLOSECANDIDATE = 0x0011,
		NI_SELECTCANDIDATESTR = 0x0012,
		NI_CHANGECANDIDATELIST = 0x0013,
		NI_FINALIZECONVERSIONRESULT = 0x0014,
		NI_COMPOSITIONSTR = 0x0015,
		NI_SETCANDIDATE_PAGESTART = 0x0016,
		NI_SETCANDIDATE_PAGESIZE = 0x0017,
		NEWTRANSPARENT = 3,
		NCBNAMSZ = 16,
		NAME_FLAGS_MASK = 0x87,
		NCBCALL = 0x10,
		NCBLISTEN = 0x11,
		NCBHANGUP = 0x12,
		NCBSEND = 0x14,
		NCBRECV = 0x15,
		NCBRECVANY = 0x16,
		NCBCHAINSEND = 0x17,
		NCBDGSEND = 0x20,
		NCBDGRECV = 0x21,
		NCBDGSENDBC = 0x22,
		NCBDGRECVBC = 0x23,
		NCBADDNAME = 0x30,
		NCBDELNAME = 0x31,
		NCBRESET = 0x32,
		NCBASTAT = 0x33,
		NCBSSTAT = 0x34,
		NCBCANCEL = 0x35,
		NCBADDGRNAME = 0x36,
		NCBENUM = 0x37,
		NCBUNLINK = 0x70,
		NCBSENDNA = 0x71,
		NCBCHAINSENDNA = 0x72,
		NCBLANSTALERT = 0x73,
		NCBACTION = 0x77,
		NCBFINDNAME = 0x78,
		NCBTRACE = 0x79,
		NRC_GOODRET = 0x00,
		NRC_BUFLEN = 0x01,
		NRC_ILLCMD = 0x03,
		NRC_CMDTMO = 0x05,
		NRC_INCOMP = 0x06,
		NRC_BADDR = 0x07,
		NRC_SNUMOUT = 0x08,
		NRC_NORES = 0x09,
		NRC_SCLOSED = 0x0a,
		NRC_CMDCAN = 0x0b,
		NRC_DUPNAME = 0x0d,
		NRC_NAMTFUL = 0x0e,
		NRC_ACTSES = 0x0f,
		NRC_LOCTFUL = 0x11,
		NRC_REMTFUL = 0x12,
		NRC_ILLNN = 0x13,
		NRC_NOCALL = 0x14,
		NRC_NOWILD = 0x15,
		NRC_INUSE = 0x16,
		NRC_NAMERR = 0x17,
		NRC_SABORT = 0x18,
		NRC_NAMCONF = 0x19,
		NRC_IFBUSY = 0x21,
		NRC_TOOMANY = 0x22,
		NRC_BRIDGE = 0x23,
		NRC_CANOCCR = 0x24,
		NRC_CANCEL = 0x26,
		NRC_DUPENV = 0x30,
		NRC_ENVNOTDEF = 0x34,
		NRC_OSRESNOTAV = 0x35,
		NRC_MAXAPPS = 0x36,
		NRC_NOSAPS = 0x37,
		NRC_NORESOURCES = 0x38,
		NRC_INVADDRESS = 0x39,
		NRC_INVDDID = 0x3B,
		NRC_LOCKFAIL = 0x3C,
		NRC_OPENERR = 0x3f,
		NRC_SYSTEM = 0x40,
		NRC_PENDING = 0xff,
		NUMPRS_LEADING_WHITE = 0x0001,
		NUMPRS_TRAILING_WHITE = 0x0002,
		NUMPRS_LEADING_PLUS = 0x0004,
		NUMPRS_TRAILING_PLUS = 0x0008,
		NUMPRS_LEADING_MINUS = 0x0010,
		NUMPRS_TRAILING_MINUS = 0x0020,
		NUMPRS_HEX_OCT = 0x0040,
		NUMPRS_PARENS = 0x0080,
		NUMPRS_DECIMAL = 0x0100,
		NUMPRS_THOUSANDS = 0x0200,
		NUMPRS_CURRENCY = 0x0400,
		NUMPRS_EXPONENT = 0x0800,
		NUMPRS_USE_ALL = 0x1000,
		NUMPRS_STD = 0x1FFF,
		NUMPRS_NEG = 0x10000,
		NUMPRS_INEXACT = 0x20000,
		NT351_INTERFACE_SIZE = 0x40,
		NIM_ADD = 0x00000000,
		NIM_MODIFY = 0x00000001,
		NIM_DELETE = 0x00000002,
		NIF_MESSAGE = 0x00000001,
		NIF_ICON = 0x00000002,
		NIF_TIP = 0x00000004,
		NONZEROLHND = (0x0002),
		NONZEROLPTR = (0x0000),
		NORMAL_PRIORITY_CLASS = 0x00000020,
		NOPARITY = 0,
		NMPWAIT_WAIT_FOREVER = 0xffffffff,
		NMPWAIT_NOWAIT = 0x00000001,
		NMPWAIT_USE_DEFAULT_WAIT = 0x00000000,
		NUMLOCK_ON = 0x0020,
		NULL = 0,
		NO_ERROR = 0,
		NOERROR = 0,
		NTE_BAD_UID = 0x80090001,
		NTE_BAD_HASH = 0x80090002,
		NTE_BAD_KEY = 0x80090003,
		NTE_BAD_LEN = 0x80090004,
		NTE_BAD_DATA = 0x80090005,
		NTE_BAD_SIGNATURE = 0x80090006,
		NTE_BAD_VER = 0x80090007,
		NTE_BAD_ALGID = 0x80090008,
		NTE_BAD_FLAGS = 0x80090009,
		NTE_BAD_TYPE = 0x8009000A,
		NTE_BAD_KEY_STATE = 0x8009000B,
		NTE_BAD_HASH_STATE = 0x8009000C,
		NTE_NO_KEY = 0x8009000D,
		NTE_NO_MEMORY = 0x8009000E,
		NTE_EXISTS = 0x8009000F,
		NTE_PERM = 0x80090010,
		NTE_NOT_FOUND = 0x80090011,
		NTE_DOUBLE_ENCRYPT = 0x80090012,
		NTE_BAD_PROVIDER = 0x80090013,
		NTE_BAD_PROV_TYPE = 0x80090014,
		NTE_BAD_PUBLIC_KEY = 0x80090015,
		NTE_BAD_KEYSET = 0x80090016,
		NTE_PROV_TYPE_NOT_DEF = 0x80090017,
		NTE_PROV_TYPE_ENTRY_BAD = 0x80090018,
		NTE_KEYSET_NOT_DEF = 0x80090019,
		NTE_KEYSET_ENTRY_BAD = 0x8009001A,
		NTE_PROV_TYPE_NO_MATCH = 0x8009001B,
		NTE_SIGNATURE_FILE_BAD = 0x8009001C,
		NTE_PROVIDER_DLL_FAIL = 0x8009001D,
		NTE_PROV_DLL_NOT_FOUND = 0x8009001E,
		NTE_BAD_KEYSET_PARAM = 0x8009001F,
		NTE_FAIL = 0x80090020,
		NTE_SYS_ERR = 0x80090021,
		NTE_OP_OK = 0,
		NULLREGION = 1,
		NEWFRAME = 1,
		NEXTBAND = 3,
		NTM_REGULAR = 0x00000040,
		NTM_BOLD = 0x00000020,
		NTM_ITALIC = 0x00000001,
		NONANTIALIASED_QUALITY = 3,
		NULL_BRUSH = 5,
		NULL_PEN = 8,
		NUMBRUSHES = 16,
		NUMPENS = 18,
		NUMMARKERS = 20,
		NUMFONTS = 22,
		NUMCOLORS = 24,
		NUMRESERVED = 106,
		NETPROPERTY_PERSISTENT = 1,
		NETINFO_DLL16 = 0x00000001,
		NETINFO_DISKRED = 0x00000004,
		NETINFO_PRINTERRED = 0x00000008,
		NORM_IGNORECASE = 0x00000001,
		NORM_IGNORENONSPACE = 0x00000002,
		NORM_IGNORESYMBOLS = 0x00000004,
		NORM_IGNOREKANATYPE = 0x00010000,
		NORM_IGNOREWIDTH = 0x00020000,
		NLS_VALID_LOCALE_MASK = 0x000fffff,
		NO_PROPAGATE_INHERIT_ACE = (0x4),
		N_BTMASK = 0x000F,
		N_TMASK = 0x0030,
		N_TMASK1 = 0x00C0,
		N_TMASK2 = 0x00F0,
		N_BTSHFT = 4,
		N_TSHIFT = 2,
		NO_PRIORITY = 0,
		NFR_ANSI = 1,
		NFR_UNICODE = 2,
		NF_QUERY = 3,
		NF_REQUERY = 4,
		NM_FIRST = (0-0),
		NM_LAST = (0-99),
		NM_OUTOFMEMORY = ((0-0)-1),
		NM_CLICK = ((0-0)-2),
		NM_DBLCLK = ((0-0)-3),
		NM_RETURN = ((0-0)-4),
		NM_RCLICK = ((0-0)-5),
		NM_RDBLCLK = ((0-0)-6),
		NM_SETFOCUS = ((0-0)-7),
		NM_KILLFOCUS = ((0-0)-8),
		NM_CUSTOMDRAW = ((0-0)-12),
		NM_HOVER = ((0-0)-13),
        NOTSRCCOPY = 0x00330008,
        NOTSRCERASE = 0x001100A6;
}
