// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winr {
    int REGULAR_FONTTYPE = 0x0400,
        rad1 = 0x0420,
        rad2 = 0x0421,
        rad3 = 0x0422,
        rad4 = 0x0423,
        rad5 = 0x0424,
        rad6 = 0x0425,
        rad7 = 0x0426,
        rad8 = 0x0427,
        rad9 = 0x0428,
        rad10 = 0x0429,
        rad11 = 0x042a,
        rad12 = 0x042b,
        rad13 = 0x042c,
        rad14 = 0x042d,
        rad15 = 0x042e,
        rad16 = 0x042f,
        rct1 = 0x0438,
        rct2 = 0x0439,
        rct3 = 0x043a,
        rct4 = 0x043b,
        REPLACEDLGORD = 1541,
        REGISTERING = 0x00,
        REGISTERED = 0x04,
        RPC_C_BINDING_INFINITE_TIMEOUT = 10,
        RPC_C_BINDING_MIN_TIMEOUT = 0,
        RPC_C_BINDING_DEFAULT_TIMEOUT = 5,
        RPC_C_BINDING_MAX_TIMEOUT = 9,
        RPC_C_CANCEL_INFINITE_TIMEOUT = -1,
        RPC_C_LISTEN_MAX_CALLS_DEFAULT = 1234,
        RPC_C_PROTSEQ_MAX_REQS_DEFAULT = 10,
        RPC_C_BIND_TO_ALL_NICS = 1,
        RPC_C_USE_INTERNET_PORT = 1,
        RPC_C_USE_INTRANET_PORT = 2,
        RPC_C_STATS_CALLS_IN = 0,
        RPC_C_STATS_CALLS_OUT = 1,
        RPC_C_STATS_PKTS_IN = 2,
        RPC_C_STATS_PKTS_OUT = 3,
        RPC_C_QOS_IDENTITY_STATIC = 0,
        RPC_C_QOS_IDENTITY_DYNAMIC = 1,
        RPC_C_QOS_CAPABILITIES_DEFAULT = 0,
        RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH = 1,
        RPC_C_PROTECT_LEVEL_DEFAULT = (0),
        RPC_C_PROTECT_LEVEL_NONE = (1),
        RPC_C_PROTECT_LEVEL_CONNECT = (2),
        RPC_C_PROTECT_LEVEL_CALL = (3),
        RPC_C_PROTECT_LEVEL_PKT = (4),
        RPC_C_PROTECT_LEVEL_PKT_INTEGRITY = (5),
        RPC_C_PROTECT_LEVEL_PKT_PRIVACY = (6),
        RPC_C_SECURITY_QOS_VERSION = 1,
        RPC_C_EP_ALL_ELTS = 0,
        RPC_C_EP_MATCH_BY_IF = 1,
        RPC_C_EP_MATCH_BY_OBJ = 2,
        RPC_C_EP_MATCH_BY_BOTH = 3,
        RPC_C_VERS_ALL = 1,
        RPC_C_VERS_COMPATIBLE = 2,
        RPC_C_VERS_EXACT = 3,
        RPC_C_VERS_MAJOR_ONLY = 4,
        RPC_C_VERS_UPTO = 5,
        RPC_C_MGMT_INQ_IF_IDS = 0,
        RPC_C_MGMT_INQ_PRINC_NAME = 1,
        RPC_C_MGMT_INQ_STATS = 2,
        RPC_C_MGMT_IS_SERVER_LISTEN = 3,
        RPC_C_MGMT_STOP_SERVER_LISTEN = 4,
        RPC_C_PARM_MAX_PACKET_LENGTH = 1,
        RPC_C_PARM_BUFFER_LENGTH = 2,
        RPC_IF_AUTOLISTEN = 0x0001,
        RPC_IF_OLE = 0x0002,
        RPC_NCA_FLAGS_DEFAULT = 0x00000000,
        RPC_NCA_FLAGS_IDEMPOTENT = 0x00000001,
        RPC_NCA_FLAGS_BROADCAST = 0x00000002,
        RPC_NCA_FLAGS_MAYBE = 0x00000004,
        RPC_BUFFER_COMPLETE = 0x00001000,
        RPC_BUFFER_PARTIAL = 0x00002000,
        RPC_BUFFER_EXTRA = 0x00004000,
        RPCFLG_NON_NDR = 0x80000000,
        RPCFLG_ASYNCHRONOUS = 0x40000000,
        RPCFLG_INPUT_SYNCHRONOUS = 0x20000000,
        RPCFLG_LOCAL_CALL = 0x10000000,
        RPC_FLAGS_VALID_BIT = 0x8000;
    // RPC_FLAGS_VALID_BIT = 0x00008000;
    int RPC_INTERFACE_HAS_PIPES = 0x0001,
        RPC_C_NS_SYNTAX_DEFAULT = 0,
        RPC_C_NS_SYNTAX_DCE = 3,
        RPC_C_PROFILE_DEFAULT_ELT = 0,
        RPC_C_PROFILE_ALL_ELT = 1,
        RPC_C_PROFILE_MATCH_BY_IF = 2,
        RPC_C_PROFILE_MATCH_BY_MBR = 3,
        RPC_C_PROFILE_MATCH_BY_BOTH = 4,
        RPC_C_NS_DEFAULT_EXP_AGE = -1,
        RTS_CONTROL_DISABLE = 0x00,
        RTS_CONTROL_ENABLE = 0x01,
        RTS_CONTROL_HANDSHAKE = 0x02,
        RTS_CONTROL_TOGGLE = 0x03,
        REALTIME_PRIORITY_CLASS = 0x00000100,
        RIP_EVENT = 9,
        RESETDEV = 7,
        RIGHT_ALT_PRESSED = 0x0001,
        RIGHT_CTRL_PRESSED = 0x0004,
        RIGHTMOST_BUTTON_PRESSED = 0x0002,
        RPC_S_INVALID_STRING_BINDING = 1700,
        RPC_S_WRONG_KIND_OF_BINDING = 1701,
        RPC_S_INVALID_BINDING = 1702,
        RPC_S_PROTSEQ_NOT_SUPPORTED = 1703,
        RPC_S_INVALID_RPC_PROTSEQ = 1704,
        RPC_S_INVALID_STRING_UUID = 1705,
        RPC_S_INVALID_ENDPOINT_FORMAT = 1706,
        RPC_S_INVALID_NET_ADDR = 1707,
        RPC_S_NO_ENDPOINT_FOUND = 1708,
        RPC_S_INVALID_TIMEOUT = 1709,
        RPC_S_OBJECT_NOT_FOUND = 1710,
        RPC_S_ALREADY_REGISTERED = 1711,
        RPC_S_TYPE_ALREADY_REGISTERED = 1712,
        RPC_S_ALREADY_LISTENING = 1713,
        RPC_S_NO_PROTSEQS_REGISTERED = 1714,
        RPC_S_NOT_LISTENING = 1715,
        RPC_S_UNKNOWN_MGR_TYPE = 1716,
        RPC_S_UNKNOWN_IF = 1717,
        RPC_S_NO_BINDINGS = 1718,
        RPC_S_NO_PROTSEQS = 1719,
        RPC_S_CANT_CREATE_ENDPOINT = 1720,
        RPC_S_OUT_OF_RESOURCES = 1721,
        RPC_S_SERVER_UNAVAILABLE = 1722,
        RPC_S_SERVER_TOO_BUSY = 1723,
        RPC_S_INVALID_NETWORK_OPTIONS = 1724,
        RPC_S_NO_CALL_ACTIVE = 1725,
        RPC_S_CALL_FAILED = 1726,
        RPC_S_CALL_FAILED_DNE = 1727,
        RPC_S_PROTOCOL_ERROR = 1728,
        RPC_S_UNSUPPORTED_TRANS_SYN = 1730,
        RPC_S_UNSUPPORTED_TYPE = 1732,
        RPC_S_INVALID_TAG = 1733,
        RPC_S_INVALID_BOUND = 1734,
        RPC_S_NO_ENTRY_NAME = 1735,
        RPC_S_INVALID_NAME_SYNTAX = 1736,
        RPC_S_UNSUPPORTED_NAME_SYNTAX = 1737,
        RPC_S_UUID_NO_ADDRESS = 1739,
        RPC_S_DUPLICATE_ENDPOINT = 1740,
        RPC_S_UNKNOWN_AUTHN_TYPE = 1741,
        RPC_S_MAX_CALLS_TOO_SMALL = 1742,
        RPC_S_STRING_TOO_LONG = 1743,
        RPC_S_PROTSEQ_NOT_FOUND = 1744,
        RPC_S_PROCNUM_OUT_OF_RANGE = 1745,
        RPC_S_BINDING_HAS_NO_AUTH = 1746,
        RPC_S_UNKNOWN_AUTHN_SERVICE = 1747,
        RPC_S_UNKNOWN_AUTHN_LEVEL = 1748,
        RPC_S_INVALID_AUTH_IDENTITY = 1749,
        RPC_S_UNKNOWN_AUTHZ_SERVICE = 1750,
        RPC_S_NOTHING_TO_EXPORT = 1754,
        RPC_S_INCOMPLETE_NAME = 1755,
        RPC_S_INVALID_VERS_OPTION = 1756,
        RPC_S_NO_MORE_MEMBERS = 1757,
        RPC_S_NOT_ALL_OBJS_UNEXPORTED = 1758,
        RPC_S_INTERFACE_NOT_FOUND = 1759,
        RPC_S_ENTRY_ALREADY_EXISTS = 1760,
        RPC_S_ENTRY_NOT_FOUND = 1761,
        RPC_S_NAME_SERVICE_UNAVAILABLE = 1762,
        RPC_S_INVALID_NAF_ID = 1763,
        RPC_S_CANNOT_SUPPORT = 1764,
        RPC_S_NO_CONTEXT_AVAILABLE = 1765,
        RPC_S_INTERNAL_ERROR = 1766,
        RPC_S_ZERO_DIVIDE = 1767,
        RPC_S_ADDRESS_ERROR = 1768,
        RPC_S_FP_DIV_ZERO = 1769,
        RPC_S_FP_UNDERFLOW = 1770,
        RPC_S_FP_OVERFLOW = 1771,
        RPC_X_NO_MORE_ENTRIES = 1772,
        RPC_X_SS_CHAR_TRANS_OPEN_FAIL = 1773,
        RPC_X_SS_CHAR_TRANS_SHORT_FILE = 1774,
        RPC_X_SS_IN_NULL_CONTEXT = 1775,
        RPC_X_SS_CONTEXT_DAMAGED = 1777,
        RPC_X_SS_HANDLES_MISMATCH = 1778,
        RPC_X_SS_CANNOT_GET_CALL_HANDLE = 1779,
        RPC_X_NULL_REF_POINTER = 1780,
        RPC_X_ENUM_VALUE_OUT_OF_RANGE = 1781,
        RPC_X_BYTE_COUNT_TOO_SMALL = 1782,
        RPC_X_BAD_STUB_DATA = 1783,
        RPC_S_CALL_IN_PROGRESS = 1791,
        RPC_S_NO_MORE_BINDINGS = 1806,
        RPC_S_NO_INTERFACES = 1817,
        RPC_S_CALL_CANCELLED = 1818,
        RPC_S_BINDING_INCOMPLETE = 1819,
        RPC_S_COMM_FAILURE = 1820,
        RPC_S_UNSUPPORTED_AUTHN_LEVEL = 1821,
        RPC_S_NO_PRINC_NAME = 1822,
        RPC_S_NOT_RPC_ERROR = 1823,
        RPC_S_UUID_LOCAL_ONLY = 1824,
        RPC_S_SEC_PKG_ERROR = 1825,
        RPC_S_NOT_CANCELLED = 1826,
        RPC_X_INVALID_ES_ACTION = 1827,
        RPC_X_WRONG_ES_VERSION = 1828,
        RPC_X_WRONG_STUB_VERSION = 1829,
        RPC_X_INVALID_PIPE_OBJECT = 1830,
        RPC_X_INVALID_PIPE_OPERATION = 1831,
        RPC_X_WRONG_PIPE_VERSION = 1832,
        RPC_S_GROUP_MEMBER_NOT_FOUND = 1898,
        RPC_S_INVALID_OBJECT = 1900,
        RPC_S_SEND_INCOMPLETE = 1913,
        REGDB_E_FIRST = 0x80040150,
        REGDB_E_LAST = 0x8004015F,
        REGDB_S_FIRST = 0x00040150,
        REGDB_S_LAST = 0x0004015F,
        REGDB_E_READREGDB = 0x80040150,
        REGDB_E_WRITEREGDB = 0x80040151,
        REGDB_E_KEYMISSING = 0x80040152,
        REGDB_E_INVALIDVALUE = 0x80040153,
        REGDB_E_CLASSNOTREG = 0x80040154,
        REGDB_E_IIDNOTREG = 0x80040155,
        RPC_E_CALL_REJECTED = 0x80010001,
        RPC_E_CALL_CANCELED = 0x80010002,
        RPC_E_CANTPOST_INSENDCALL = 0x80010003,
        RPC_E_CANTCALLOUT_INASYNCCALL = 0x80010004,
        RPC_E_CONNECTION_TERMINATED = 0x80010006,
        RPC_E_SERVER_DIED = 0x80010007,
        RPC_E_CLIENT_DIED = 0x80010008,
        RPC_E_INVALID_DATAPACKET = 0x80010009,
        RPC_E_CANTTRANSMIT_CALL = 0x8001000A,
        RPC_E_CLIENT_CANTMARSHAL_DATA = 0x8001000B,
        RPC_E_CLIENT_CANTUNMARSHAL_DATA = 0x8001000C,
        RPC_E_SERVER_CANTMARSHAL_DATA = 0x8001000D,
        RPC_E_SERVER_CANTUNMARSHAL_DATA = 0x8001000E,
        RPC_E_INVALID_DATA = 0x8001000F,
        RPC_E_INVALID_PARAMETER = 0x80010010,
        RPC_E_CANTCALLOUT_AGAIN = 0x80010011,
        RPC_E_SERVER_DIED_DNE = 0x80010012,
        RPC_E_SYS_CALL_FAILED = 0x80010100,
        RPC_E_OUT_OF_RESOURCES = 0x80010101,
        RPC_E_ATTEMPTED_MULTITHREAD = 0x80010102,
        RPC_E_NOT_REGISTERED = 0x80010103,
        RPC_E_FAULT = 0x80010104,
        RPC_E_SERVERFAULT = 0x80010105,
        RPC_E_CHANGED_MODE = 0x80010106,
        RPC_E_INVALIDMETHOD = 0x80010107,
        RPC_E_DISCONNECTED = 0x80010108,
        RPC_E_RETRY = 0x80010109,
        RPC_E_SERVERCALL_RETRYLATER = 0x8001010A,
        RPC_E_SERVERCALL_REJECTED = 0x8001010B,
        RPC_E_INVALID_CALLDATA = 0x8001010C,
        RPC_E_CANTCALLOUT_ININPUTSYNCCALL = 0x8001010D,
        RPC_E_WRONG_THREAD = 0x8001010E,
        RPC_E_THREAD_NOT_INIT = 0x8001010F,
        RPC_E_VERSION_MISMATCH = 0x80010110,
        RPC_E_INVALID_HEADER = 0x80010111,
        RPC_E_INVALID_EXTENSION = 0x80010112,
        RPC_E_INVALID_IPID = 0x80010113,
        RPC_E_INVALID_OBJECT = 0x80010114,
        RPC_S_CALLPENDING = 0x80010115,
        RPC_S_WAITONTIMER = 0x80010116,
        RPC_E_CALL_COMPLETE = 0x80010117,
        RPC_E_UNSECURE_CALL = 0x80010118,
        RPC_E_TOO_LATE = 0x80010119,
        RPC_E_NO_GOOD_SECURITY_PACKAGES = 0x8001011A,
        RPC_E_ACCESS_DENIED = 0x8001011B,
        RPC_E_REMOTE_DISABLED = 0x8001011C,
        RPC_E_INVALID_OBJREF = 0x8001011D,
        RPC_E_UNEXPECTED = 0x8001FFFF,
        R2_BLACK = 1,
        R2_NOTMERGEPEN = 2,
        R2_MASKNOTPEN = 3,
        R2_NOTCOPYPEN = 4,
        R2_MASKPENNOT = 5,
        R2_NOT = 6,
        R2_XORPEN = 7,
        R2_NOTMASKPEN = 8,
        R2_MASKPEN = 9,
        R2_NOTXORPEN = 10,
        R2_NOP = 11,
        R2_MERGENOTPEN = 12,
        R2_COPYPEN = 13,
        R2_MERGEPENNOT = 14,
        R2_MERGEPEN = 15,
        R2_WHITE = 16,
        R2_LAST = 16,
        RGN_ERROR = 0,
        RGN_AND = 1,
        RGN_OR = 2,
        RGN_XOR = 3,
        RGN_DIFF = 4,
        RGN_COPY = 5,
        RGN_MIN = 1,
        RGN_MAX = 5,
        RESTORE_CTM = 4100,
        RUSSIAN_CHARSET = 204,
        RASTER_FONTTYPE = 0x0001,
        RELATIVE = 2,
        RASTERCAPS = 38,
        RC_BITBLT = 1,
        RC_BANDING = 2,
        RC_SCALING = 4,
        RC_BITMAP64 = 8,
        RC_GDI20_OUTPUT = 0x0010,
        RC_GDI20_STATE = 0x0020,
        RC_SAVEBITMAP = 0x0040,
        RC_DI_BITMAP = 0x0080,
        RC_PALETTE = 0x0100,
        RC_DIBTODEV = 0x0200,
        RC_BIGFONT = 0x0400,
        RC_STRETCHBLT = 0x0800,
        RC_FLOODFILL = 0x1000,
        RC_STRETCHDIB = 0x2000,
        RC_OP_DX_OUTPUT = 0x4000,
        RC_DEVBITS = 0x8000,
        RDH_RECTANGLES = 1,
        RESOURCE_CONNECTED = 0x00000001,
        RESOURCE_GLOBALNET = 0x00000002,
        RESOURCE_REMEMBERED = 0x00000003,
        RESOURCE_RECENT = 0x00000004,
        RESOURCE_CONTEXT = 0x00000005,
        RESOURCETYPE_ANY = 0x00000000,
        RESOURCETYPE_DISK = 0x00000001,
        RESOURCETYPE_PRINT = 0x00000002,
        RESOURCETYPE_RESERVED = 0x00000008,
        RESOURCETYPE_UNKNOWN = 0xFFFFFFFF,
        RESOURCEUSAGE_CONNECTABLE = 0x00000001,
        RESOURCEUSAGE_CONTAINER = 0x00000002,
        RESOURCEUSAGE_NOLOCALDEVICE = 0x00000004,
        RESOURCEUSAGE_SIBLING = 0x00000008,
        RESOURCEUSAGE_ATTACHED = 0x00000010,
        RESOURCEUSAGE_ALL = (0x00000001|0x00000002|0x00000010),
        RESOURCEUSAGE_RESERVED = 0x80000000,
        RESOURCEDISPLAYTYPE_GENERIC = 0x00000000,
        RESOURCEDISPLAYTYPE_DOMAIN = 0x00000001,
        RESOURCEDISPLAYTYPE_SERVER = 0x00000002,
        RESOURCEDISPLAYTYPE_SHARE = 0x00000003,
        RESOURCEDISPLAYTYPE_FILE = 0x00000004,
        RESOURCEDISPLAYTYPE_GROUP = 0x00000005,
        RESOURCEDISPLAYTYPE_NETWORK = 0x00000006,
        RESOURCEDISPLAYTYPE_ROOT = 0x00000007,
        RESOURCEDISPLAYTYPE_SHAREADMIN = 0x00000008,
        RESOURCEDISPLAYTYPE_DIRECTORY = 0x00000009,
        RESOURCEDISPLAYTYPE_TREE = 0x0000000A,
        RESOURCEDISPLAYTYPE_NDSCONTAINER = 0x0000000B,
        REMOTE_NAME_INFO_LEVEL = 0x00000002,
        RP_LOGON = 0x01,
        RP_INIFILE = 0x02,
        READ_CONTROL = (0x00020000),
        RTL_CRITSECT_TYPE = 0,
        RTL_RESOURCE_TYPE = 1,
        REG_OPTION_RESERVED = (0x00000000),
        REG_OPTION_NON_VOLATILE = (0x00000000),
        REG_OPTION_VOLATILE = (0x00000001),
        REG_OPTION_CREATE_LINK = (0x00000002),
        REG_OPTION_BACKUP_RESTORE = (0x00000004),
        REG_OPTION_OPEN_LINK = (0x00000008),
        REG_CREATED_NEW_KEY = (0x00000001),
        REG_OPENED_EXISTING_KEY = (0x00000002),
        REG_WHOLE_HIVE_VOLATILE = (0x00000001),
        REG_REFRESH_HIVE = (0x00000002),
        REG_NO_LAZY_FLUSH = (0x00000004),
        REG_NOTIFY_CHANGE_NAME = (0x00000001),
        REG_NOTIFY_CHANGE_ATTRIBUTES = (0x00000002),
        REG_NOTIFY_CHANGE_LAST_SET = (0x00000004),
        REG_NOTIFY_CHANGE_SECURITY = (0x00000008),
        REG_NONE = (0),
        REG_SZ = (1),
        REG_EXPAND_SZ = (2),
        REG_BINARY = (3),
        REG_DWORD = (4),
        REG_DWORD_LITTLE_ENDIAN = (4),
        REG_DWORD_BIG_ENDIAN = (5),
        REG_LINK = (6),
        REG_MULTI_SZ = (7),
        REG_RESOURCE_LIST = (8),
        REG_FULL_RESOURCE_DESCRIPTOR = (9),
        REG_RESOURCE_REQUIREMENTS_LIST = (10),
        RT_CURSOR = 1,
        RT_BITMAP = 2,
        RT_ICON = 3,
        RT_MENU = 4,
        RT_DIALOG = 5,
        RT_STRING = 6,
        RT_FONTDIR = 7,
        RT_FONT = 8,
        RT_ACCELERATOR = 9,
        RT_RCDATA = 10,
        RT_MESSAGETABLE = 11,
        RT_GROUP_CURSOR = 1+11,
        RT_GROUP_ICON = 3+11,
        RT_VERSION = 16,
        RT_DLGINCLUDE = 17,
        RT_PLUGPLAY = 19,
        RT_VXD = 20,
        RT_ANICURSOR = 21,
        RT_ANIICON = 22,
        RDW_INVALIDATE = 0x0001,
        RDW_INTERNALPAINT = 0x0002,
        RDW_ERASE = 0x0004,
        RDW_VALIDATE = 0x0008,
        RDW_NOINTERNALPAINT = 0x0010,
        RDW_NOERASE = 0x0020,
        RDW_NOCHILDREN = 0x0040,
        RDW_ALLCHILDREN = 0x0080,
        RDW_UPDATENOW = 0x0100,
        RDW_ERASENOW = 0x0200,
        RDW_FRAME = 0x0400,
        RDW_NOFRAME = 0x0800,
        RES_ICON = 1,
        RES_CURSOR = 2,
        ROTFLAGS_REGISTRATIONKEEPSALIVE = 0x1,
        ROTFLAGS_ALLOWANYCLIENT = 0x2,
        ROT_COMPARE_MAX = 2048,
        RBN_FIRST = (0-831),
        RBN_LAST = (0-859),
        RBNM_ID = 0x00000001,
        RBNM_STYLE = 0x00000002,
        RBNM_LPARAM = 0x00000004,
        RBIM_IMAGELIST = 0x00000001,
        RBS_TOOLTIPS = 0x00000100,
        RBS_VARHEIGHT = 0x00000200,
        RBS_BANDBORDERS = 0x00000400,
        RBS_FIXEDORDER = 0x00000800,
        RBS_REGISTERDROP = 0x1000,
        RBS_AUTOSIZE = 0x2000,
        RBS_VERTICALGRIPPER = 0x4000,
        RBS_DBLCLKTOGGLE = 0x8000,
        RBBS_BREAK = 0x00000001,
        RBBS_FIXEDSIZE = 0x00000002,
        RBBS_CHILDEDGE = 0x00000004,
        RBBS_HIDDEN = 0x00000008,
        RBBS_NOVERT = 0x00000010,
        RBBS_FIXEDBMP = 0x00000020,
        RBBS_VARIABLEHEIGHT = 0x00000040,
        RBBS_GRIPPERALWAYS = 0x00000080,
        RBBS_NOGRIPPER = 0x00000100,
        RBBIM_STYLE = 0x00000001,
        RBBIM_COLORS = 0x00000002,
        RBBIM_TEXT = 0x00000004,
        RBBIM_IMAGE = 0x00000008,
        RBBIM_CHILD = 0x00000010,
        RBBIM_CHILDSIZE = 0x00000020,
        RBBIM_SIZE = 0x00000040,
        RBBIM_BACKGROUND = 0x00000080,
        RBBIM_ID = 0x00000100,
        RBBIM_IDEALSIZE = 0x00000200,
        RBBIM_LPARAM = 0x00000400,
        RBBIM_HEADERSIZE = 0x00000800,
        RB_INSERTBANDA = (0x0400+1),
        RB_DELETEBAND = (0x0400+2),
        RB_GETBARINFO = (0x0400+3),
        RB_SETBARINFO = (0x0400+4),
        RB_GETBANDINFO_OLD = (0x0400+5),
        RB_SETBANDINFOA = (0x0400+6),
        RB_SETPARENT = (0x0400+7),
        RB_HITTEST = (0x0400+8),
        RB_GETRECT = (0x0400+9),
        RB_INSERTBANDW = (0x0400+10),
        RB_SETBANDINFOW = (0x0400+11),
        RB_GETBANDCOUNT = (0x0400+12),
        RB_GETROWCOUNT = (0x0400+13),
        RB_GETROWHEIGHT = (0x0400+14),
        RB_IDTOINDEX = (0x0400+16),
        RB_GETTOOLTIPS = (0x0400+17),
        RB_SETTOOLTIPS = (0x0400+18),
        RB_SETBKCOLOR = (0x0400+19),
        RB_GETBKCOLOR = (0x0400+20),
        RB_SETTEXTCOLOR = (0x0400+21),
        RB_GETTEXTCOLOR = (0x0400+22),
        RB_SIZETORECT = (0x0400+23),
        RB_BEGINDRAG = (0x0400+24),
        RB_ENDDRAG = (0x0400+25),
        RB_DRAGMOVE = (0x0400+26),
        RB_GETBARHEIGHT = (0x0400+27),
        RB_GETBANDINFOW = (0x0400+28),
        RB_GETBANDINFOA = (0x0400+29),
        RB_MINIMIZEBAND = (0x0400+30),
        RB_MAXIMIZEBAND = (0x0400+31),
        RB_GETBANDBORDERS = (0x0400+34),
        RB_SHOWBAND = (0x0400+35),
        RB_SETPALETTE = (0x0400+37),
        RB_GETPALETTE = (0x0400+38),
        RB_MOVEBAND = (0x0400+39),
        RB_SETCOLORSCHEME = win.CCM_SETCOLORSCHEME,
        RB_GETCOLORSCHEME = win.CCM_GETCOLORSCHEME,
        RB_GETDROPTARGET = win.CCM_GETDROPTARGET,
        RB_SETUNICODEFORMAT = win.CCM_SETUNICODEFORMAT,
        RB_GETUNICODEFORMAT = win.CCM_GETUNICODEFORMAT,
        RBN_HEIGHTCHANGE = ((0-831)-0),
        RBN_GETOBJECT = ((0-831)-1),
        RBN_LAYOUTCHANGED = ((0-831)-2),
        RBN_AUTOSIZE = ((0-831)-3),
        RBN_BEGINDRAG = ((0-831)-4),
        RBN_ENDDRAG = ((0-831)-5),
        RBN_DELETINGBAND = ((0-831)-6),
        RBN_DELETEDBAND = ((0-831)-7),
        RBN_CHILDSIZE = ((0-831)-8),
        RBHT_NOWHERE = 0x0001,
        RBHT_CAPTION = 0x0002,
        RBHT_CLIENT = 0x0003,
        RBHT_GRABBER = 0x0004,
        RPC_S_OK = 0,
        RPC_S_INVALID_ARG = 87,
        RPC_S_OUT_OF_MEMORY = 14,
        RPC_S_OUT_OF_THREADS = 164,
        RPC_S_INVALID_LEVEL = 87,
        RPC_S_BUFFER_TOO_SMALL = 122,
        RPC_S_INVALID_SECURITY_DESC = 1338,
        RPC_S_ACCESS_DENIED = 5,
        RPC_S_SERVER_OUT_OF_MEMORY = 1130,
        RPC_X_NO_MEMORY = 14,
        RPC_X_INVALID_BOUND = 1734,
        RPC_X_INVALID_TAG = 1733,
        RPC_X_ENUM_VALUE_TOO_LARGE = 1781,
        RPC_X_SS_CONTEXT_MISMATCH = 6,
        RPC_X_INVALID_BUFFER = 1784;

    int REGCLS_SINGLEUSE        = 0,    // class object only generates one instance
        REGCLS_MULTIPLEUSE      = 1,    // same class object genereates multiple inst.
                                        // and local automatically goes into inproc tbl.
        REGCLS_MULTI_SEPARATE   = 2,    // multiple use, but separate control over each
                                        // context.
        REGCLS_SUSPENDED        = 4,    // register is as suspended, will be activated
                                        // when app calls CoResumeClassObjects
        REGCLS_SURROGATE        = 8;    // must be used when a surrogate process
                                        // is registering a class object that will be
                                        // loaded in the surrogate

    int RPC_C_AUTHN_LEVEL_DEFAULT       = 0,
        RPC_C_AUTHN_LEVEL_NONE          = 1,
        RPC_C_AUTHN_LEVEL_CONNECT       = 2,
        RPC_C_AUTHN_LEVEL_CALL          = 3,
        RPC_C_AUTHN_LEVEL_PKT           = 4,
        RPC_C_AUTHN_LEVEL_PKT_INTEGRITY = 5,
        RPC_C_AUTHN_LEVEL_PKT_PRIVACY   = 6;

    int RPC_C_IMP_LEVEL_DEFAULT     = 0,            // O/S >= NT5
        RPC_C_IMP_LEVEL_ANONYMOUS   = 1,            // not supported as of NT5
        RPC_C_IMP_LEVEL_IDENTIFY    = 2,
        RPC_C_IMP_LEVEL_IMPERSONATE = 3,
        RPC_C_IMP_LEVEL_DELEGATE    = 4;            // O/S >= NT5

    int RPC_C_AUTHN_NONE            = 0,
        RPC_C_AUTHN_DCE_PRIVATE     = 1,
        RPC_C_AUTHN_DCE_PUBLIC      = 2,
        RPC_C_AUTHN_DEC_PUBLIC      = 4,
        RPC_C_AUTHN_GSS_NEGOTIATE   = 9,
        RPC_C_AUTHN_WINNT           = 10,
        RPC_C_AUTHN_GSS_SCHANNEL    = 14,           // O/S >= NT5
        RPC_C_AUTHN_DPA             = 16,
        RPC_C_AUTHN_MSN             = 17,
        RPC_C_AUTHN_GSS_KERBEROS    = 18,           // O/S >= NT5
        RPC_C_AUTHN_MQ              = 100,
        RPC_C_AUTHN_DEFAULT         = 0xffffffff;   // O/S >= NT5

    int RPC_C_AUTHZ_NONE            = 0,
        RPC_C_AUTHZ_NAME            = 1,
        RPC_C_AUTHZ_DCE             = 2,
        RPC_C_AUTHZ_DEFAULT         = 0xffffffff;   // O/S >= NT5
}
