// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winu {
    int UI_CAP_2700 = 0x00000001,
        UI_CAP_ROT90 = 0x00000002,
        UI_CAP_ROTANY = 0x00000004,
        UNIQUE_NAME = 0x00,
        UPDFCACHE_NODATACACHE = (0x1),
        UPDFCACHE_ONSAVECACHE = (0x2),
        UPDFCACHE_ONSTOPCACHE = (0x4),
        UPDFCACHE_NORMALCACHE = (0x8),
        UPDFCACHE_IFBLANK = (0x10),
        UPDFCACHE_ONLYIFBLANK = (0x80000000),
        UPDFCACHE_IFBLANKORONSAVECACHE = ((0x10)|(0x2)),
        UPDFCACHE_ALL = (~(0x80000000)),
        UPDFCACHE_ALLBUTNODATACACHE = ((~(0x80000000))&~(0x1)),
        USER_MARSHAL_FC_BYTE = 1,
        USER_MARSHAL_FC_CHAR = 2,
        USER_MARSHAL_FC_SMALL = 3,
        USER_MARSHAL_FC_USMALL = 4,
        USER_MARSHAL_FC_WCHAR = 5,
        USER_MARSHAL_FC_SHORT = 6,
        USER_MARSHAL_FC_USHORT = 7,
        USER_MARSHAL_FC_LONG = 8,
        USER_MARSHAL_FC_ULONG = 9,
        USER_MARSHAL_FC_FLOAT = 10,
        USER_MARSHAL_FC_HYPER = 11,
        USER_MARSHAL_FC_DOUBLE = 12,
        UNLOAD_DLL_DEBUG_EVENT = 7,
        UNIVERSAL_NAME_INFO_LEVEL = 0x00000001,
        UOI_FLAGS = 1,
        UOI_NAME = 2,
        UOI_TYPE = 3,
        UOI_USER_SID = 4,
        UDN_FIRST = (0-721),
        UDN_LAST = (0-740),
        UD_MAXVAL = 0x7fff,
        UD_MINVAL = (-0x7fff),
        UDS_WRAP = 0x0001,
        UDS_SETBUDDYINT = 0x0002,
        UDS_ALIGNRIGHT = 0x0004,
        UDS_ALIGNLEFT = 0x0008,
        UDS_AUTOBUDDY = 0x0010,
        UDS_ARROWKEYS = 0x0020,
        UDS_HORZ = 0x0040,
        UDS_NOTHOUSANDS = 0x0080,
        UDS_HOTTRACK = 0x0100,
        UDM_SETRANGE = (0x0400+101),
        UDM_GETRANGE = (0x0400+102),
        UDM_SETPOS = (0x0400+103),
        UDM_GETPOS = (0x0400+104),
        UDM_SETBUDDY = (0x0400+105),
        UDM_GETBUDDY = (0x0400+106),
        UDM_SETACCEL = (0x0400+107),
        UDM_GETACCEL = (0x0400+108),
        UDM_SETBASE = (0x0400+109),
        UDM_GETBASE = (0x0400+110),
        UDM_SETRANGE32 = (0x0400+111),
        UDM_GETRANGE32 = (0x0400+112),
        UDN_DELTAPOS = ((0-721)-1);

    /* RichEdit: UndoName info */
    int UID_UNKNOWN     = 0,
        UID_TYPING      = 1,
        UID_DELETE      = 2,
        UID_DRAGDROP    = 3,
        UID_CUT         = 4,
        UID_PASTE       = 5;
}
